<?php
/*  Display External < Sumple > 拡張子:HTMLのサムネイル出力
  外部関数は,XML設定<ViewExtend> <{kind} Func={関数名}>拡張子でCallされる。
  ファイル検出で,引数は下記のようにCallされる。
  サムネイル1個分の内容を標準出力する。
	DispThumbnail_Extend($idimg,$kind,$tbno,$Img_file,$file,$file_js,$tbwidth,$urlstr,$urlstr_js,$retwidth,$rethigth) : Display Thumbnail Image
	 $idimg    : i  : Tagのidに設定する場合に使用
	 $kind     : i  : Data Kind (拡張子種別:Image)
	 $tbno     : i  : DispFileAlbum TableNo Art数(XMLConfif)
	 $Img_file : i  : File Path
	 $file     : i  : File Name
	 $file_js  : i  : jsで使用するためのFile名(',"→\',\")
	 $tbwidth  : i  : Display Width
	 $urlstr   : i  : URL File Path (URL Encode)
	 $urlstr_js: i  : URL(JS) File Path (URL Encode JS Escape)
	 $retwidth : io : Image Data width
	 $rethigth : io : Image Data higth
*/
function DispThumbnail_HTML($idimg,$kind,$tbno,$Img_file,$file,$file_js,$tbwidth,$urlstr,$urlstr_js,$retwidth,$rethigth) {
// 内部組み込み関数(ArgThumbnail_Detail)を使用しなくても良いがテストを兼ねている。(XML設定は拡張View設定と同じルールとなる)

	$xml_view=array("ViewThumbnail_".$kind =>"{$urlstr_js}","View_".$kind =>"{$urlstr_js}");
	get_config("ViewExtend",$xml_view);								// <ViewExtend> <ViewThumbnail_{kind}>:Thumbnail Viewer /<View_{$kind}:Thumbnail On Click Viewer Kick shell
	$change=array('{$ViewThumbnail}'=>$xml_view["ViewThumbnail_".$kind],'{$View}'=>$xml_view["View_".$kind]);
// Select条件を設定
	$selifinit='$setno_now=-1;$kind="'.$kind.'";';							// セットしているNo($selif使用の初期値) $kind:をセレクトのため値を受け渡す
	$selif[]='if (($ext=array_search("Extend",$at_itm,true)) !== false) {	// 有効判定 : 属性=Extendがあるとき
				if ($attri["Val"][$i][$ext] !== $kind) { return false; }	//  $Kind(対象種別)が違えば対象外
				}
				return true;';
	$selif[]='if (($idx=array_search("No",$at_itm,true)) === false) { $setno=0;return true; } else {	// 属性=Noがないときは,個数定義としないのでtrue
				 $setno = $attri["Val"][$i][$idx]; }				// 表示個数から有効判定 : 属性=Noがあるとき
				 if ($setno_now > $setno) { return false; }			// 現在セットしている値より小さいと無視:側近を採用
				 if ($setno > $tbno) { return false; }				// 表示個数より大きい設定は対象外
				 $setno_now=$setno; return true;';			// セットした$setno(表示個数)をKeep
// Filedの継続 : XML{Filed}の設定 & "tbno":$selifにあるため
	$fldary = compact("idimg","Img_file","file","file_js","tbwidth","urlstr","urlstr_js","retwidth","rethigth","tbno");
	$sel=array("Thumbnail"=>"1");	// XML:セレクト対象Tag , 1:指定文字列を含む前方一致
	$ret=ArgXML2HTMLStr("ViewExternal_HTML",$sel,$fldary,$change,$selifinit,$selif);	// Thumbnail設定:"ViewExtend"を使用
	if ($ret !==-1) {	// Thumbnailを作成して出力する
echo <<<EOM
{$ret}
EOM;
		}
/*
出力イメージ
<div style="width:{$tbwidthdef}px;height:{$tbheightdef}px;cursor:pointer;background-color:#c0c0c0;margin:{$marginudef}px 0px 0px 0px;">
<iframe src="{$ViewThumbnail}" scrolling="no" frameborder="1" 
style="width:100%;height:100%;margin:-{$wdef}px 0px 0px -{$hdef}px; 
">iframe対応ブラウザで見てください。</iframe>
</div>
*/
	}

/*-------------------------------------------------------------------------------------------------------
	Viewer自身を作成する場合は以下に関数として作成 Initの設定で起動される
	XML設定:<ViewExtend><HTML Init="{関数名}" Func="DispThumbnail_HTML" require="mpdartlist_external.php">
---------------------------------------------------------------------------------------------------------*/
/*
	DispView_Extend(): Display View Extend Box : 内部拡張Viewer
*/
function DispView_HTML() {
// Viewerの初期値 XML設定されない場合の値
	$func="";				// XML設定に初期化関数指定があるとき
// XML設定からHTMLを展開
	$fldary = compact("width","height","minWidth","minHeight","frmwidth_def","frmheight_def","frmwidth","frmheight","func");
	$sel=array("Viewer"=>"1");	// XML:セレクト対象Tag , 1:指定文字列を含む前方一致
	$ret_frame=ArgXML2HTMLStr("ViewExternal_HTML",$sel,$fldary,"");
//if ($ret_frame == -1) { return; }
	if(is_array($fldary)) { extract($fldary,EXTR_OVERWRITE); }	// EXTR_OVERWRITE: 既に同名の変数が存在する場合上書き
	if (($func !== "")&&(function_exists($func))) { 								// <{Kind} Func="{Function}">				// 外部関数の呼び出し
		eval($func.'($fldary);');
		if (error_get_last()) {
			ArgErrorEdit("ViewExternal_HTML","eval()");
			}
		}
	}
/* ---------- HTMLViwerを転用する ------------------------------------------------------------------------ */

?>
