<?php
/***************************************************************************************
	mpdhost_multi.php : Mpd Multi collection
	Mpd Multi Command Exec mpdweb Function , Put ,Host mpdmyset.xml<Mpd_net> MPD Setting
	Function
	 func=MultiMpd  : ArgFunc_MultiMpd

	Linkage Source
	 mpdweb.php     : mpdweb.php & mpdLibrary
	 mpdhost.lib.php: mpdmyset.xml <Mpd_net>のMPD hootを使用

	※MultiMpd Command : mpdweb.php / mpdweb.lib_mpd.php mpdweb.lib_mpdshm.phpを同時に
	  同じコマンドを発行する。
	  使用できる条件は mpdmyset.xml<Mpd_net>を使用，mpdのMusicDataが同じ。
	  異なると同じCommand発行でErrorが発生することが考えられる。
	  Hostはmpdmyset.xml<Mpd_net>を使用する。AJAXを使用しないと表示Pageが移動ためPOSTを使用。
	  mpdhostシリーズのSessionを活用しない。mpdweb.phpをLibrary化して使用するため,他の
	  Libraryに組み込むとPOSTの競合/SESSIONで仮想にHOSTを変更しているなどの問題が発生する。
	  このLibraryを使用するための条件が狭いなどの利用で独自のLibraryにする。
	  全体に対してのアクションができることより,別ソースでの利用は広がると考えられる。
****************************************************************************************/
$VERSION_Multi=basename(__FILE__)." Ver:0.3 (10.06.2025)";
ob_start();
$_GET['p']="nop";										// mpdweb.php: "nop" mode Vertionを使用
$require_mpdweb=dirname(__FILE__).'/mpdweb.php';		// Mpd XML Basic Library mpdweb.lib.php
require_once($require_mpdweb);							// Mpd : Original Library mpdwen.lib.php
mpd_close();											// 設定でOpenNetをClose
ob_end_clean();

$require_host=dirname(__FILE__).'/mpdhost.lib.php';		// Mpd XML Basic Library mpdweb.lib.php
require_once($require_host);							// Mpd : Original Library mpdwen.lib.php

if ((isset($_POST['func']))&&($_POST['func']=="MultiMpd")) {
	if (!isset($_POST['cmd'])) {
		print "Func:MultiMpd Error Not cmd\n";
		}
	$str=$_POST['cmd'];
	$result=ArgFunc_MultiMpd($str);
	//print_r($result);					// $resultの活用方法は現時点ではない
	}

// -------------- mpd Update : Argument -----------------------------------------------
// POST p=update&amp;f=update&amp;m1=path:%B64:RequestDir%&amp;art=off&amp;exists=on'
// mpdweb PostSendUpdate("%RequestDir%","update","off","","","on");
//    ↓
//mpdweb Function
//    PostSendUpdate($ARG["m"],$ARG["f"],$art,$disp,$url,$exists);
//$ARG["m"]:path
//$ARG["f"]:update/status

/* -------------------------------------------------------------------------------------
	ArgFunc_MultiMpd($str) : multiple MPD Library Command
	 $cmd    : i  : Excution Shell Command
	 @return : o  : MPD Command Rresult Array $result[{Mpd_netTAG}]
	※ mpdmyset.xml <Mpd_net>のMPD hoot をマルチCommand
	   mpdweb.php / mpdweb.lib_mpd.php mpdweb.lib_mpdshm.php
	Exp) $str
	$str='PostSendUpdate('NAS/music/Music2/aiko','update','off','','','on');'; 
	     evalで実行するため リテラルは "'"→"\'" 変換してあること
-------------------------------------------------------------------------------------- */
function ArgFunc_MultiMpd($str) {
	global $Net,$XML_MYSETTING,$XML_MPDSRV;
	$result=array();
	GetMyEnv("Mpd_net");
	print "Func:MultiMpd Start\n";
	foreach($XML_MPDSRV as $key=> $val) {						// Session Clearが設定されていないときは追加
		if ((isset($val['host']))&&(isset($val['port']))) {		// <host><port>指定時,mpdweb.php切替設定
			$Net = new Net_Common;
			$Net->c_timeout =5;
			$Net->p_connect['host'] = $val['host'];
			$Net->p_connect['port'] = $val['port'];
			$Net->p_connect['password'] = null;
			if((isset($val['pass']))&&(rtrim($val['pass']) !=="")) {
				 $Net->p_connect['password'] = $val['pass'];
				 }
			if (!$Net->connect()) {
				 msglog($Net->p_error."\n");
				 }
			else {
				 $result[$key]=eval($str);
//				 $fp = fopen("log/testlog.txt", 'a');fwrite($fp,"eval End\n");fclose($fp);
				 }
			mpd_close();
			}
		}
	print "Func:MultiMpd End\n";
	return($result);
	}



//----- Source End --------------------------------------------------------------
?>
