<?php
/***************************************************************************************
	mpdilist.php : List Search Helper :  require_once("mpdilist.php");で使用する
****************************************************************************************
利用元で設定する項目
必須項目
$iListTBL="{Table id}"               : 対象となるTable
$iListARG="{"id={id}"}"|{CellsNo}    : 対象をidで指定(id=で指定) | 対象をtd Cell位置をNoで指定(
$iListSes= "{SessionName}"           : Sesseionを使用時SessionNameを指定 ※現在表示Pageのみ保存

Position設定
 $iListDefHigh={pos}                 : Scroll Def High Positon時Haeder高さの位置補正 default:50
 $iListDefLeft={pos}                 : Scroll Def Left Positon時の位置補正 default:0
条件設定
 $iListCapital="on"|"off"            : on:大文字/小文字区別しない(対象Tableが大/小文字区別なくSortされているときに効果がある) default:off
 $iListListExc="{定冠詞},{定冠詞}.." : Listの定冠詞などを除外","で複数指定可(定冠詞でSortされているときに効果がある) ex:"The ,..." default:""
 $iListTopChar="{正規表現}"          : Listの文字列を正規表現で編集 例) $iListTopChar='/^\[/'; 先頭"["を削除
 $iListMaskVal="{Value}"             : Tagなし時の表示文字(呼び出し元でTagがないときの表示文字列),未指定時"[no Tag]"
-----------------------------------------------------------------------------------------
デザイン設定
 $iListRows={no}             : 行数 default:5
 $iListCells={no}            : カラム数 default:5
 $iL2ndRows={no}             : 2nd Choice行数 default:2
 $iL2ndDispNo={no}           : 2nd Choice非表示数= default:3 (カラムが以下のとき表示しない)
 $iListPageSel={no}          : Page SelectBox数
 $iL2ndPageSel={no}          : 2nd ChoicePage SelectBox数

 $iListHeight={value}        : IndexButtonの高さ default:44  (計算の基準は50)  ※図形があるのでFunctionは固定
 $iListWidth ={value}        : IndexButtonの幅   default:46  (計算の基準は50)
 $iListGap={value}           : 外枠とボタンまでのギャップ default:6
 $iListFuncG={value}         : 外枠下部Function部余白(Button配置用) default:24;
 $iListFuncH={value}         : FunctionButton高さ
 $iListLR ="{css}"           : IndexList:Positon Left default:"left:168px"
 $iListPos="{css}"           : IndexList:Postion default:"bottom:70px"
 $iL2ndPosDef={value}        : iList2nd Postion の補正値 iList1次セレクトLows5個を基準に計算しているが高さ位置補正値(Px)
 $iL2ndFuncGFunction={value} : 外枠下部Function部余白(Button配置用) default:20;
 $iListPgSelDef={value}      : IndexList PageSelect Box Postion 調整 default:-170;
 $iL2ndPgSelDef={value}      : 2nd Choice IndexList PageSelect Box Postion 調整 default:90;
 $iListPgCharNo={value}      : IndexList PageSelect 表示語数(Word) default:4;

PageBoxの設定
 $iLPageWidth={value}        : PageBox Width
 $iLPageLeng={value}         : PageBox 1st Character Length(変更しない前提)        default:1
 $iLPage2ndLeng={value}      : PageBox 2nd Character文字数(1次選択は1文字固定前提) default:2
 $iLPageChrRate={value}      : PageBox 1行文字数を求めるRate (Width/文字数:全角考慮なし) default:180/12;

Index Box Button
 $iListBoxCss)="{css}"       : IndexList:IndexBox Buttonに追加するcss Ex:"z-index:1000"
IndexList Function
 $iListDown="{class}"        : IndexList DownButton Class(ボタンデザイン) default:"trapezDown" ボタン修飾idセレクタ Class : #iLDown ()
 $iListUp  ="{class}"        : IndexList UpButton Class(ボタンデザイン)   default:"trapezUp"   ボタン修飾idセレクタ Class : #iLUp ()
   List Up,Down用 内蔵Class図形
     trapezDown 台形(三角Down)
     trapezUp   台形(三角Up)
     trapezLeft 台形(三角Left)
     trapezRight 台形(三角Right)
 ※利用元でcss classを作成することができる。

-----------------------------------------------------------------------------------------
 リソース: sessionStorageブラウザを開いてる間のみ
  "iList/page/"{sesname}:表示DataをKeep
-----------------------------------------------------------------------------------------
I/F 呼び出し方法設定(呼び元で作成することができる) : 現在2パターンを設定している
 $iListIF={HTML}      : 呼び出し用ボタンHTML , $iListIF未セット内蔵のI/Fボタンを利用
                        外部から呼び出し用ボタンを作成する場合は"$iListIF"の項目名でHTMLを作成する。
 $iListIFMode=NULL|1|2: 未セット時, 1 1:Bottom右に表示を使用する 2:右Function上
 $iListIFDisp         : 内蔵のI/Fボタンを利用時css Style追加 "display:none;"指定時呼び元でOn方法を実装する
 $iListIFName         : 内蔵のI/Fボタンを利用時 NameValueを設定
 $iListIFCss          : 内蔵のI/Fボタンを利用時 NameValueのCSSを設定(文字の修飾のみ可能)
 ※ $iListIFName:"...."(ピリオドのみの文字列)の場合はイレギュラとしてのCSSを適用する
 作成の場合，id名の使用部分には名称を合わせること
  $iListIFid           : 呼び出し用ボタンFrame HTML;id : "idiListIF"
  $iListIFbutton       : 呼び出し用ボタンHTML;id       : "idiListButton"
-----------------------------------------------------------------------------------------
css デザイン Class : 呼出し後再設定(変更時上書き)
.iLOuterFrame   : IndexList:外枠
.iLTable        : IndexList:table
.iLButton       : IndexList:Index Button
.iLChar         : IndexList:Index Character
.iLPageFrame    : IndexList Page Frame
.LPage          : IndexList Page
#iLClose        : IndexList:Button Close
#iLDown         : IndexList:Button Down  : Buttonは,$GiLDownでデザインを設定
#iLUp           : IndexList:Button Up    : Buttonは,$GiLUpでデザイン

※参考 内蔵Button用図形
 halfCircleRight 半円(右)
 halfCircleLeft  半円(左)
 ovalLateral 楕円(縦)
 ovalSide    楕円(横)
****************************************************************************************/
global $GiLWidth,$GiLHeight,$GiLSpace,$GiLGap;								// Index Button
global $GiLinfBox,$GiLFuncH,$GiLDown,$GiLUp,$GinfBoxCan;					// Make Index Function Button
global $GiLPagef,$GiLPage,$GiL2ndPage,$GiL2ndPagef;							// Index List Common
global $GiLPgSel,$GiLPgSelNo,$GiLPgSelDef;									// Index List Page Select Box
global $GiL2ndPgSel,$GiL2ndPgSelNo,$GiL2ndPgSelDef,$GiLPgLf,$GiL2ndPgLf;	// Index List 2nd Page Select Box
$iLIST_VERSION="mpdilist 0.95 (31.08.2023)";
/* 外部から設定必須項目
	$iListTBL="idlisttbl";	: 対象となるTable
	$iListARG="id=idL";		: 対象をidで指定
	$iListARG="0";			: 対象をtd Cell位置で指定 */
if ((!isset($iListTBL))||($iListTBL=="")) { exit; }			// 対象となるTable
if ((!isset($iListARG))||($iListARG=="")) { exit; }			// 対象をtdidで指定 "id=idL" , 対象をtd Cell位置で指定 "0"
if (!isset($iListSes)) { $iListSes=""; }					// Sesseionを使用時SessionName
$iListSesBase="iList/";										// Sesseion BaseName

// Position設定
//if (!isset($iListLR))      { $iListLR="left:168px"; }			// IndexList:Left ※$iListWidth:50の基準値
if (!isset($iListLR))      { $iListLR="left:188px"; }		// IndexList:Left $iListWidth:46の基準値
//if (!isset($iListPos))   { $iListPos="top:500px"; }		// IndexList:Postion
if (!isset($iListPos))     { $iListPos="bottom:70px"; }		// IndexList:Postion
if (!isset($iListDefHigh)) { $iListDefHigh=50; }			// Scroll Def High Positon時Haeder高さの位置補正
if (!isset($iListDefLeft)) { $iListDefLeft=0; }				// Scroll Def Left Positon時の位置補正 
// 外部から設定可能項目
if (!isset($iListCapital)) { $iListCapital="off"; }			// off|on:大文字/小文字区別しない(対象Tableが大/小文字区別なくSortされているときに効果がある)
if (!isset($iListListExc)) { $iListListExc=""; }			// Listの定冠詞などを除外","で複数指定可(定冠詞でSortされているときに効果がある)
if (!isset($iListTopChar)) { $iListTopChar="''"; }			// Listの文字列を正規表現で編集 例) $iListTopChar='/^\[/'; 先頭"["を削除
if (!isset($iListMaskVal)) { $iListMaskVal="[no Tag]"; }	// ListのMask文字列 TagがないときListに表示するValue
// 外部からデザイン設定可能項目
if (!isset($iListRows))    { $iListRows=5; }				// $iListRows:行数 
if (!isset($iListCells))   { $iListCells=5; }				// $iListCells:カラム数
//if (!isset($iListHeight))  { $iListHeight=50; }				// IndexBotton高さ ※50が計算の基準
if (!isset($iListHeight))  { $iListHeight=44; }				// IndexBotton高さ
//if (!isset($iListWidth))   { $iListWidth=50; }				// IndexBotton幅 ※50が計算の基準
if (!isset($iListWidth))   { $iListWidth=46; }				// IndexBotton幅
if (!isset($iListGap))     { $iListGap=6; }					// 外枠とボタンまでのギャップ
if (!isset($iListFuncH))   { $iListFuncH=28; }				// 下部FunctionButton高さ
if (!isset($iListFuncG))   { $iListFuncG=24; }				// 外枠下部余白(Button配置用)
// Index Box Button
if (!isset($iListBoxCss))  { $iListBoxCss=""; }				// IndexList:IndexBox Buttonに追加するcss Ex:"z-index:1000"
if ($iListBoxCss !== "")   { $iListBoxCss=(trim($iListBoxCss,";")).";"; }
// IndexList Function
if (!isset($iListDown))    { $iListDown="trapezDown"; }		// IndexList DownButton Class(ボタンデザイン) ボタン修飾idセレクタ Class : #iLDown ()
if (!isset($iListUp))      { $iListUp  ="trapezUp"; }		// IndexList UpButton Class(ボタンデザイン)   ボタン修飾idセレクタ Class : #iLUp ()
//if (!isset($iListDown))    { $iListDown="trapezLeft"; }		// IndexList DownButton Class(ボタンデザイン) ボタン修飾idセレクタ Class : #iLDown ()
//if (!isset($iListUp))      { $iListUp  ="trapezRight"; }		// IndexList UpButton Class(ボタンデザイン)   ボタン修飾idセレクタ Class : #iLUp ()

// IndexButton 2ndBox作成
if (!isset($iL2ndRows))    { $iL2ndRows  = 2; }				// iList2ndRows:行数
if (!isset($iL2ndPosDef))    {$iL2ndPosDef  = 0; }			// iList2nd Postion の補正値 iList1次セレクトLows5個を基準に計算しているが高さ位置補正値(Px)
if (!isset($iL2ndDispNo))  { $iL2ndDispNo= 3; }				// iList2ndDispNo:非表示数(カラムが以下のとき表示しない)
if (!isset($iL2ndFuncG))   { $iL2ndFuncG=20; }				// IndexList 2nd 外枠下部余白(Button配置用)
// IndexList PageSelect Box作成
if (!isset($iListPageSel)) { $iListPageSel= 7; }			// IndexList PageSelect Box Select数
if (!isset($iL2ndPageSel)) { $iL2ndPageSel= 3; }			// IndexList 2nd PageSelect Box Select数
if (!isset($iListPgSelDef)) { $iListPgSelDef= -98; }		// IndexList PageSelect Box Postion 調整
if (!isset($iL2ndPgSelDef)) { $iL2ndPgSelDef= 49; }			// IndexList 2nd PageSelect Box Postion 調整
if (!isset($iListPgCharNo)) { $iListPgCharNo= 4; }			// IndexList 1ラインPageSelect 表示語数(Word)
// IndexList PageBox設定
if (!isset($iLPageWidth))   { $iLPageWidth=202; }			// PageBox Width
if (!isset($iLPageLeng))    { $iLPageLeng=1; }				// PageBox 1st Character Length(変更しない前提)
if (!isset($iLPage2ndLeng)) { $iLPage2ndLeng=2; }			// PageBox 2nd Character文字数
if (!isset($iLPageChrRate)) { $iLPageChrRate=180/12; }		// PageBox1行文字数を求めるRate (Width/文字数:全角考慮なし)

// global項目に格納
$GiLHeight=$iListHeight;				// IndexBotton高さ
$GiLWidth=$iListWidth;					// IndexBotton幅
$GiLGap=$iListGap;						// 外枠とボタンまでのギャップ
$GiLFuncH=$iListFuncH;					// 下部FunctionButton高さ
$GiLSpace=$iListFuncG+$iListFuncH;		// 外枠下部余白(Button配置用)
$GiLDown=$iListDown;					// IndexList DownButton Class(ボタンデザイン) ボタン修飾idセレクタ Class : #iLDown ()
$GiLUp  =$iListUp;						// IndexList UpButton Class(ボタンデザイン)   ボタン修飾idセレクタ Class : #iLUp ()
// PHP/JS共通領域
// IndexButton
$iList    ="idiList";					// IndexListBox:id
$iListtd  ="iListid";					// Index<id>:id
$iListchr ="iListchr";					// Index<id>下文字修飾用<div>:id
$GiLPagef ="iListPagef";				// IndexListBox PageFrame:id
$GiLPage  ="iListPage";					// IndexListBox Page:id
$GiLinfBox="iLinfoBox";					// IndexList InfoBox:id
// IndexButton 2ndBox
$iL2nd     ="iL2ndid";					// IndexListBox:id
$iL2ndtd   ="iL2ndtd";					// Index<id>:id
$iL2ndchr  ="iL2ndchr";					// Index<id>下文字修飾用<div>:id
$GiL2ndPagef="iL2ndPagef";				// IndexListBox 2nd PageFrame:id
$GiL2ndPage="iL2ndPage";				// IndexListBox 2nd Page:id
// Page Select Box
$iLPgL="idPageList";					// IndexList PageSelect Box:id
$iLPgLf="idPageListFrm";				// IndexList PageSelect Box:Table Frame id
$GiLPgSel="iLPgSel";					// IndexList PageSelect Box Select:id
$GiLPgSelNo=$iListPageSel;				// IndexList PageSelect Box Select数
$GiLPgSelDef=$iListPgSelDef;			// IndexList PageSelect Box Postion 調整

$iL2ndPgL="id2ndPageList";				// IndexList 2nd PageSelect Box:id
$iL2ndPgLf="id2ndPageListFrm";			// IndexList 2nd PageSelect Box:Table Frame id
$GiL2ndPgSel="iL2ndPgSel";				// IndexList 2nd PageSelectBox Select:id,
$GiL2ndPgSelNo=$iL2ndPageSel;			// IndexList PageSelect Box Select数
$GiL2ndPgSelDef=$iL2ndPgSelDef;			// IndexList 2nd PageSelect Box Postion 調整
$GiL2ndSpace=$iL2ndFuncG+$iListFuncH;	// 外枠下部余白(Button配置用)
$GiLPgLf=$iLPgLf;						// IndexList PageSelect Box:Table Frame id
$GiL2ndPgLf=$iL2ndPgLf;					// IndexList 2nd PageSelect Box:Table Frame id

/* 呼び出し方法設定 $iListIF : IndexList Display Button $iListIF:ButtonのHTML */
$iListIFid ="idiListIF";
$iListIFbutton ="idiListButton";
if ((!isset($iListIF))||($iListIF=="")) {				// $iListIF未セット ,$iListIFModeをセットして利用時,内蔵のI/Fボタンを利用
	$iListIF=ArgiListIFMakeButton($iListIFMode,$iListIFid,$iListIFbutton,$iList,$iL2nd,$iListIFDisp,$iListIFName,$iListIFCss);		// Buttunパターンの設定
	}
print $iListIF;					// I/F 呼び出し方法設定
$capstr=ArgMakeCapList($iListListExc,$iListCapital);		// PHP/JS共通領域,設定項目をJS使用可にする
echo <<<EOM
<script type="text/javascript">
TAGET_TBL="{$iListTBL}";		// Taget Table
TAGET_ID="{$iListARG}";			// Taget Table id : td Indexを作成するCell id={id} | no,no...
iListSes="{$iListSes}";			// Sesseionを使用時SessionName
iListSesBase="{$iListSesBase}";	// Sesseion BaseName
iListRows={$iListRows};			// iListRows:行数 
iListCells={$iListCells};		// iListCells:カラム数
iListCapital="{$iListCapital}";	// off|on:大文字/小文字区別しない
iListExc=[{$capstr} ];				// Listの定冠詞などを除外
iListTopChar={$iListTopChar};	// Listの文字列を正規表現で編集
iListMaskVal="{$iListMaskVal}";	// ListのMask文字列 TagがないときListに表示するValue

iListtd="{$iListtd}";			// Index<id>:id
iListchr="{$iListchr}";			// Index<id>下文字修飾用<div>:id
iListPage="{$GiLPage}";			// IndexListBox Page:id
iListPagef="{$GiLPagef}";		// IndexListBox PageFrame:id
iLPgList="{$iLPgL}";			// IndexList PageSelect Box:id
iLPgSel="{$GiLPgSel}";			// IndexList PageSelect Box Select:id
iListPageSel={$iListPageSel};	// IndexList PageSelect Box Select数
iListPgCharNo={$iListPgCharNo};	// IndexList PageSelect Box Select数
</script>
EOM;

// IndexButton Box作成
$boxheight=$iListRows*$GiLHeight+$GiLSpace+10;
$boxwidth=$iListCells*($GiLWidth+5)+$GiLGap*2;
print "<div id=\"{$iList}\" class=\"iLOuterFrame\" style=\"position:fixed;{$iListLR};{$iListPos};width:{$boxwidth}px;height:{$boxheight}px;display:none;{$iListBoxCss}\">";
DispiList($iList,$iListRows,$iListCells,$iListtd,$iListchr,1);		// Make Index Button
DispiListBox($iList,$iL2nd,$iLPgL,$iLIST_VERSION);	// Make Index Function Button
print '</div>';
// IndexButton 2ndBox作成
$box2ndheight=$iL2ndRows*$GiLHeight+$GiL2ndSpace+10;
$numeric = preg_replace('/[^0-9]/','',$iListPos);
if(strpos($iListPos,'bottom') !== false) {
	 $def=198-(198/4)*($iL2ndRows-1);								// Row数で徐々にずれるので補正 Rows1:196/Rows5:0
	 $def2=($GiLHeight-50)*(10-($iL2ndRows+$iListRows));			// 個数,高さでずれる部分を補正 基準:5×2(2nd)
	 $def=$def+$def2;
	 $pos=$numeric+$box2ndheight+$def;
	 $pos=$pos+($iListRows-5)*37+$iL2ndPosDef;						// 1次セレクトを5Low基準に補正
	 }
else {
	 $pos=$numeric-$box2ndheight;
	 $pos=$pos-($iListRows-5)*(37-35)+14+$iL2ndPosDef;						// 1次セレクトを5Low基準に補正
	 }
$iL2ndPos=str_replace($numeric,$pos,$iListPos);
echo <<<EOM
<script type="text/javascript">
iL2nd="{$iL2nd}";				// IndexListBox:id
iL2ndRows={$iL2ndRows};			// iList2ndRows:行数
iL2ndCells={$iListCells};		// iList2ndCells:カラム数
iL2ndDispNo={$iL2ndDispNo};		// iList2ndDispNo:非表示数(カラムが以下のとき表示しない)
iL2ndtd="{$iL2ndtd}";			// Index<id>:id
iL2ndchr="{$iL2ndchr}";			// Index<id>下文字修飾用<div>:id
iL2ndPage="{$GiL2ndPage}";		// IndexListBox Page:id
iL2ndPagef="{$GiL2ndPagef}";	// IndexListBox PageFrame:id
iL2ndPgList="{$iL2ndPgL}";		// IndexList 2nd PageSelect Box:id
iL2ndPgSel="{$GiL2ndPgSel}";	// IndexList PageSelect Box Select:id
iL2ndPageSel={$iL2ndPageSel};	// IndexList 2nd PageSelect Box Select数

/*
  case event.key "ArrowLeft"/ "ArrowRight" / "ArrowUp" / "ArrowDown":
  case event.shiftKey / event.ctrlKey / event.altKey
*/
document.body.addEventListener('keydown',function(event) {
		if ((event.shiftKey)&&(event.key =="ArrowUp")) { if (document.getElementById('{$iList}').style.display == 'block') { document.getElementById('iLDown').click();} }
		if ((event.shiftKey)&&(event.key =="ArrowDown")) { if (document.getElementById('{$iList}').style.display == 'block') { document.getElementById('iLUp').click();} }
		}
	);

</script>
EOM;
print "<div id=\"{$iL2nd}\" class=\"iLOuterFrame\" style=\"position:fixed;{$iListLR};{$iL2ndPos};width:{$boxwidth}px;height:{$box2ndheight}px;display:none;{$iListBoxCss}\">";
DispiList($iL2nd,$iL2ndRows,$iListCells,$iL2ndtd,$iL2ndchr);		// Make Index Button
DispiList2ndBox($iL2nd,$iL2ndPgL);

print '</div>';
?>

<style type="text/css">
/* IndexList Style
.iLOuterFrame : IndexList:外枠
.iLTable      : IndexList:table
.iLButton     : IndexList:Index Button
.iLChar       : IndexList:Index Character
*/
.iLOuterFrame { border: 1px solid #0f0f33;border-radius:6px;background:rgba(17,17,77,0.5);color:#f08080;font-size:16px; }
.iLTable { background:rgba(0,51,204,0.5); }
.iLButton { border-radius:6px;cursor:pointer; }
.iLChar { position:relative;top:1px; }

/* IndexList Function Style
.iLPageFrame  : IndexList Page Frame
.LPage        : IndexList Page
#iLDownF      : IndexList:Button Down Freme
#iLDown       : IndexList:Button Down php:$GiLDownでデザイン
#iLUpF        : IndexList:Button Up Freme
#iLUp         : IndexList:Button Up   php:$GiLUpでデザイン
#iLinfo       : IndexList:Button info
#iLClose      : IndexList:Button Close
#iL2DownF     : IndexList 2nd:Button Down Freme
#iL2Down      : IndexList 2nd:Button Down php:$GiLDownでデザイン
#iL2UpF       : IndexList 2nd:Button Up Freme
#iL2Up        : IndexList 2nd:Button Up   php:$GiLUpでデザイン
#iL2Close     : IndexList 2nd:Button Close
#iL2info      : IndexList 2nd:Button info
*/
.iLPageFrame { position:absolute;bottom:8px;left:6px;border: 1px solid #888888;background:rgba(0,51,204,0.5);border-radius:6px; }
.LPage { position:absolute;bottom:4px;left:6px;text-align:center;font-size:15px;color:#87cefa; }
#iLDownF { position:absolute;bottom:8px;border: 1px solid #888888;border-radius:6px;background:rgba(0,51,204,0.5); }
#iLDown { position:absolute;bottom:12px; }
#iLUpF { position:absolute;bottom:9px;border: 1px solid #888888;background:rgba(0,51,204,0.5);border-radius:6px; }
#iLUp { position:absolute;bottom:12px; }
#iLinfo { position:absolute;bottom:9px;height:20px;color:#b0c4de;border: 1px solid #888888;border-radius:6px;background:rgba(0,51,204,0.5); }
#iLClose { position:absolute;bottom:9px;right:11px;font-size:12px;text-align:center;color:#e0ffff;border: 1px solid #888888;border-radius:6px;background:rgba(0,51,204,0.5); }

#iL2DownF { position:absolute;bottom:12px;border: 1px solid #888888;border-radius:6px;background:rgba(0,51,204,0.5); }
#iL2Down { position:absolute;bottom:16px; }
#iL2UpF { position:absolute;bottom:12px;border: 1px solid #888888;background:rgba(0,51,204,0.5);border-radius:6px; }
#iL2Up { position:absolute;bottom:16px; }
#iL2Close { position:absolute;bottom:12px;right:10px;font-size:12px;text-align:center;color:#e0ffff;border: 1px solid #888888;border-radius:6px;background:rgba(0,51,204,0.5); }
#iL2info { position:absolute;bottom:12px;color:#b0c4de;font-size:10px;border: 1px solid #888888;border-radius:6px;background:rgba(0,51,204,0.5); }

<?php
$iLPageGap=11;									// PageBox GapWidth
$iLPageSelWidth=$iLPageWidth-($iLPageGap*2);	// PageBox:Width($iLPageWidth)Gapを除きTableWidth($iLPageSelWidth)
$iLPageDtlWidth=$iLPageSelWidth-2;				// PageBox:Td Width
echo <<<EOM
/*
.iLPagaBox    : IndexList PageSelect Box
.iLPagaFrm    : IndexList PageSelect Box Tabel Frame
.iLPageSel    : IndexList PageSelect table
.iLPageDtl    : IndexList PageSelect td(Detail)
.iLBoxbcan    : IndexList PageSelect Calcel
*/
.iLPagaBox { width:{$iLPageWidth}px;border: 1px solid #888888;border-radius:6px;background:#2e6399; }
/* PageBox 縦スクロールバーを出すパターン
.iLPagaFrm { width:{$iLPageWidth}px;border:none;overflow-x:hidden;overflow-y:auto; }
*/
/* PageBox スクロールバーを出さずにスクロール */
.iLPagaFrm { width:{$iLPageWidth}px;border:none;overflow-x:hidden;overflow-y:auto;-ms-overflow-style:none; }
.iLPagaFrm::-webkit-scrollbar {display:none;}

.iLPageSel { position:absolute;top:10px;left:10px;width:{$iLPageSelWidth}px;border:1px solid #2e6399;font-size:16px;color:#161666;background:#2e6399;border-collapse:collapse;border-spacing:0; }
.iLPageDtl { width:{$iLPageDtlWidth}px;border: 1px solid #ffffff;height:20px;background:#add8e6;overflow:hidden;cursor:pointer; }
.iLPageCan { position:absolute;bottom:4px;right:10px;width:54px;height:24px;font-size:12px;text-align:center;color:#ffffff;border: 1px solid #888888;border-radius:6px;background:rgba(0,51,204,1); }
EOM;
?>

/* BoxStyle
.iLBox     :Upper Box Default Off
.iLBoxtitle:Upper Box Title
.iLBoxline :Event Line
.iLBoxblin1:Event Line 1st iLBoxline+iLBoxblin1で指定
.iLBoxtext :Upper Box Button Text
.iLBoxbcan :Upper Box Cancel Button
*/
.iLBox { border: 1px solid #888888;font-size:10px;background-color:rgba(47,47,47,1);color:#CEECF5;display:none; }
.iLBoxtitle { position:absolute;top:0px;left:0px;background-color:#0000FF;color:#CEECF5;font-size:14px;text-align:left;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;height:18px;padding:6px 10px 4px;}
.iLBoxline  { background-color:#000000;color:#ffffff;font-size:13px;font-weight:bold;text-decoration:none;white-space:nowrap;display:block;text-align:left;vertical-align:middle;cursor:pointer;border: 1px solid #acacac;width:302px;height:20;padding:3px 10 2px;}
.iLBoxblin1 { position:absolute;left:0px;top:32px;line-height:22px;font-size:12px;}
.iLBoxtext  { position:absolute;top:62px;color:#CEECF5;font-size:10px;font-weight:bold;text-decoration:none;text-align:left;vertical-align:middle;border: 0px;width:278px;height:19;padding:3px 10 2px;}
.iLBoxbcan  { position:absolute;right:14px;border-style:none;width:50px;height:20px;padding:2px 0 2px;font-size:11px;cursor:pointer;-moz-border-radius:4px;-webkit-border-radius:4px;border-radius: 4px; }

/* List Function Up,Down用 図形 */
/* 台形(三角Down) */
.trapezDown { width:0px;height:0px;
	border-bottom:22px solid;border-color:rgba(51,102,255,0.8);
	border-left:14px solid transparent;
	border-right:14px solid transparent;
	}
/* 台形(三角Up) */
.trapezUp { width:0px;height:0;
	border-top:22px solid;border-color:rgba(51,102,255,0.8);
	border-left:14px solid transparent;
	border-right:14px solid transparent;
	}
/* 台形(三角Left) */
.trapezLeft { width:0;height:0px;
	border-right:26px solid;border-color:rgba(51,102,255,0.8);
	border-top:12px solid transparent;
	border-bottom:12px solid transparent;
	}
/* 台形(三角Right) */
.trapezRight { width:0;height:0px;
	border-left:26px solid;border-color:rgba(51,102,255,0.8);
	border-top:12px solid transparent;
	border-bottom:12px solid transparent;
	}
</style>

<?php
ArgMakeCallCss();		// 呼び出し用Button用図形用CSS設定
?>

<script type="text/javascript">
<?php
$iLPageChr=$iLPageDtlWidth/($iLPageChrRate);
echo <<<EOM
iLPageDtlWidth={$iLPageDtlWidth};			// PageBox td Width
var iLPageChr={$iLPageChr};					// PageBox文字数(漢字考慮なし)
var iLPage2ndLeng={$iLPage2ndLeng};			// PageBox 2nd Character Length
var	iLPageLeng={$iLPageLeng};				// PageBox 1st Character Length(変更しない前提)
EOM;
?>

<?php
echo <<<EOM
Make_ListNew({$iListDefHigh},{$iListDefLeft});	// 対象TableのIndeexListを作成
EOM;
?>

var ARY_INDEX;								// <table Tag下のIndexTable   : index(1文字):Table id
var ARY_LIST;								// IndexTable List [no(連番)] : index(1文字)
var ARY_POINT;								// <table Tag下のIndexTable rows ARY_LIST[no]と同じpoint)
var ListDefHigh;							// Scroll Def High
var ListDefLeft;							// Scroll Def Left
var ListNowPage;							// 現在表示ページ

var A2nd_INDEX;								// <table Tag下のIndexTable(id) 2nd index(2文字):Table id
var A2nd_LIST;								// IndexTable List ,                no(連番) : index(2文字)
var A2nd_POINT;								// <table Tag下のIndexTable rows A2nd_LIST[no]と同じpoint)
var ListNowPage2ndv;						// 現在表示ページ2nd

/* -------------------------------------------------------------------------------------
	Make_ListIndex(CellsId,value) : Make Index List Table
	 CellsId : i  : td Indexを作成するCell id={id} | no,no...
	 defHigh : i  : Scroll Def High Positon時Haeder高さの位置補正
	 defLeft : i  : Scroll Def Left Positon時の位置補正
---------------------------------------------------------------------------------------*/
function Make_ListNew(defHigh,defLeft) {
	ARY_INDEX= {};									// <table Tag下のIndexTable(id)
	ARY_LIST= {};									// IndexTable List [no(連番)] : index(1文字)
	ARY_POINT= {}									// <table Tag下のIndexTable rows ARY_LIST[no]と同じpoint)

	if (typeof ListDefHigh !== "undefined") { if(defHigh == null) { defHigh=ListDefHigh;ArgSessionKeep("page",0); } }		// ReMake Request
	if (typeof ListDefLeft !== "undefined") { if(defLeft == null) { defLeft=ListDefLeft; } }		// ReMake Request
	document.getElementById(iL2nd).style.display = 'none';
	document.getElementById(iLPgList).style.display= 'none';

	ListDefHigh=defHigh;							// Scroll Def High 初期値を設定
	ListDefLeft=defLeft;							// Scroll Def Left 初期値を設定
	endpage=Make_ListIndex(ARY_INDEX,ARY_LIST,ARY_POINT,iListRows,iListCells,iLPageLeng,0,-1);
	ListNowPage=0;
	var sespage=ArgSessionGet("page");				// Session Data(Page)取得
	if (sespage != null) { ListNowPage=parseInt(sespage); }
	if (ListNowPage >endpage) { ListNowPage=0; }	// Sessionを復元したとき前回とPage数が変わっていた時を防ぐ
	DispListIndex(ListNowPage);						// IndexTable HTMLを作成
	if (parseInt(endpage) == 0) {
		document.getElementById(iListPagef).style.cursor="default";
		}
	}

/* -------------------------------------------------------------------------------------
	Make_ListIndex(index,list,point,listrows,listcells,CharLeng,sno,eno) : Make Index List Table
	 index    : i  : id index array    ARY_INDEX/A2nd_INDEX
	 list     : i  : index no array    ARY_LIST /A2nd_LIST
	 point    : i  : index point array ARY_POINT/A2nd_POINT
	 listrows : i  : Index List Rows数  : iListRows/iL2ndRows    ※End Pageを求めるために設定
	 listcells: i  : Index List Cells数 : iListCells/iL2ndCells  ※End Pageを求めるために設定
	 CharLeng : i  : index point Character Length
	 sno      : i  : Start Array Point
	 eno      : i  : End Array Point : -1:最後まで
	 @return  : o  : End Page(Page数) 0:(1Page)
---------------------------------------------------------------------------------------*/
function Make_ListIndex(index,list,point,listrows,listcells,CharLeng,sno,eno) {
	Selid="";
	result = TAGET_ID.match(/id=[\s\S]*?/i);			// 引数の判定
	if(result !==null) {								// TAGET_ID:形式 td Indexを作成するCell id={id} | no,no...
		 Selid = TAGET_ID.replace(/(id=|\"|\')/g,'');		// 'id='を除去しidを取得する "
		 }
	else {
		 SelNo = TAGET_ID.split(",");					// Array:cells[index]
		 }
	tblobj=document.getElementById(TAGET_TBL);
	for (i=sno,no=0;i < tblobj.rows.length;i++) {		// 配列 Row取得
		if ((eno >= 0)&&(i >= eno)) { break; }
		colLen = tblobj.rows[i].cells.length;
		if (Selid !=="") {
			 for (j=0;j < colLen;j++) {					// 配列 cells取得
				var cells = tblobj.rows[i].cells[j];
				str=cells.innerHTML;
				result = str.match(/id=[\s\S]*? /i);	// htmlからidを分離
				if (result == null) { continue; }
				var id = result[0].replace(/(id=|\"|\')/g,'');	// 'id='を除去しidを取得する "
				id=id.replace(/^\s+|\s+$/g,'');			// Trimと同じ
				if (id.indexOf(Selid) !== -1) {			// Cellのidが指定idと一致:対象
					var val = cells.textContent;		// Textを取得する
//					var val = cells.textContent || cells.innerText;			// ID指定で取れないとき有効にしてみる。HTMLを取り除く。<td id={id}><div>{value}</div>で<div>をエスケープする
					no=_Make_ListIndex_Add(index,list,point,i,no,id,val,CharLeng);
					}
				}
			 }
		else {
			 for (j=0;j < SelNo.length;j++) {			// 配列 cells取得
				if (SelNo[j] < colLen) {				// cell数より大きい指定は無視する
					var cells = tblobj.rows[i].cells[SelNo[j]];
					var val = cells.innerText;
					str=cells.innerHTML;				// idを取得する
					result = str.match(/id=[\s\S]*? /i);	// htmlからidを分離
					var id = result[0].replace(/(id=|\"|\')/g,'');	// 'id='を除去しidを取得する "
					id=id.trim();
					no=_Make_ListIndex_Add(index,list,point,i,no,id,val,CharLeng);
					}
				}
			 }
		}
	var	endpage = Math.floor(Object.keys(list).length/(listrows*listcells));
	remain  = Math.floor(Object.keys(list).length%(listrows*listcells));
	if (remain==0) { endpage = endpage -1; }
	return(endpage);
	}

/*
	_Make_ListIndex_Add(index,list,,point,i,no,id,val,leng) : ARY_INDEX <table Tag下のIndexTableを作成
	 index   : i  : id index array    ARY_INDEX/A2nd_INDEX
	 list    : i  : index no array    ARY_LIST /A2nd_LIST
	 point   : i  : index point array ARY_POINT/A2nd_POINT
	 i       : i  : index table point
	 no      : i  : Index No
	 id      : i  : Index Charcter : 1文字切出しKeyにする
	 val     : i  : Value
	 leng    : i  : Character Length
	 @rturn  : o  : New No
*/
function _Make_ListIndex_Add(index,list,point,i,no,id,val,leng) {
	tmp=val;									// Valの先頭文字をルールに従い抽出
	if (tmp.startsWith(iListMaskVal)) { tmp=""; }		//  ListのMask文字列 Tagがないとき
	if (iListTopChar  == "") { } else {			// 文字列操作が外部から設定
		regexp = new RegExp(iListTopChar);
		tmp=tmp.replace(regexp,'');
		}
	for (c=0;c < iListExc.length;c++) {			// 定冠詞を除外(iListExc:定冠詞配列)
		if (iListCapital == "on") {				// 大/小文字を区別しないときは定冠詞も同様
			tmp = tmp.toUpperCase();			// 小文字->大文字変換
			}
		ret=tmp.indexOf(iListExc[c]);
		if (ret != 0) { continue; }
		tmp=tmp.replace(iListExc[c],'');
		}
	str=tmp.substr(0,leng);						// 先頭n文字抽出
	if (iListCapital == "on") {
		str = str.toUpperCase();				// 小文字->大文字変換
		}
	str=str.replace(/^\s+|\s+$/g,'');			// Space Trim
	point[parseInt(no)] =i;
	if (!index[str]) {							// 先頭のIDをセット
		index[str]=id;
		list[parseInt(no)]=str;
		no++;
		}
	return(no);
	}

/* =====================================================================================
	DispListIndex(page) : IndexTable HTMLを作成
	 page   : i  : 表示ページ
---------------------------------------------------------------------------------------*/
function DispListIndex(page) {
	if (page < 0) { return; }
	var reslt=DispListPage(ARY_INDEX,ARY_LIST,iListRows,iListCells,iListPage,iListchr,page,iListtd);
	if (reslt >= 0) {
		ListNowPage=reslt;
		}
	ArgSessionKeep("page",ListNowPage);
	}

/* -------------------------------------------------------------------------------------
	DispListIndex2nd(page) : IndexTable HTMLを作成
	 page   : i  : 表示ページ
---------------------------------------------------------------------------------------*/
function DispListIndex2nd(page) {
	if (page < 0) { return; }
	var reslt=DispListPage(A2nd_INDEX,A2nd_LIST,iL2ndRows,iL2ndCells,iL2ndPage,iL2ndchr,page);
	if (reslt >= 0) {
		ListNowPage2nd=reslt;
		}
	}

/* -------------------------------------------------------------------------------------
	DispListPage(index,list,rows,cells,pageid,chrid,page,tdid) : IndexTable 指定PageHTML作成
	 index   : i  : id index array     : ARY_INDEX/A2nd_INDEX
	 list    : i  : index no array     : ARY_LIST /A2nd_LIST
	 rows    : i  : Index List Rows数  : iListRows/iL2ndRows
	 cells   : i  : Index List Cells数 : iListCells/iL2ndCells
	 pageid  : i  : Index List Page id : iListPage/iL2ndPage
	 chrid   : i  : Index List Character id : iListchr/iL2ndchr
	 page    : i  : Request 表示ページ
	 tdid    : i  : Index<id>の固定部(iListtd),2nd Index時未セット(null,undefined)
---------------------------------------------------------------------------------------*/
function DispListPage(index,list,rows,cells,pageid,chrid,page,tdid) {
	endpage = Math.floor(Object.keys(list).length/(rows*cells));
	remain  = Math.floor(Object.keys(list).length%(rows*cells));
	if (remain==0) { endpage = endpage -1; }
	if (page > endpage) { return(-1); }
	document.getElementById(pageid).innerText=(page+1)+"/"+(endpage+1);
	start_pos=page*(rows*cells);			// 表示開始Index
	for (i=0;i < rows*cells;i++) {			// 配列 Row取得
		idx=start_pos+i;
		id=chrid+i;							// <td?下 文字修飾用 <div>:id
		if (idx >= Object.keys(list).length) { document.getElementById(id).innerHTML='';continue; }
		key=list[idx];
		val=index[key];
		if ((iListCapital == "on")&&(key.length >1 )) {		// 大/小文字を区別しない&文字列長が1より大きい
			key=key.slice(0,1)+key.slice(1).toLowerCase();	// 2文字以降を小文字にする
			}
		document.getElementById(id).innerText=key;
		if ((tdid !== null)&&(tdid !== undefined)) {		// tdid : 2nd Index時未指定,TagがないときbackgroundColorをセットし色を変える
			if(key=="") { document.getElementById(iListtd+i).style.backgroundColor = 'rgba(0,0,0,0.2)'; } else { document.getElementById(iListtd+i).style.backgroundColor = ''; }
			}
		}
	return(page);
	}

/* =====================================================================================
	DispReqPos(i) : Request Scroll RequestScrollPositon I/F
	 i     : i  : Input Heler(IndexListTable) Indexを指定 ARY_LISTの示す位置にPostionする
---------------------------------------------------------------------------------------*/
function DispReqPos(i) {
	start_pos=ListNowPage*(iListRows*iListCells);			// 表示開始Index
	idx=start_pos+i;
	if (idx < Object.keys(ARY_LIST).length) {
		key=ARY_LIST[idx];
		id=ARY_INDEX[key];
		RequestPositon(window,id,ListDefHigh,ListDefLeft);
		// 2nd Choice Index List
		document.getElementById(iL2nd).style.display = 'none';
		A2nd_INDEX= {};		// <table Tag下のIndexTable(id)
		A2nd_LIST = {};		// <table Tag下のIndexTable(no)
		A2nd_POINT = {};	// <table Tag下のIndexTable(rows)
		sno=ARY_POINT[idx];
		id2=idx+1;
		if (id2 < Object.keys(ARY_LIST).length) { eno=ARY_POINT[id2]; } else { eno=-1;}
		endpage=Make_ListIndex(A2nd_INDEX,A2nd_LIST,A2nd_POINT,iL2ndRows,iL2ndCells,iLPage2ndLeng,sno,eno);
		if (parseInt(endpage) == 0) {
			 document.getElementById(iL2ndPagef).style.cursor="default";
			 }
		else {
			 document.getElementById(iL2ndPagef).style.cursor="pointer";
			 }
		ListNowPage2nd=0;
		DispListIndex2nd(ListNowPage2nd);
		if (Object.keys(A2nd_LIST).length > iL2ndDispNo) {
			document.getElementById(iL2nd).style.display = 'block';
			}
		}
	}

/* -------------------------------------------------------------------------------------
	DispReqPos2nd(i) : Request Scroll RequestScrollPositon I/F 2nd
	 i     : i  : Input Heler(IndexListTable) Indexを指定 ARY_LISTの示す位置にPostionする
---------------------------------------------------------------------------------------*/
function DispReqPos2nd(i) {
	start_pos=ListNowPage2nd*(iL2ndRows*iL2ndCells);		// 表示開始Index
	idx=start_pos+i;
	if (idx < Object.keys(A2nd_LIST).length) {
		key=A2nd_LIST[idx];
		id=A2nd_INDEX[key];
		RequestPositon(window,id,ListDefHigh,ListDefLeft);
		}
	}

/* ------------------------------------------------------------------------------------
	RequestScrollPositon(scrlObj,id,defHigh,defLeft) : 指定Objectをスクロール
	 scrlObj : Scroll Object
	 id      : Positon id 
	 defHigh : 高さ差分  (Windowの場合はHeaderまでの位置を指定)
	 defLeft : 左位置差分(左位置を補正する場合指定)

	※Postion Fixdは移動しない。
	  Windowサイズが不定の場合に使用できる。
------------------------------------------------------------------------------------- */
function RequestPositon(scrlObj,id,defHigh,defLeft) {
	if (document.getElementById(id)) {
		scrlObj.scrollTo(0,0);						// 一旦先頭にスクロール
		var element = document.getElementById(id);	// スクロール要素の位置を取得
		var rect = element.getBoundingClientRect();
		var topval = rect.top- defHigh;				// Headまでを補正
		var leftval=rect.left;
		if (valleft != 0) {							// Left補正が指定されたときは補正
			leftval=rect.left + defLeft;
			}
		if (topval < 0) {							// 大きすぎる値が設定された場合でも0を最低にする(ロジック的にはしなくても良いが)
			topval=0;
			}
		scrlObj.scrollTo(leftval,topval);			// スクロール
		}
	}

/* =====================================================================================
	DispPageList(page) : IndexList Select Box Page  Display Box
	 page : i  : 現在のPage
------------------------------------------------------------------------------------- */
function DispPageList(page) {
	onevent="onClickPageList({$page});";
	endpage=MakePageList(iLPgSel,onevent,iListPageSel,ARY_INDEX,ARY_LIST,iListRows,iListCells,page);
	if (endpage > 0) {
		document.getElementById(iLPgList).style.display='block';
		}
	}

/* ------------------------------------------------------------------------------------
	DispPageList(page) : IndexList Select Box Page  Display Box
	 page : i  : 現在のPage
------------------------------------------------------------------------------------- */
function DispPageList2nd(page) {
	onevent="onClickPageList2nd({$page});";
	endpage=MakePageList(iL2ndPgSel,onevent,iL2ndPageSel,A2nd_INDEX,A2nd_LIST,iL2ndRows,iL2ndCells,page);
	if (endpage > 0) {
		 document.getElementById(iL2ndPgList).style.display='block';
		 }
	}

/* ------------------------------------------------------------------------------------
	MakePageList(selid,onevent,PageSel,index,list,rows,cells,page) : IndexList Select Box Make Box
	 selid   : i  : SeelctBox id       : iLPgSel/iL2ndPgSel
	 onevent : i  : Page Cell Click Event
	 PageSel : i  : Page Cell RowsNo(行数)
	 index   : i  : id index array     : ARY_INDEX/A2nd_INDEX
	 list    : i  : index no array     : ARY_LIST /A2nd_LIST
	 rows    : i  : Index List Rows数  : iListRows/iL2ndRows
	 cells   : i  : Index List Cells数 : iListCells/iL2ndCells
	 page    : i  : 現在のPage
	 @return : o  : Index List Page数
------------------------------------------------------------------------------------- */
function MakePageList(selid,onevent,PageSel,index,list,rows,cells,page) {
	endpage = Math.floor(Object.keys(list).length/(rows*cells));
	remain  = Math.floor(Object.keys(list).length%(rows*cells));
	if (remain==0) { endpage = endpage -1; }
	var td_style='style="color:#a9a9a9;background:#4682b4;"';
	var td_cons='<div class="iLPageDtl" onclick="{$event}" {$style}>{$value}</div>';
	Element = document.getElementById(selid);
	row = Element.rows.length;
    for (i = 0; i < row; i++) {					// Table全行削除
	    Element.deleteRow(0);
		}
	for (i=0;i < endpage+1;i++) {
		row = Element.insertRow(-1);
		cell = row.insertCell(-1);
//		start_pos=i*(rows*cells);				// Pageの先頭Index 1文字のみのときは "_MakePageList_char()"と入れ替え
//		key=list[start_pos];					// Pageの先頭のValue
		key =_MakePageList_char(index,list,rows,cells,i);		// 半角12文字が限界値
		no=i+1;
		leng=String(endpage+1).length;
		if (leng >1) {							// 2桁以上のページ時,Zeroパティングする
			zeros = Array(leng + 1).join("0");
			no=(zeros + (i+1)).slice(-leng);
			}
		val= "&nbsp;"+ no + " : " + key;		// Select Box Text値
		var str=td_cons.replace("{$value}",val);
		if (i== page) {							// 表示Page:Mark,Eventは処理なし
			 str=str.replace("{$style}",td_style);
			 str=str.replace("{$event}","");
			 }
		else {
			 str=str.replace("{$style}","");	// Select対象
			 str=str.replace("{$event}",onevent);	// Onclick Eventをセット
			 }
		str=str.replace("{$page}",i);
		cell.innerHTML=str;						// Select Box Text値
		}
	str=td_cons.replace("{$event}","");
	str=str.replace("{$page}","");				// デザインのため枠まで空Cellを作成
	str=str.replace("{$style}","");
	str=str.replace("{$value}","");
	for (i=endpage+1;i < PageSel;i++) {
		row = Element.insertRow(-1);
		cell = row.insertCell(-1);
		cell.innerHTML = str;
		}
	return(endpage);
	}

/*
	_MakePageList_char(index,list,rows,cells,point) : Make IndexList Charcter
	 index   : i  : id index array     : ARY_INDEX/A2nd_INDEX
	 list    : i  : index no array     : ARY_LIST /A2nd_LIST
	 rows    : i  : Index List Rows数  : iListRows/iL2ndRows
	 cells   : i  : Index List Cells数 : iListCells/iL2ndCells
	 point   : i  : Reqest Page
	 @return : o  : List Char String
*/
function _MakePageList_char(index,list,rows,cells,point) {
	start_pos=point*(rows*cells);				// Pageの先頭Index
	var end_pos=((point+1)*(rows*cells))-1;	// 終了Index
	var end_list= Object.keys(list).length;	// 配列数
	var str="";
	for (j=start_pos,n=0;n < iListPgCharNo;j++,n++) {
		if (j >= end_list) { break; }		// 配列数Stopper
		if (j > end_pos) { break; }			// 対象Page
		if (str !=="") { str=str+","; }
		
		var tmp=str+list[j];
		if (tmp.length > iLPageChr) { break; }

		str=str+list[j];
		}
	if (str !=="") { str=str+"..."; }
	return(str);
	}

/* =====================================================================================
	onClickPageList(val) : IndexList Select Box Page  Click Event
	 val   : i  : Reqest Page
------------------------------------------------------------------------------------- */
function onClickPageList(val) {
	DispListIndex(parseInt(val));
	document.getElementById(iLPgList).style.display='none';
	document.getElementById(iL2nd).style.display='none';
	ArgSessionKeep("page",val);
	}

/* ------------------------------------------------------------------------------------
	onClickPageList(val) : IndexList Select Box Page  Click Event
	 val   : i  : Reqest Page
------------------------------------------------------------------------------------- */
function onClickPageList2nd(val) {
	DispListIndex2nd(parseInt(val));
	document.getElementById(iL2ndPgList).style.display='none';
	}

/* =====================================================================================
	ArgSessionKeep(subkey,val) : SessionKeep
	 subkey : i  ; Session SubKey
	 val    : i  : Session Data
	※Session Key : {iListSesBase}+{subkey}+{iListSes}
	                iListSesBase:Programで一意:"iList/" , subkey:処理で決定(任意) , iListSes:呼び元で決定
------------------------------------------------------------------------------------- */
function ArgSessionKeep(subkey,val) {
	if (iListSes != "") {
		 sessionStorage[iListSesBase+subkey+"/"+iListSes] = val;
		 }
	}

/* ------------------------------------------------------------------------------------
	ArgSessionGet(subkey) : Session Data Get
	 subkey : i  ; Session SubKey
	 @return: i  : Session Data
------------------------------------------------------------------------------------- */
function ArgSessionGet(subkey) {
	var ret =null;
	if (iListSes != "") {
		 ret =sessionStorage.getItem(iListSesBase+subkey+"/"+iListSes);
		 }
	return(ret);
	}

</script>

<?php
/* ------------------------------------------------------------------------------------
	ArgMakeCapList($iListListExc,$iListCapital) : PHP定冠詞設定項目をJS用に編集にする
	 $iListListExc : i  : Listの定冠詞などを除外 "{定冠詞},{定冠詞}.." : ","で複数指定可 ex:"The ,..." default:""
	 $iListCapital : i  : on:大文字/小文字区別しない default:off
	 @return       : o  : 定冠詞設定項目 JS String
------------------------------------------------------------------------------------- */
function ArgMakeCapList($iListListExc,$iListCapital) {
	$ary= explode(",",$iListListExc);
	$iListCapital = mb_strtolower($iListCapital);
	$capstr="";
	foreach($ary as $ar) {
		if ($$capstr !=="") { $capstr=$capstr.","; }
		if ($iListCapital=="on") { $tmp=strtoupper($ar); }
		$tmp = str_replace('"','\"',$tmp);
		$capstr=$capstr.'"'.$tmp.'"';
		}
	return($capstr);
	}

/* ------------------------------------------------------------------------------------
	DispiList($Boxid,$BoxRows,$Boxtdid,$BoxDivid,$parent) : Index Box Table生成
	 $Boxid     : i  : IndexBox id
	 $BoxRows   : i  : IndexBox Rows(行数)
	 $BoxCells  : i  : IndexBox Cells(セル数)
	 $Boxtdid   : i  : IndexBox td id
	 $BoxDivid  : i  : IndexBox td配下Div id
	 $parent    : i  : 1:親Box, 0:Child Box
------------------------------------------------------------------------------------- */
function DispiList($Boxid,$BoxRows,$BoxCells,$Boxtdid,$BoxDivid,$parent=0) {
	global $GiLWidth,$GiLHeight,$GiLGap;

// IndexButton Box作成
echo <<<EOM
<!-- IndexList Index Button -->
<table border="3" cellpadding="0" bgcolor="#000000" class="iLTable" frame=void style="position:absolute;top:{$GiLGap}px;left:{$GiLGap}px;">
EOM;
	for ($i=0;$i < $BoxRows;$i++) {
		print '<tr>';
		for ($j=0;$j < $BoxCells;$j++) {
			$id=$Boxtdid.($i*$BoxCells+$j);
			$idchr=$BoxDivid.($i*$BoxCells+$j);
			$onclick="";
			if ($parent==1) {		// Main IndexBox Onclick
				 $onclick="DispReqPos(".($i*$BoxCells+$j).");";
				 }
			else {
				 $onclick="DispReqPos2nd(".($i*$BoxCells+$j).");";
				 }
			print "<td id=\"{$id}\" align=\"center\" onclick=\"".$onclick."\" class=\"iLButton\" style=\"width:{$GiLWidth}px;height:{$GiLHeight}px;\">";
			print "<div id=\"{$idchr}\" class=\"iLChar\" ></div></td>";
			}
		print '</tr>';
		}
echo <<<EOM
</table>
EOM;
	}

/* ------------------------------------------------------------------------------------
	DispiListBox($iList,$iL2nd,$iLIST_VERSION) : Index Box Function生成
	 $iList        : i  : IndexBox id
	 $iL2nd        : i  : IndexBox 2nd id
	 $iLPgL        : i  : List Index Page Select id
	 $iLIST_VERSION: i  : Info Box Info
------------------------------------------------------------------------------------- */
function DispiListBox($iList,$iL2nd,$iLPgL,$iLIST_VERSION) {
	global $GiLinfBox,$GiLPagef,$GiLPage,$GiLDown,$GiLUp,$GinfBoxCan,$GiLWidth,$GiLFuncH,$GiLPgSel,$GiLPgSelNo,$GiLPgSelDef,$GiLPgLf;

// IndexButton Box Function作成
	$infboxheight=190;
	$clshigth=$GiLFuncH+2;
	$GinfBoxCan=$infboxheight-26;
	$infboxbottom=$infboxheight-20;

	$widthinfo=36-(50-$GiLWidth)/2;
	$leftdownf=6+7+$GiLWidth;					// LeftDownFreme 6:iLPageFrame + Gap
	$leftdown =$leftdownf+12-(50-$GiLWidth)/2;	// LeftDown 基準片幅(1/2)50基準
	$leftupf=$leftdownf+4+$GiLWidth;			// LeftUpFreme 4:Gap
	$leftup=$leftupf+12-(50-$GiLWidth)/2;;		// LeftUp
	$leftinfo=$leftupf+5+$GiLWidth;				// LeftInfo + 6Gap
echo <<<EOM
<!-- IndexList Function -->
<div id="{$GiLPagef}" class="iLPageFrame" onclick="DispPageList(ListNowPage);" style="width:{$GiLWidth}px;height:{$GiLFuncH}px;cursor:pointer;">
<div id="{$GiLPage}" class="LPage" style="width:{$widthinfo}px;">0/0</div>
</div>
<div id="iLDownF" style="left:{$leftdownf}px;width:{$GiLWidth}px;height:{$GiLFuncH}px;"></div>
<div id="iLDown" class="{$GiLDown}" onclick="DispListIndex(ListNowPage-1);document.getElementById('{$iL2nd}').style.display='none';" style="left:{$leftdown}px;cursor:pointer;"></div>
<div id="iLUpF" style="left:{$leftupf}px;width:{$GiLWidth}px;height:{$GiLFuncH}px;"></div>
<div id="iLUp" class="{$GiLUp}" onclick="DispListIndex(ListNowPage+1);document.getElementById('{$iL2nd}').style.display='none';" style="left:{$leftup}px;cursor:pointer;"></div>
<button id="iLinfo" onclick="document.getElementById('{$GiLinfBox}').style.display='block';if (ArgSessionGet('page')!==null) { document.getElementById('iLBSesClr').style.backgroundColor='#191970';;document.getElementById('idInfoSes').innerHTML=iListSesBase+'page/'+iListSes+'('+ArgSessionGet('page')+')'; } else { document.getElementById('iLBSesClr').style.backgroundColor=''; ;document.getElementById('idInfoSes').innerHTML='Not using Session'; }" style="left:{$leftinfo}px;width:{$GiLWidth}px;cursor:pointer;">Info</button>
<button id="iLClose" onclick="document.getElementById('{$iList}').style.display='none';document.getElementById('{$iL2nd}').style.display='none';" style="width:{$GiLWidth}px;height:{$clshigth}px;cursor:pointer;">Close</button>
<!-- Information Box -->
<div id="{$GiLinfBox}" class="iLBox" style="position:absolute;bottom:8px;left:8px;width:260px;height:{$infboxheight}px;">
<div class="iLBoxtitle" style="width:238px;">mpdilist Information</div>
<div id="iLBSesClr" class="iLBoxline iLBoxblin1" style="width:238px;" onclick="sessionStorage.clear();document.getElementById('{$GiLinfBox}').style.display='none';">SessionStorage Clear</div>
<div class="iLBoxtext">{$iLIST_VERSION}</div>
<div class="iLBoxtext" style="top:80px;">SessionStrage:</div>
<div class="iLBoxtext" id="idInfoSes" style="top:95px;left:14px;color:#98fb98;"></div>
<div class="iLBoxtext" style="top:114px;color:#75baff;font-weight:bold;font-size;13px;">Operation Tips</div>
<div class="iLBoxtext" style="top:128px;left:10px;">&lt;Shift&gt;+&lt;Up&gt; &ensp;&nbsp;&nbsp; : Scroll Up</div>
<div class="iLBoxtext" style="top:140px;left:10px;">&lt;Shift&gt;+&lt;Down&gt; : Scroll Down</div>

<!-- Close Botton -->
<div class="iLBoxtext" style="top:{$infboxbottom}px;font-size:9px;">(C)2019 by Mikio Shiratori</div>
<button class="iLBoxbcan" onclick="document.getElementById('{$GiLinfBox}').style.display='none';" style="top:{$GinfBoxCan}px;">Close</button>
</div>
<!-- Information Box End -->
EOM;
	DispiPageListBox($iLPgL,$GiLPgLf,$GiLPgSel,$GiLPgSelNo,$GiLPgSelDef);		// IndexList, Make Page Select Box
	}

/* ------------------------------------------------------------------------------------
	DispiList2ndBox($iL2nd,$iL2ndPgL) :  Index Box 2nd Function生成
	 $iL2nd    : i  : IndexBox 2nd id
	 $iL2ndPgL : i  : List Index 2nd Page Select Box id
------------------------------------------------------------------------------------- */
function DispiList2ndBox($iL2nd,$iL2ndPgL) {
	global $GiL2ndPage,$GiL2ndPagef,$GiLDown,$GiLUp,$GiLWidth,$GiLFuncH,$GiL2ndPgSel,$GiL2ndPgSelNo,$GiL2ndPgSelDef,$GiL2ndPgLf;

	$widthinfo=36-(50-$GiLWidth)/2;
	$clshigth=$GiLFuncH+2;
	$leftdownf=6+7+$GiLWidth;					// LeftDownFreme 6:iLPageFrame + Gap
	$leftdown =$leftdownf+12-(50-$GiLWidth)/2;	// LeftDown 基準片幅(1/2)50基準
	$leftupf=$leftdownf+4+$GiLWidth;			// LeftUpFreme 4:Gap
	$leftup=$leftupf+12-(50-$GiLWidth)/2;;		// LeftUp
	$leftinfo=$leftupf+5+$GiLWidth;				// LeftInfo + 6Gap
echo <<<EOM
<!-- IndexList Function -->
<div id="{$GiL2ndPagef}" class="iLPageFrame" onclick="DispPageList2nd(ListNowPage2nd);" style="bottom:12px;width:{$GiLWidth}px;height:{$GiLFuncH}px;cursor:pointer;">
<div id="{$GiL2ndPage}" class="LPage" style="width:{$widthinfo}px;">0/0</div>
</div>
<div id="iL2DownF" style="left:{$leftdownf}px;width:{$GiLWidth}px;height:{$GiLFuncH}px;"></div>
<div id="iL2Down" class="{$GiLDown}" onclick="DispListIndex2nd(ListNowPage2nd-1);"  style="left:{$leftdown}px;cursor:pointer;"></div>
<div id="iL2UpF" style="left:{$leftupf}px;width:{$GiLWidth}px;height:{$GiLFuncH}px;"></div>
<div id="iL2Up" class="{$GiLUp}" onclick="DispListIndex2nd(ListNowPage2nd+1);" style="left:{$leftup}px;cursor:pointer;"></div>
<button id="iL2Close" onclick="document.getElementById('{$iL2nd}').style.display='none';" style="width:{$GiLWidth}px;height:{$clshigth}px;color:#b0c4de;cursor:pointer;">Close</button>
<div id="iL2info" style="left:{$leftinfo}px;width:{$GiLWidth}px;height:{$GiLFuncH}px;"><div style="position:absolute;bottom:2px;right:4px;">2nd<BR>Choice</div></div>
EOM;
	global $GiLPgLf;
	DispiPageListBox($iL2ndPgL,$GiL2ndPgLf,$GiL2ndPgSel,$GiL2ndPgSelNo,$GiL2ndPgSelDef);		// IndexList, Make Page Select Box
	}

/* ------------------------------------------------------------------------------------
	DispiPageListBox($iLPgL) :  List Index Page Select HTML
	 $iLPgL       : i  : Box id
	 $iLPgSel     : i  : IndexList PageSelect Box Select:id
	 $iListPageSel: i  : IndexList PageSelect Box Select数
	 $def         ; i  : SelectBox表示時のPositon Topの調整値
------------------------------------------------------------------------------------- */
function DispiPageListBox($iLPgL,$iLPgLf,$iLPgSel,$iListPageSel,$def) {
	$tbheight=$iListPageSel*23;
	$height=$iListPageSel*23+60;
	$tbframe=$iListPageSel*23+13;
	$top=$def-($def+-6)/10*$iListPageSel-22;		// 行数 1:-176,10:-14 を比率で調整 -20:補正値
echo <<<EOM
<div id="{$iLPgL}" class="iLPagaBox" style="position:relative;bottom:{$top}px;left:6px;height:{$height}px;width:202px;display:none;">
<div id="{$iLPgLf}" class="iLPagaFrm" style="position:absolute;top:10px;left:0px;height:{$tbframe}px;"><!-- BoxからCancelButtonを除いた高さ:スクロール時の考慮 -->
<table id="{$iLPgSel}" class="iLPageSel" style="height:{$tbheight}px;border-collapse:collapse;border-spacing:0;margin:-10px -2px; 0px 0px;"></table>
</div>
<button class="iLPageCan" onclick="document.getElementById('{$iLPgL}').style.display='none';" style="cursor:pointer;">Cancel</button>
</div>
EOM;
	}

/* ------------------------------------------------------------------------------------
	ArgiListIF($iListIFid,$iListIFbutton,$iListIFbutton,$iListIFMode,$iListIFDisp,$iListIFCss,$iListIFName,$iList,$iL2nd) : IndexList(iList) I/F Button
	 $iListIFid    : i  : 呼び出し用ボタン HTML;id
	 $iListIFbutton: i  : 呼び出し用ボタン id
	 $iListIFMode  : i  : NULL|1|2: 未セット時, 1 1:Bottom右に表示を使用する 2:右Function上
	 $iListIFDisp  : i  : 内蔵のI/Fボタンを利用時css Style追加 "display:none;"指定時呼び元でOn方法を実装する
	 $iListIFCss   : i  : 内蔵のI/Fボタンを利用時 NameValueのCSSを設定(文字の修飾のみ可能)
	 $iListIFName  : i  : 内蔵のI/Fボタンを利用時 NameValueを設定
	 $iList        : i  : IndexListBox:id
	 $iL2nd        : i  : IndexListBox 2nd:id
	 @return       : o  : HTML($iListIF) : 呼び出し用ボタンHTML

	※ $iListIFName:"...."(ピリオドのみの文字列)の場合はイレギュラとしてのCSSを適用する
------------------------------------------------------------------------------------- */
function ArgiListIF($iListIFid,$iListIFbutton,$iListIFMode,$iListIFDisp,$iListIFCss,$iListIFName,$iList,$iL2nd) {
	if ($iListIFMode == "2") {	// Mode= "2": 右Function上に表示
		$iListIF = <<<EOM
	<!-- IndexList Display Button -->
	<div id="{$iListIFid}" class="ovalLateral" style="position:fixed;bottom:73px;left:459px;height:53px;width:20px;background:rgba(255,250,240,0.4);{$iListIFDisp}"></div>
	<div style="{$iListIFCss}">{$iListIFName}</div>
	<div id="{$iListIFbutton}" class="ovalLateral" onclick="if (document.getElementById('{$iList}').style.display == 'block') { document.getElementById('{$iList}').style.display = 'none';document.getElementById('{$iL2nd}').style.display='none'; } else { document.getElementById('{$iList}').style.display = 'block'; }" style="position:fixed;bottom:74px;left:458px;cursor:pointer;zindex:900;"></div>
EOM;
		 }
	else {							 // Mode 1 (!= "2") : Bottom右に表示
		$iListIF = <<<EOM
	<div id="{$iListIFid}" style="position:fixed;bottom:0px;left:432px;z-index:900;{$iListIFDisp}">
		<div id="{$iListIFbutton}" class="ovalSide" onclick="if (document.getElementById('{$iList}').style.display == 'block') { document.getElementById('{$iList}').style.display = 'none';document.getElementById('{$iL2nd}').style.display='none'; } else { document.getElementById('{$iList}').style.display = 'block'; }" style="position:absolute;bottom:0px;left:0px;cursor:pointer;background:rgba(0,51,204,0.6);">
			<div class="ovalSide" style="position:absolute;bottom:0px;left:1px;height:18px;width:48px;background:rgba(0,0,128,0.6);"></div>
			<div style="{$iListIFCss}">{$iListIFName}</div>
		</div>
	</div>
EOM;
		}
	return($iListIF);
	}

/* ------------------------------------------------------------------------------------
	ArgiListIFMakeButton($iListIFMode,$iListIFid,$iListIFbutton,$iList,$iL2nd,$iListIFDisp,$iListIFName,$iListIFCss) : 呼び出しBottonデザイン作成
	 $iListIFMode  : i  : Button Design Mode 1:Botton(横) / 2Botton(縦) 省略時:1
	 $iListIFid    : i  : 呼び出し用ボタンFrame HTML;id
	 $iListIFbutton: i  : 呼び出し用ボタンHTML;id
	 $iList        : i  : IndexListBox :id
	 $iL2nd        : i  : IndexListBox(2nd):id
	 $iListIFDisp  : i  : 内蔵のI/Fボタンを利用時css Style追加 "display:none;"指定時呼び元でOn方法を実装する
	 $iListIFName  : i  : Button表示名
	 $iListIFCss   : i  : Button Style Sheet
	 @retirn       : o  : Design HTML

	 $iListIFDisp,$iListIFName,$iListIFCss省略時デフォルト(用意したパターン)
	※ 呼び出しButtunパターンを増やす場合，この関数を変更する
------------------------------------------------------------------------------------- */
function ArgiListIFMakeButton($iListIFMode,$iListIFid,$iListIFbutton,$iList,$iL2nd,$iListIFDisp,$iListIFName,$iListIFCss) {
// IndexList Display Button : 外部で"$iListIF"に呼び出しBottonデザインを設定できる。
	$iListIFName1= 'Index';$iListIFName2= '....';		// Mode1/Mode2 ButtanValuse Defult
	$iListIFCss11 ="position:absolute;bottom:9px;left:12px;height:18px;width:22px;";
	$iListIFCss11s="font-size:18px;font-weight:bold;color:#0099FF;";
	$iListIFCss12 ="position:absolute;bottom:-1px;left:12px;height:18px;width:22px;";
	$iListIFCss12s="font-size:10px;color:#4db8ff;line-height:160%;";
	$iListIFCss21 ="position:fixed;bottom:76px;left:451px;height:50px;width:20px;transform:rotate(90deg);";
	$iListIFCss21s="font-size:18px;font-weight:bold;color:#ffffff;";
	$iListIFCss22 ="position:fixed;bottom:78px;left:440px;height:50px;width:20px;transform:rotate(90deg);";
	$iListIFCss22s="font-size:10px;color:#ffffff;";

	if (!isset($iListIFMode)) { $iListIFMode=1; }		// $iListIFModeも未セット時,Bottom右に表示を使用する
	if (!isset($iListIFDisp)) { $iListIFDisp = ""; } 	// styleを設定 display:none;指定時呼び元でOn方法を実装する
	if ($iListIFDisp !== "")  { $iListIFDisp=(trim($iListIFDisp,";")).";"; }
	if ((!isset($iListIFName))||($iListIFName=="")) { if ($iListIFMode!==2) { $iListIFName=$iListIFName1; } else { $iListIFName=$iListIFName2; } }
	if ((!isset($iListIFCss)) ||($iListIFCss==""))  {	// CSSの判定
		if ($iListIFMode!==2) { if (preg_match("/\.{1,}/",$iListIFName)) { $iListIFCss =$iListIFCss11s; } else { $iListIFCss =$iListIFCss12s; } }
		else if (preg_match("/\.{1,}/",$iListIFName)) { $iListIFCss =$iListIFCss21s; } else { $iListIFCss =$iListIFCss22s; } }
	if ($iListIFMode!==2) { if (preg_match("/\.{1,}/",$iListIFName)) { $cssstr=$iListIFCss11.$iListIFCss; } else { $cssstr=$iListIFCss12.$iListIFCss; } }
	else if (preg_match("/\.{1,}/",$iListIFName)) { $cssstr=$iListIFCss21.$iListIFCss; } else { $cssstr=$iListIFCss22.$iListIFCss; }
	$iListIF=ArgiListIF($iListIFid,$iListIFbutton,$iListIFMode,$iListIFDisp,$cssstr,$iListIFName,$iList,$iL2nd);		// Make IndexList(iList) I/F Button
	return($iListIF);
	}

/* ------------------------------------------------------------------------------------
	ArgMakeCallCss() : 呼び出し用Button用図形用CSS設定
	※ 呼び出しButtunのCSSパターンを修正する場合，この関数を変更する
------------------------------------------------------------------------------------- */
function ArgMakeCallCss() {
		echo <<<EOM
<style type="text/css">
/*----- Button用図形 ------------------------------------------------------------------*/
/* 半円(右) */
.halfCircleRight { height:90px;width:45px;background:rgba(0,51,204,0.6);
	border-radius: 0 90px 90px 0;
	-moz-border-radius: 0 90px 90px 0;
	-webkit-border-radius:  0 90px 90px 0;
	}
/* 半円(左) */
.halfCircleLeft  { height:90px;width:45px;background:rgba(0,51,204,0.6);
	border-radius: 90px 0 0 90px;
	-moz-border-radius: 90px 0 0 90px;
	-webkit-border-radius: 90px 0 0 90px;
	}
/* 楕円(縦) */
.ovalLateral { height:48px;width:18px;background:rgba(0,51,204,0.6);
	border-radius: 30px / 15px;
	-moz-border-radius:30px / 15px;
	-webkit-border-radius:30px / 15px;
	}
/* 楕円(横) */
.ovalSide { height:18px;width:48px;background:rgba(0,51,204,0.6);
	border-radius: 15px / 30px;
	-moz-border-radius:15px / 30px;
	-webkit-border-radius:15px / 30px;
	}
/* 1/4円(右) */
.quarterCircleTopRight { width:50px;height:50px;border:1px solid #000;background:rgba(0,51,204,0.5);
	border-radius: 0 40px 0 0;
	-moz-border-radius: 0 40px 0 0;
	-webkit-border-radius: 0 40px 0 0;
	}
/* 1/4円(左) */
.quarterCircleTopLeft  { width:50px;height:50px;border:1px solid #000;background:rgba(0,51,204,0.5);
	border-radius: 40px 0 0 0;
	-moz-border-radius: 40px 0 0 0;
	-webkit-border-radius: 40px 0 0 0;
	}
</style>
EOM;
	}
//////////////// End Of Source /////////////////////////////////////////////////////////
?>
