<?php
/***************************************************************************************
	mpdplayer.php : mpdweb mpd HTTP Striming

	HTML Calling : http://{Address}/mpdplayer
	SubWindow    : Example :  window.open('mpdplayer.php','mpdPlayer','replace=yes,width=320,height=350');
	mpdmyset.xml : Example :mpdmyset.xmlに追加する場合の設定
					Frame	<mpdplayer-frm><name>mpdPlayer(Frame)</name>
								<url>./mpdplayer.php</url>
								<frame>Event|position:fixed;bottom:50px;left:156px;width:321px;height:350px;border: 1px solid #696969;z-index:99;</frame>
								<close><name>Close</name><style>position:fixed;bottom:86px;left:410px;width:48px;height:20px;border:1px solid #696969;background-color:#c0c0c0;font-size:12px;color:#000000;text-align:center;line-height:180%;z-index:100;-moz-border-radius:4px;-webkit-border-radius:4px;border-radius: 4px;cursor:pointer;</style></close>
							</mpdplayer-frm>
					Windows	<mpdplayer-wind><name>mpdPlayer(Wind)</name>
								<url>./mpdplayer.php</url>
							<window>'mpdPlayer','left='+(window.screenX+100)+',top='+(window.screenY+400)+',replace=yes,width=320,height=350'</window>
							</mpdplayer-wind>

	mpd.conf Streaming : Example :
							 audio_output {
								type "httpd"		# HTTP Streaming
								name "HTTP Server"
								port "8000"			# Port
								encoder "lame"		# Encode or ogg
								bitrate "320"
								tags "yes"
								always_on "yes"
								format "44100:16:2"
								}
	※Internetから再生はできない。
	  公開Server上で{mpd Address}:8000をBridgeするアプリを作成し，Portを開放すれば良いが様々な点より対応予定なし。

設定XMLを作成時のサンプル:setting/mpdplay.xml
****************************************************************************************
<?xml version="1.0" encoding="UTF-8"?>
<mpdplay.php>
<Html_config>
	<lang>ja</lang>														<!-- lang設定 -->
	<favicon>rel="shortcut icon" href="./mpdwebfavicon.ico"</favicon>	<!-- faviconの設定 -->
</Html_config>
<AUDIO>
	<DEVICE>HTTP</DEVICE>			<!-- Streaming Device:指定文字列を含む DeviceName(MoOdeAudioはこの名称) -->
	<PORT>8000</PORT>				<!-- HTTPStreaming Port -->
</AUDIO>
<PLAYAUDIO>
	<VOLUME>0.5</VOLUME><!-- VOLUME(Range)の刻み-->
</PLAYAUDIO>
<UnlockTIMER>
	<UnlockInit>2</UnlockInit>		<!-- 起動時Play切り替えmSec:Test結果:Min:2 -->
	<UnlockPAUSE>1000</UnlockPAUSE>	<!-- PauseからStartの切り替えmSec:Test結果:Min:1000 -->
	<UnlockSTOP>3000</UnlockSTOP>	<!-- StopからStartの切り替えmSec:Test結果:Min:3000 -->
	<WaitSTART>10</WaitSTART>		<!-- 初期停止からStartまで監視Min(分) 1回Playになれば途中で，クリアしても動作する(?) -->
</UnlockTIMER>
<Exit>
	<OUTPUT>disableoutput</OUTPUT>	<!-- Exit:Output:disableoutput(終了時:Off)/enableoutput(終了時:On)/restore(起動時にする)/ -->
</Exit>
</mpdplay.php>

***************************************************************************************/
$MPDWEB_BASE="mpdweb";
$require_lib=dirname(__FILE__).'/'.$MPDWEB_BASE.'.lib.php';		// Mpd XML Library Default
if  (file_exists(dirname(__FILE__)."/".basename(__FILE__,".php").".lib.php")) {		// Mpd XML Library mpd{module}.lib.phpの存在確認
	$require_lib=dirname(__FILE__)."/".basename(__FILE__,".php").".lib.php";
	}
require_once($require_lib);					// Mpd XML Library mpd{module}.lib.php
$require_mpd=dirname(__FILE__).'/'.$MPDWEB_BASE.'.lib_mpd.php';

$require_ses=dirname(__FILE__).'/mpdcmnses.lib.php';	// Mpd Session id Library
if  (file_exists($require_ses)) {						// Mpd Session id Libraryの存在確認
	require_once($require_ses);							// Mpd Mpd Session id Library
	}
$SESSION_CONF=GetSessionConfig();						// $XML_MPDLIBを判定する(GetEnvCommon経由)
ArgSessionStart($SESSION_CONF);							// Start Session : Used mpdcmnses.lib.php

if  (file_exists(dirname(__FILE__)."/".basename(__FILE__,".php").$XML_MPDLIB)) {	// Mpd Library  $XML_MPDLIBの存在確認
	 $require_mpd=dirname(__FILE__)."/".basename(__FILE__,".php").$XML_MPDLIB;	
	 }
else if ((false !== strpos($XML_MPDLIB,"lib_mpdshm")) &&(file_exists(dirname(__FILE__).'/'.$MPDWEB_BASE.'.lib_mpdshm.php'))) {
	 $require_mpd=dirname(__FILE__).'/'.$MPDWEB_BASE.'.lib_mpdshm.php';
	 }
require_once($require_mpd);								// mpd{module}.lib_mpd.php / mpd{module}.lib_mpdshm.php
///////////////////////// Library End ///////////////////////////////////////////////////
$PLAYER_VER=basename(__FILE__,"")." 0.91 (30.11.2024)";
$CMN_RESULT=GetEnvCommon();
get_libinit();
$Net = new Net_Common;
$tout=array("PostTimeout"=>0,"ConnectTimeout"=>4);		// Timeoutは局面で変える可能性かあるので共通化としていない
$no=get_config("Net_Timeout",$tout);
if ($no != 0) {
	$Net->timeout=$tout["PostTimeout"];					// Usind Post Timeout
	$Net->c_timeout=$tout["ConnectTimeout"];
	}
get_config("Mpd_net",$Net->p_connect);					// Net_Common Property mpdconfig.xmlから設定
if (!$Net->connect()) {
	msglog($Net->p_error."\n");
	}

if (isset($_POST["p"])) {
	 PostMpdState();
	 }
else {
	 $GHOST=$Net->p_connect['host'];
	 if(stripos($GHOST,"localhost") !== false){			// localhost時自Serverにmpdがあるとする
		$GHOST=$_SERVER["SERVER_ADDR"];
	 	}
	 $GSTRMING="http://".$GHOST.":".$XML_AUDIO["PORT"];
	 DispAudio($GHOST,$GSTRMING);
	 }
mpd_close();

/* -----------------------------------------------------------------------------
	GetSessionConfig() : php Session Config
	 @return: o  : $SESSION_CONF Session Array
----------------------------------------------------------------------------- */
function GetSessionConfig() {
	global $XML_CONF;

	$ret="";
	GetEnvCommon();
	ignore_user_abort(false);							// 切断時終了
	$SESSION_CONF=array("sesion_id"=>"mpdweb","href_waitmsec"=>"50","maxlifetime"=>"1440");
	get_config("php_session",$SESSION_CONF);			// php config php_session
	$SESSION_CONF=ArgSessionConf($SESSION_CONF);		// mpdweb:Session id 作成 : Used mpdcmnses.lib.php
	return($SESSION_CONF);
	}

/* -----------------------------------------------------------------------------
	GetEnvCommon(): Load setting/mpdconfig.xml
	 @return: o  : "":Normal !="":ErrorMessage
----------------------------------------------------------------------------- */
function GetEnvCommon() {
	global $XML_CONF,$XML,$XML_SHMUSE,$XML_MPDLIB,$C_SERVERMD,$C_CALLBACK,$C_STOUT,$C_ERSTR;
	global $XML_AUDIO,$XML_PLAYAUDIO,$XML_UNLOCK,$XML_EXIT,$HTML_CONFIG,$MPDWEB_BASE;

	$ret="";
	$XML_File = "setting/mpdconfig.xml";
	try {
		$XML_CONF = get_loadconfig($XML_File);				// XML File Get FileNameはLibrary標準
		} catch( Exception $e ) {
	  $ret=$XML_File.':'.$e->getMessage();
	  }
	$XML_SHMUSE=array("Used"=>"off");get_config("Shm_Project",$XML_SHMUSE);
	if (strcasecmp($XML_SHMUSE["Used"],"Off") == 0) {		// Not Used Shared Memory
		 $XML_MPDLIB=".lib_mpd.php";						// mpd{module}.lib_mpd.php
		 }
	else {
		 $XML_MPDLIB=".lib_mpdshm.php";						// mpd{module}.lib_mpdshm.php
		 }
	$POST_MOD='./'.$MPDWEB_BASE.'.php';
	$C_SERVERMD="RequestByPost('".$POST_MOD."','%p1%',%Callback%);";			// onclickなどJavaScript Server起動モジュールリンク %p1%:入力の取得オブジェクト{form}:{name} %p1%:表示エリア名(Std) , $_SERVER['PHP_SELF']:module,%p1%:item,%p2%:message_id,%Callback%:callback,callback_char,callback2,errchar
	$C_CALLBACK="function () { %func% }";$C_STOUT="status";$C_ERSTR="ERR";		// Callback形式 $C_STOUT:JavaScript 実行後復帰表示エリア名 $C_ERSTR:ERR時の文言
	$XML_PLSCONF=array();
	$XML_Play="setting/mpdplay.xml";
	if (file_exists($XML_Play)) {
		try {
			$XML_PLSCONF=get_loadxml($XML_Play);
			} catch( Exception $e ) {
		  $ret=$XML_Play.':'.$e->getMessage();
		  }
		}
	$HTML_CONFIG=array("lang"=>"ja","favicon"=>"rel=\"shortcut icon\" href=\"./mpdwebfavicon.ico\"");
	get_confxml($XML_PLSCONF,"Html_config",$HTML_CONFIG);				// php config
	$XML_AUDIO=array("DEVICE"=>"HTTP","PORT"=>"8000");							// Streaming Device:指定文字列を含む DeviceName
	get_confxml($XML_PLSCONF,"AUDIO",$XML_AUDIO);
	$XML_PLAYAUDIO=array("VOLUME"=>"0.4");										// PLAY Audio
	get_confxml($XML_PLSCONF,"PLAYAUDIO",$XML_PLAYAUDIO);
	$XML_UNLOCK=array("UnlockInit"=>"2","UnlockPAUSE"=>"1000","UnlockSTOP"=>"3000","WaitSTART"=>"10");				// PLAY Audio UnlockTimer
	get_confxml($XML_PLSCONF,"UnlockTIMER",$XML_UNLOCK);
	$XML_EXIT=array("OUTPUT"=>"disableoutput");				// Exit:Output:disableoutput/enableoutput/restore/''
	get_confxml($XML_PLSCONF,"Exit",$XML_EXIT);
	if (($XML_EXIT["OUTPUT"] !="")&&($XML_EXIT["OUTPUT"] !="disableoutput")&&($XML_EXIT["OUTPUT"] !="enableoutput")&&($XML_EXIT["OUTPUT"] !="restore")) {
		$XML_EXIT["OUTPUT"]="";
		}
	return($ret);
	}

/* *****************************************************************************
	DispAudio($Host,$Source) : Make Display AudioPayer HTML
	 $Host  : i  : mpd Host
	 $Source: i  : httpd Streaming Source
***************************************************************************** */
function DispAudio($Host,$Source) {
	global $Net,$C_SERVERMD,$C_CALLBACK,$C_STOUT,$C_ERSTR,$PLAYER_VER,$CMN_RESULT;
	global $XML_AUDIO,$XML_PLAYAUDIO,$XML_UNLOCK,$XML_EXIT;			// Streaming Device:指定文字列を含む DeviceName

	$AUDIO_WIDTH=280;$HOST_WIDTH=$AUDIO_WIDTH-13;$CLOSE_LEFT=$AUDIO_WIDTH-50;
	$UNLOAD="window.close();";
	DispAudioHeader();
echo <<<EOM
<!-----------------------------------------------------------------------------
 HTML Body
------------------------------------------------------------------------------>
<body style="background-color: #000000;color:#ffffff;">
<div class="subWin" style="position:fixed;top:4px;left:20px;">
	<div class="subTxt" style="top:6px;left:18px;width:{$HOST_WIDTH}px;">{$Source}</div>
	<div class="subWin" style="top:60px;left:20px;">
<!--	<audio controls="" id="idAudio" src="" autoplay="" preload="auto" name="media"></audio>-->
		<audio id="idAudio" src=""></audio>
		<button id="idPlayback" class="subPly" onclick="togglePlayback()" style="color:#000000;">Play/Pause</button>
		<div class="subTit" style="top:56px;left:120px;font-size:10px;">Volume&nbsp;&nbsp;-</div>
		<input type="range" min="0" max="1" step="0.1" value="{$XML_PLAYAUDIO["VOLUME"]}" onchange="setVolume(this.value)" class="subReg" style="top:55px;left:170px;"><!--  初期ボリュームSet value="0.5" -->
		<div class="subTit" style="top:58px;left:286px;font-size:10px;">+</div>
		<div class="subTit" style="top:82px;left:28px;color:#dcdcdc;font-size:10px;">* Click the "Play/Pause" button to play.</div>
	</div>
EOM;
	$arg=array();	$command="outputs";									// mpd Get,Output
	$output=$Net->runCommand($command,$arg,1,1);
	if (!is_array($output)) {
		$errmsg='Output No Selected !!';
		print '<div class="subTit" style="top:100px;left:24px;font-size:14px;color:#f08080;">'.$errmsg.'</div>';
		if ($output !== 1) {
			print '<div class="subTit" style="top:120px;left:24px;font-size:14px;color:#f08080;">'.$output.'</div>';
			}
		print '<input type="button" name="Submit" class=subCls value="Close" onclick="'.$UNLOAD.'" style="bottom:20px;left:'.$CLOSE_LEFT.'px;" />';
		print '</div>';
		return;
		}
	print '<div class="subTit" style="top:110px;left:24px;">Audio Device</div>';
	print '<input type="button" id="idPNowMusic" name="Submit" class=subCls value="NowMusic" onclick="EventnowMusic();" style="top:107px;left:224px;height:20px;background-color:#00008b;border:solid 4px #191970;font-size:10px;color:#b0c4de;display:none" />';
	print '<div class="subTDv">';
	print '<table border="1" cellpadding="0"frame=void class="subTbl">';
	$top=0;
	$outkey=array_keys($output);
	$DEVICE_NO="";$DEVICE_ENABLE=0;$DEVOutput="";
	foreach($output[$outkey[0]] as $i => $idx) {
		print '<tr>';
		$checked='';
		$str="0";
		if ((isset($output['outputenabled'][$i]))&&($output['outputenabled'][$i] == "1")) {
			 $str="1";
			 $checked='checked="checked"';
			 }
		if (($DEVICE_NO=="")&&(strpos($output['outputname'][$i],$XML_AUDIO["DEVICE"]) !== false)){		// Streaming Device
			$DEVICE_NO=$i;
			if ($str=="1") {													// Streaming Device:On
				$DEVICE_ENABLE="1";
				}
			}
		$top=$top+32;
		$str=$output['outputid'][$i]+1;
		$post = str_replace('%p1%',"p=cmd&f='+outcmd+'&'+outcmd+'=".$output['outputid'][$i],$C_SERVERMD);	// Function Audio Device: mpd:Play→(This)Play
		if ($DEVICE_NO==(string)$i) {											// Striming:Callback作成
			 $post2nd=str_replace('%p1%','p=cmd&f=play',$C_SERVERMD);				// CallBack(2) Function :Post mpd:Play

			 $func2 ="EventnowMusic();";
			 $func2 =str_replace('%func%',$func2,$C_CALLBACK);						// Enableにした場合, CallBack(2)設定
			 $post2nd= str_replace('%Callback%',$func2,$post2nd);					// Callback設定

//			 $post2nd=str_replace('%Callback%',"''",$post2nd);						// Callback(2) 設定
			 $func ="if (outcmd=='enableoutput') { ".$post2nd."RePlayback(); } else { RePause(); }";
			 $func =str_replace('%func%',$func,$C_CALLBACK);					// Enableにした場合, CallBack(2)設定
			 $post = str_replace('%Callback%',$func,$post);						// Callback設定
			 }
		else {
			 $post = str_replace('%Callback%',"''",$post);						// Striming以外,Callbackなし
			 }
		if ($DEVICE_NO==(string)$i) { $color="color:#00ff7f;"; } else { $color=""; }
		print '<td style="width:20px;text-align: center"><div style="font-size:12px;font-weight:bold;'.$color.'">'.$str.'</div></td>';
		print '<td style="width:150px;"><div style="overflow:hidden;font-size:12px;font-weight:bold;'.$color.'">'.(mb_strimwidth($output['outputname'][$i],0,20)).'</div></td>';
		print '<td style="width:20px;text-align: center"><input id="output'.$i.'" type=checkbox value="'.$str.'" '.$checked.' onClick="this.blur();this.focus();" onChange="outcmd='."'disableoutput'".";if (this.checked != '') { outcmd='enableoutput'; }".$post.';" class="subChk"></td>';
		print '</tr>';
		}
	print '</table>';
	print '</div>';
	if($CMN_RESULT != "") {											// GetEnvCommon()のError
		print '<div class="subTit" style="bottom:74px;left:27px;font-size:10px;line-height:96%;color:#b22222;">'.$CMN_RESULT.'</div>';
		}
	print '<div class="subTit" style="bottom:54px;left:27px;font-size:10px;">No consideration for exclusive use</div>';
// 終了時JS
	if (($DEVICE_NO !="")&&($XML_EXIT["OUTPUT"] !="")) {			// Deviceがあり，有効でないとき
		 if ($XML_EXIT["OUTPUT"]=="restore") {									// 起動時に戻す
			 if ($DEVICE_ENABLE=="1") {
					 $out="enableoutput";									// Status:Save
					 }
				else {
					 $out="disableoutput";
					 }
			  }
		 else {
			  $out=$XML_EXIT["OUTPUT"];
			  }
		 $post = str_replace('%p1%','p=cmd&f='.$out.'&'.$out.'='.(string)$DEVICE_NO,$C_SERVERMD);		// Post Streaming Device:off
		 $func=str_replace('%func%','EventnowMusic();window.close();',$C_CALLBACK);								// CallBack : WindowClose
		 $post = str_replace('%Callback%',$func,$post);							// Callback設定				// 同じ方向には更新しない
		 $post = "var repout='".$out."';var devout=document.getElementById('output".(string)$DEVICE_NO."');if (((devout.checked != '')&&(repout=='disableoutput'))||((devout.checked == '')&&(repout=='enableoutput'))) { ".$post." } else { ".$UNLOAD." }";
		 $CLOSE_JS=$post;
		 }
	else {
		 $CLOSE_JS=$UNLOAD;
		 }
echo <<<EOM
	</div>
<input type="button" id="idClose" name="Submit" class=subCls value="Close" onclick="{$CLOSE_JS}" style="bottom:36px;left:{$CLOSE_LEFT}px;display:block;" />
<div class="subTit" style="bottom:20px;left:138px;font-size:9px;color:#c0c0c0">{$PLAYER_VER}</div>
<textarea cols="56" rows="1" readonly id="status" class="subSts"></textarea>
</div>

EOM;
// 起動時JS
	$result=PostMpdState("proc");
	if ((isset($result["state"][0]))&&(($result["state"][0]=="pause")||($result["state"][0]=="start"))) {
		 print '<div class="subTit" id="idWarning" style="bottom:34px;left:24px;color:#800000;"></div>';
		 $sleep=$XML_UNLOCK["UnlockInit"];									// Min2Sec
		 }
	else {
		 print '<div class="subTit" id="idWarning" style="bottom:34px;left:24px;color:#cd5c5c;">*Playback delay('.($XML_UNLOCK["UnlockSTOP"]/1000).'Sec)*</div>';
		 $sleep=$XML_UNLOCK["UnlockSTOP"];									// 停止からのStart状態は遅い:Test結果:Min:3000
		 }
	if (($DEVICE_NO !="")&&($DEVICE_ENABLE==0)) {								// Deviceがあり，有効でないとき Device:Enable→mpd:Play→(This)TimerPlay
		 $post = str_replace('%p1%','p=cmd&f=enableoutput&enableoutput='.(string)$DEVICE_NO,$C_SERVERMD);	// Post Streaming Device:On
		 $callback = str_replace('%p1%','p=cmd&f=play',$C_SERVERMD);										// CallBack(1):Post mpd:Play
		 $func2nd="document.getElementById('output".(string)$DEVICE_NO."').checked=true;";						// HTML Streaming Device:Cheack
		 $func2nd=$func2nd."initPlayback(".$sleep.");";						// HTML Streaming Play
		 $func2nd=str_replace('%func%',$func2nd,$C_CALLBACK);
		 // Callback実行Post関数のCallback
		 $callback = str_replace('%Callback%',$func2nd,$callback);				// Callback(2)設定
		 $func=str_replace('%func%',$callback,$C_CALLBACK);
		 $ONLOAD = str_replace('%Callback%',$func,$post);						// Callback(1)設定
		 }
	else if ($DEVICE_NO !="") {												// Deviceがあり，有効のとき mpd:Play→(This)TimerPlay
		 $post = str_replace('%p1%','p=cmd&f=play',$C_SERVERMD);				// Post Streaming Play
		 $func="initPlayback(".$sleep.");";										// HTML Streaming Play
		 $func=str_replace('%func%',$func,$C_CALLBACK);
		 $ONLOAD = str_replace('%Callback%',$func,$post);						// Callback(1)設定
		 }
	else {
		 $ONLOAD = "";
		 }
	$post = str_replace('%p1%','p=cmd&f=play',$C_SERVERMD);					// Post Streaming Play mpd:Play→(This)TimerPlay
	$func="initPlayback(ReSleep);";												// HTML Streaming Play
	$func=str_replace('%func%',$func,$C_CALLBACK);
	$ReSLEEP = str_replace('%Callback%',$func,$post);							// Callback(1)設定
echo <<<EOM

<script>
/* -----------------------------------------------------------------------------
 	Java Script Direct Open:noDisplay:Close / Window.open:Display:Close
----------------------------------------------------------------------------- */
var isWindowOpened = window.opener != null;
if (isWindowOpened) {
	 }
else {
	 document.getElementById("idClose").style.display = "none";
	 }

/* -----------------------------------------------------------------------------
 	Load/unLoad
----------------------------------------------------------------------------- */
window.addEventListener("load", (event) => {
	{$ONLOAD};
	});

window.addEventListener('beforeunload', function(e) {
	{$CLOSE_JS}
	});

window.addEventListener('message', function(event) {
var str=event.data;
	if (str.indexOf('close') >=0) {
		{$CLOSE_JS}
		var id = str.split('close:');
		parent.document.getElementById(id[1]).style.display = 'none';
		}
	});

/* -----------------------------------------------------------------------------
 	initPlayback(sleep) : Java Script Function (This)Timer Play
	sleep : i  : Sleep Time msec 1Sec:1000 (未設定:1000)
----------------------------------------------------------------------------- */
var Audio    = document.getElementById('idAudio');
var Playback = document.getElementById('idPlayback');
var Warning  = document.getElementById('idWarning');
var GCOUNT =0;												// mpd:Startの監視Counter
var UnLockStop ={$XML_UNLOCK["UnlockSTOP"]};				// Stop →Start:Test結果:Min:3000
var UnLockPause={$XML_UNLOCK["UnlockPAUSE"]}				// Pause→Start:Test結果:Min:1000
var ReSleep    ={$XML_UNLOCK["UnlockSTOP"]};				// STOP解除を採用
var GWLOOP     ={$XML_UNLOCK["WaitSTART"]}*60*1000/ReSleep;	// 設定(Min)を回数にする
var ReFunc= function(value) {	// Function:value;status	// 1回Playになれば途中で，クリアしても動作する(?)
	if (value=="stop") {									// 状態でEventがLoopしなくなるのを防止
		if (GCOUNT < GWLOOP) {
			GCOUNT=GCOUNT+1;
			Warning.textContent="* MPD Status:Stop,Re:Start";
			Audio.setAttribute('src','');				// mpd cmd:Play Function
			{$ReSLEEP}
			}
		}
	}
// Init:Proc : initPlayback(sleep) : sleep;msec
function initPlayback(sleep) {
	if (sleep == null) { sleep=1000; }
		setTimeout(function() {
			callPhpFunction("status",ReFunc);				// Callbackで Stop時，Retry
			Audio.setAttribute('src','{$Source}');			// mpd Status判定にレスポンスが発生するのでPlayにしてみる。
			initPlaybackOn();
			Audio.play();
			}
		,sleep);
	}

/* -----------------------------------------------------------------------------
 	initPlaybackOn() : Load後,Play/Pauseの状態を設定
	window.openの場合，起動時再生するが，URLで直接開いたとき再生しないので状態判定
----------------------------------------------------------------------------- */
function initPlaybackOn() {
	setTimeout(function() {
		if (Audio.paused) {
			 Playback.style.backgroundColor = "";
			 Playback.style.color = "";
			 }
		else {
			 Playback.style.backgroundColor = "#00A497";
			 Playback.style.color = "#ffffff";
			 EventnowMusic();
			 }
		}
		,10)
	}

/* -----------------------------------------------------------------------------
 	RePlayback() : (This) Re:PlaySet
----------------------------------------------------------------------------- */
function RePlayback() {
	Audio.setAttribute('src','');
	var func=function(value) { if ((value=="pause")||(value="start")) { var sec=UnLockPause; } else { var sec=UnLockStop; } initPlayback(sec); }
	callPhpFunction("status",func);
	}

/* -----------------------------------------------------------------------------
 	RePause() : (This) Re:PauseSet
----------------------------------------------------------------------------- */
function RePause() {
   	Audio.pause();
	Playback.style.backgroundColor = "";
	Playback.style.color = "";
	}

/* -----------------------------------------------------------------------------
 	Java Script Event Playback/ Volume
----------------------------------------------------------------------------- */
function togglePlayback() {				// Button:Play/Pause
	if (Audio.paused) {
		Audio.play();
		Playback.style.backgroundColor = "#00A497";
		Playback.style.color = "#ffffff";
	} else {
    	Audio.pause();					// Volube RendgeButton:Play/Pause
		Playback.style.backgroundColor = "";
		Playback.style.color = "";
   		}
	}

function setVolume(volume) {			// range:volume
	Audio.volume = volume;
	}

function EventnowMusic() {				// parentWin:NowMusicButtonClick(親最新化)
	if(!window.opener || window.opener.closed){ // SubWundowからMainWindowをチェック
		var parentWin = window.parent.document.getElementById("idNowMusic");	// iframeの場合のidを取得
		if (parentWin) {
  		  parentWin.click();
		  }
		return;
		}
	var parentWin=window.opener.document.getElementById("idNowMusic");	//親Window取得
	if(parentWin == null) {
		return;
		 }
	parentWin.click()
	}

/* -----------------------------------------------------------------------------
	callPhpFunction(para,callback) : (This) PHP Exec Function
	 para      : i  : PHP Function
	 callback  : i  : Calback Function
	※StanderdOut:"state"が含まれればCalbac引数にする。
	  state={Value};
----------------------------------------------------------------------------- */
function callPhpFunction(para,callback) {
	var xhr = new XMLHttpRequest();						  		// Ajaxリクエストを作成
	xhr.open("POST","{$_SERVER['PHP_SELF']}",true);				// PHPスクリプトのURLを指定
	xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
	xhr.onreadystatechange = function() {						// リクエスト完了時の処理
		if (xhr.readyState == 4 && xhr.status == 200) {			// レスポンスを処理
			var response = xhr.responseText;
			console.log(response);
			response.split(";").forEach(function(item) {		// 取得結果処理
		    	var pair = item.split("=");		    // =で分割し、キーと値を取得
		    	var key = pair[0];
		    	var value = pair[1];
				if(key=="state") {
					document.getElementById('idWarning').textContent="";
//					alert(value);
					if (callback != null) { callback(value); }
					}
				});
			}
		};
	xhr.send('p=' + para);										// リクエスト送信
	}

</script>

EOM;

echo <<<EOM
</body>
</html>
EOM;
	}

/* *****************************************************************************
	DispAudioHeader() : Make HTML Header
***************************************************************************** */
function DispAudioHeader() {
	global $HTML_CONFIG;				// lang/favicon

	$jslibajax="./mpdweb.libcajax.js";
	$dateform="";
	if (file_exists($jscommon)) {
		$date = new DateTime();
		$date->setTimestamp(filemtime($jslibajax));
		$dateform=$date->format('YmdHis');
		$dateform="?a=".$dateform;
		}
echo <<<EOM
<!DOCTYPE html>
<html lang="{$HTML_CONFIG["lang"]}">
EOM;
if ($HTML_CONFIG["favicon"] !== "") {
	print '<link '.$HTML_CONFIG["favicon"].'>';
	}
$Tbl_Height='130';					// Output Tableの高さ
echo <<<EOM
<head>
<title>HTTP:MPDPlayer</title>
</head>
<script type="text/javascript" src="{$jslibajax}{$dateform}"></script>

<style type="text/css">
/*----------------------------------------------------------------------------
 HTML Style
---------------------------------------------------------------------------- */
audio { width:{$AUDIO_WIDTH}px;height:20px; }
.subWin { position:fixed; }
.subTxt { position:fixed;background-color:#0b0b33;color:#ffffff;border:3px groove #636363;border-radius:4px;font-size:13px;height:20px;padding:5px 0px 0px 10px; }
.subBtn { position:fixed;width:70;height:25px; }
.subTit { position:fixed;font-size:13px; }
.subTDv { position:fixed;top:130px;width:280px;height:{$Tbl_Height}px;overflow-y:scroll;overflow-x:hidden; }
.subTDv::-webkit-scrollbar { width: 10px; }					/* スクロールバー全体 */
.subTDv::-webkit-scrollbar-track { background: #1c1c1c; box-shadow: inset 0 0 1px #2e2e2e; }	/* スクロールバー背景 */
.subTDv::-webkit-scrollbar-thumb { background: #2f4f4f; }		/* スクロールバーつまみ */
.subTbl { position:relative;width:270px;max-height:{$Tbl_Height}px }
.subTbl td { height: 26px; }
.subReg { position:fixed;width:110px;cursor: pointer;appearance:none;height:13px;background-color:#505050;border-radius:3px; }
.subPly { position:fixed;top:50px;border-style:none;width:90px;height:25px;padding:2px 0 2px;font-size:14px;cursor:pointer;-moz-border-radius:4px;-webkit-border-radius:4px;border-radius: 4px;border:1px solid #556b2f; }
.subChk { cursor:pointer; }
.subCls { position:fixed;border-style:none;width:70px;height:25px;padding:2px 0 2px;font-size:11px;cursor:pointer;-moz-border-radius:4px;-webkit-border-radius:4px;border-radius: 4px;border:1px solid; }
.subSts { position:fixed;bottom:0px;left:0px;background-color:#242424;color:#ffffff;font-size:9px;border:none; }
</style>

EOM;

	}

/* *****************************************************************************
	PostMpdState($mode) : Make HTML Header
	 $mode  : i  : 実行モード "post":Postで実行 / proc(!=post):PHPで関数として実行
	 @return: o  : 実行モード Procの場合 状態 Output Array
	 実行モード "post"時は,Standard Out {key}={Value};の形式
***************************************************************************** */
function PostMpdState($mode="post") {
	$field=array("volume","state","song","elapsed_sec","elapsed");
	$output=mpd_status($field);
	if ($mode!="post") {
		return($output);
		}
	if ((!is_array($output))||(!isset($output["state"]))) {		// Timeout Out 0件
		 print "Error=".$output.";";
		 }
	else {
		 foreach($output as $key => $val) {
			if (isset($val[0])) {
				print $key."=".$val[0].";";
				}
			}
		 }
	}
//----- Source End --------------------------------------------------------------

?>
