<?php
/***************************************************************************************
	mpdweb.list.setting.php : mpdweb 拡張 ListArt Setting
	起動)
	  mpdweb.list.setting.php        : Edit LISTART_Order
	  mpdweb.list.setting.php?p=conf : XML Editer
	※mpdxmlupdate.lib.phpは，同一Tagを許可し設定位置(定義順)を指定し更新するためI/Fが使用できない。
	  そのため内部でXMLを更新しているため共通Laibraryを使用していない
/************************************************************************************* */
$BASENAME=basename(__FILE__);							// テスト時basenameを一連モジュール合わせて実行可能にしておく
$ary=explode(".",$BASENAME);
$origin=$ary[0];										// OriginName:"mpdweb"
$MPDWEB=$origin.".php";									// $MPDWEB:"mpdweb.php":標準
if (!isset($ary[1])) { $ary[1]="list"; }
$MPDWEBLISTART=$ary[0].".".$ary[1].".php";				// $MPDWEBLISTART:"mpdweb.list.php":標準

$require_lib=dirname(__FILE__).'/'.$origin.'.lib.php';		// Mpd XML Library Default
if  (file_exists(dirname(__FILE__)."/".basename(__FILE__,".php").".lib.php")) {		// Mpd XML Library mpd{module}.lib.phpの存在確認
	$require_lib=dirname(__FILE__)."/".basename(__FILE__,".php").".lib.php";
	}
require_once($require_lib);					// Mpd XML Library mpd{module}.lib.php
$require_appli_lib=dirname(__FILE__).'/mpdweb.lib_appli.php';								// mpd Application Library アプリケーション層
if  (file_exists(dirname(__FILE__)."/".basename(__FILE__,".php").".lib_appli.php")) {		// Mpd XML Library mpd{module}.lib_appli.phpの存在確認
	$require_appli_lib=dirname(__FILE__)."/".basename(__FILE__,".php").".lib_appli.php";
	}
require_once($require_appli_lib);						// Mpd Application Library mpd{module}.lib.php
// 本設定は，Sessionは同じ必要としないが,起動中Sessionを継続しておく。
$require_ses=dirname(__FILE__).'/mpdcmnses.lib.php';	// Mpd Session id Library ※ mpdtask.if.lib.phpより先にrequireすること
if  (file_exists($require_ses)) { require_once($require_ses); }	// Mpd mpdcmnses.lib.phpの存在確認&require
$SESSION_CONF=GetSessionConfig();								// mpdtask.if.lib.php:$XML_MPDLIBを判定する(GetEnvCommon経由)
ArgSessionStart($SESSION_CONF);									// Start Session : Used mpdcmnses.lib.php

$MY_LISTARTVERSION=basename(__FILE__,"")." 0.92 (01.03.2025)";

// ※ $DEBUG= 2 ケースにより,ファイルアウトに掛かる負担でTimeoutがあり得ることに注意。Art切り替えを繰り返すときなど
$DEBUG= false;	// flase 1:msg 2:logout 3:User
//$DEBUG= 2;  	// false 1:msg 2:logout 3:User // 2:にするときは、Directory Permissionを書き込み許可にすること。
//$DEBUG= 3;  	// false 1:msg 2:logout 3:User
get_libinit();
$result=GetXMLSetting();
if ($result !="") {
	DispMsgBox("on","ERROR",60,60,"Message");
	}

/***************************************************************************************
	mpdweb.list.setting.php Post Proc
***************************************************************************************/

if (isset($_POST['p'])) {
	ArgAnalyze($_POST,$ARG);
	if($_POST['p']=="getdir") {				// Get Directory BOX
		 PostGetdir();
		 }
	else if($_POST['p']=="PutOder") {		// Order File Create/Update
		 PostPutOder();
		 }
	else if($_POST['p']=="RemoveOder") {	// Order File Remove
		 PostRemoveOder();
		 }
	else if($_POST['p']=="MoveOder") {		// Order File Move
		 PostMoveOder();
		 }
	else if($_POST['p']=="Myset") {			// Sumple FileCopy
		 PostMakeMyset();
		 }
	exit;
	}

/* -----------------------------------------------------------------------------
	PostGetdir() : Make Directory List
	dir={Path}&top={WebRoot}&select={SelectFile/Directory}
----------------------------------------------------------------------------- */
function PostGetdir() {
	global $ARG,$XML_WEBROOTBASE;

	$WebRoot=str_replace("%DOCUMENT_ROOT%",$_SERVER['DOCUMENT_ROOT'],$XML_WEBROOTBASE["WebRoot"]);		// %DOCUMENT_ROOT%を実際のPathに変換
	$target=rtrim($ARG["top"],"/")."/".$ARG["dir"];
	$path=str_replace($XML_WEBROOTBASE["WebRoot"],$WebRoot,$target);									// RequestのDirectoryを実際のPathに変換
	$dirlist = glob(rtrim($path,"/").'/*', GLOB_ONLYDIR);											// Directory List
	$sel=$ARG["select"];
	print "idEditDirSel:";
	print '<div class="box ListArtDir" id=idEditDirSel style="position:absolute;top:51px;left:10px;width:444px;height:218px;">';					// Combo:WebRoot
	print '<table border="0" cellpadding="0" frame=void class=ListArtDirTb style="padding: 4px 0 0 4px;display:block;">';
	$post='var dir=document.getElementById(\'idEditDir\').innerText;var top=document.getElementById(\'idEditTop\').value;';
	$post=$post.'dir=RequestB64Encode(dir);top=RequestB64Encode(top);';																						// B64Encoder
	$post=$post.'var tag=document.getElementById(\'idEditTag\').innerText;RequestByPost(POSTMOD,\'p=getdir&dir=\'+dir+\'&top=\'+top+\'&tag=\'+tag);';		// Post String
	if (($ARG["dir"] !== "")&&($ARG["dir"] !== "/")) {
		$ary=explode("/",rtrim(trim($ARG["dir"],"/"),"/"));											// Return, Directorry
		unset($ary[count($ary)-1]);
		$target_dir=implode ("/",$ary);
		$select ='document.getElementById(\'idEditDir\').innerText=\''.$target_dir.'\';';
		$select =$select.$post;
		print '<tr><td onclick="'.$select.'" class=ListArtDirDt style="width:440px;">';
		if ($target_dir !=="") { $str='&nbsp;['.$target_dir.']'; } else { $str=""; }
		print '..'.$str;
		print '</td></tr>';
		}
	foreach ($dirlist as $val) {
		$ary=explode("/",$val);
		$target_dir=$ary[count($ary)-1];
		$select ='document.getElementById(\'idEditDir\').innerText=\''.(rtrim($ARG["dir"],'/')).'/'.(trim($target_dir,'/')).'\';';		// Directory Combo Select Event
		$select =$select.$post;
		$style="";
		if($sel==$target_dir) {
			$style="background-color:#00bfff;color:#000000;";
			}
		print '<tr><td onclick="'.$select.'" class=ListArtDirDt style="width:440px;'.$style.'">';
		print $target_dir;
		print '</td></tr>';
		}
	if($ARG["tag"]=="LinkText") {										// LinkTextはTextFileまでSelect
		foreach(glob(rtrim($path,"/").'/{*.txt}',GLOB_BRACE) as $val) {
			$ary=explode("/",$val);
			$target_dir=$ary[count($ary)-1];
			$select ='document.getElementById(\'idEditDir\').innerText=\''.(rtrim($ARG["dir"],'/')).'/'.(trim($target_dir,'/')).'\';';
			$select =$select;
			$style="";
			if($sel==$target_dir) {
				$style="background-color:#00bfff;color:#000000;";
				}
			print '<tr><td onclick="'.$select.'" class=ListArtDirDt style="width:440px;'.$style.'">';
			print $target_dir;
			print '</td></tr>';
			}
		}
	print '</table>';
	print "</dev>\n";
	}

/*******************************************************************************
	PostPutOder() : PostPutOder Update
	no={0:New/1～Rep}&tag={RepTag/NewTag}&path={TagValue}&field={fieldValue:Attlibuto}

	mpdxmlupdate.lib.phpはTag名に対するLibraryであり，本処理はNo[番目]に対する対応となる
	・No[番目]，同一Tagを発生順に特定している。
	・他に類次処理が発生したとき，Library化できるように構築しておく
*******************************************************************************/
function PostPutOder() {
	global $ARG;

	$tagary["tag"]=$ARG["tag"];
	$tagary["value"]=ArgHTMLEncode($ARG["path"]);
	$tagary["attrii"]="";
	if ((isset($ARG["field"]))&&($ARG["field"] !=="")) {		// Tag Replace
		$tagary["attri"] ='Filed="'.$_POST["field"].'"';		// Attribute String {Attri}="Value"
		$tagary["attary"]['Filed']=$_POST["field"];				// Attribute Array [Attri]:Value
		}
	$xmltag="LISTART_Order";
	if 	($ARG["no"] > 0) {
		 print "PutOder Start Replace No[".$ARG["no"]."]\n";
		 $no=(int)$ARG["no"]-1;
		 $ret=PutReplaceElement($xmltag,$no,$tagary);
		 print "PutOder End Replace\n";
		 }
	else {
		 print "PutOder Start Add New No\n";
		 PutNewElement($xmltag,$tagary);
		 print "PutOder End Add New No\n";
		 }
	print "grplist:";											// 再表示
	DispListArtOrderDetail();
	print "\n";
	}

/* -------------------------------------------------------------------------------
	PutReplaceElement($xmltag,$no,$tagary) : XML Tag No Replace
	 $xmltag     : i  : XML Update Target Tag
	 $no         : i  : Rep No 0～指定
	 $tagary     : i  ; [tag]:Tag Name ,[value]:Tag Value , [attri]:Attribute {Attribute}="{値}"
	 @return     : o  : "":Normal End , AbnormalEnd:Error String
	 作成後,OrignalFileを{$XML_ORDERLIST}.orgにする。
	 移動しFrom No(Tag:$sourceIndex)には<!-- Date:{Data Time -->を付加する。
------------------------------------------------------------------------------ */
function PutReplaceElement($xmltag,$no,$tagary) {
	global $XML_ORDERLIST;

	$ret="";
	$onTag=0;$index=0;$repkey=-1;
	$tmp = file_get_contents($XML_ORDERLIST);
	$LineAry = explode("\n",$tmp);

	for($key = 0; $key < count($LineAry);$key++) {
		$str=preg_replace( '/\A[\p{C}\p{Z}]++|[\p{C}\p{Z}]++\z/u', '',$LineAry[$key]);			// 前Spaceを詰める
		preg_match("/^\<(.*?)\>/is", $str,$reslut);					// <{Select}>
		$tag="";if(isset($reslut[1])) { $tag=$reslut[1]; }

		if ($tag == "/".$xmltag) { $onTag=0; }					// ArgumentTagの終了
		if ($onTag==1) {										// Tag:<LISTART_Order>の間
			$split =  preg_split('/(?<=>)\s*(?=<)/',$str);			// 同Lineに有効Tagがあるかチェック

			if (isset($split[1])) {
				_PutElementUnfold($LineAry,$key,$split);			// 有効Tagを分割する
				}
			$ary = explode(" ",$tag);
			if (isset($ary[1])) { $ar = explode("=",$ary[1]); }		// Attribute {a}={b}
			if (((preg_match('/^[a-zA-Z0-9]+$/is',$ary[0]))&&(!isset($ary[1])))							// 英数字はTag
				|| ((preg_match('/^[a-zA-Z0-9]+$/is',$ary[0]))&&(isset($ary[1]))&&(isset($ar[1])))) {	// 英数字はTag && Attribute
				if ($no==$index) {								// n番目一致
					$repkey=$key;
					}
//				print "[".$key."]"."[".$index."]".htmlspecialchars($LineAry[$key])."<BR>";
				$index=$index+1;
				}
			}
		if ($tag == $xmltag) {									// ArgumentTagの開始
			$onTag=1;
			}
		}
	if ($repkey < 0) {
		return("PutOder End Replace Noting");
		}
	$tmp=preg_replace( "/\<!-- Date(.*?) --\>/is",'',$LineAry[$repkey]);
	preg_match("/\<\!--(.*?)--\>/is",$tmp,$reslut);				// <!--{Select}--> Replace前のコメントを切り出し
	$commentt="";
	if(isset($reslut[1])) { $commentt='<!--'.$reslut[1].'-->'; }
	$commentt=$commentt.'<!-- Date:'.date('Y-m-d H:i:s').' -->';	// TimeStumpをコメントに追加
	if ($tagary["attri"] !="") { $tagary["attri"]=" ".$tagary["attri"]; }
	$str="\t<".$tagary["tag"].$tagary["attri"].">".$tagary["value"]."</".$tagary["tag"].">".$commentt;
	$LineAry[$repkey]=$str;

	$LineStr=implode("\n",$LineAry);
	$LineStr=rtrim($LineStr,"\n")."\n";
	$XML_ORDERLISTNew=$XML_ORDERLIST.".new";						// Make New XMLFile
	file_put_contents($XML_ORDERLISTNew,$LineStr);
	chmod($XML_ORDERLISTNew,0666);								// Orignal XMLFile Backup
	chmod($XML_ORDERLIST,0666);
	rename($XML_ORDERLIST,$XML_ORDERLIST.".".org);
	rename($XML_ORDERLISTNew,$XML_ORDERLIST);						// New XMLFile End
	return($ret);
	}

/* -------------------------------------------------------------------------------
	PutNewElement($xmltag,$tagary) : XML Tag No New (新規Tagを追加)
	 $xmltag     : i  : XML Update Target Tag
	 $no         : i  : Rep No 0～指定
	 $tagary     : i  ; [tag]:Tag Name ,[value]:Tag Value , [attri]:Attribute {Attribute}="{値}"
	 @return     : o  : "":Normal End , AbnormalEnd:Error String
	 作成後,OrignalFileを{$XML_ORDERLIST}.orgにする。
	 移動しFrom No(Tag:$sourceIndex)には<!-- Date:{Data Time -->を付加する。
------------------------------------------------------------------------------ */
function PutNewElement($xmltag,$tagary) {
	global $XML_ORDERLIST;

	$xml = simplexml_load_file($XML_ORDERLIST);

	$dom = dom_import_simplexml($xml);										// SimpleXMLオブジェクトをDOMツリーに変換
	$parentElement = $dom->getElementsByTagName($xmltag)->item(0); 			// LISTART_Order要素を取得
	$g = new DOMText("\t");													// Tab追加
	$newChild=$parentElement->appendChild($g);
	$newChild = $parentElement->appendChild(new DOMElement($tagary["tag"], $tagary["value"])); // 新TagをDOMツリーに追加
	foreach ((array)$tagary["attary"] as $key => $val) {					// 新Attributeを追加
 	 	$newChild->setAttribute($key, $val);
		}
	$g = new DOMText("\n");													// NL追加
	$newChild=$parentElement->appendChild($g);

	$XML_ORDERLISTNew = $XML_ORDERLIST . ".new";					// 新XMLファイル名
	$dom->ownerDocument->save($XML_ORDERLISTNew); 				// 新XMLファイルを保存
	chmod($XML_ORDERLISTNew,0666);								// Orignal XMLFile Backup
	chmod($XML_ORDERLIST,0666);
	rename($XML_ORDERLIST,$XML_ORDERLIST.".".org);
	rename($XML_ORDERLISTNew,$XML_ORDERLIST);						// New XMLFile End
	}

/*******************************************************************************
	PostRemoveOder() : PostPutOder Remove
	no={}&tag={Tag}  no:1～ Remove No , tagが一致しなければ削除しない。(裏で内容が変わった判断)
*******************************************************************************/
function PostRemoveOder() {
	global $ARG,$XML_ORDERLIST;

	print "PutOder Start Remove No[".$ARG["no"]."]\n";
	$rmno=(int)$ARG["no"]-1;
	$xmltag="LISTART_Order";
	$result=PutRemoveElement($xmltag,$rmno,$ARG["tag"]);

	print "PutOder End\n";
	print "grplist:";											// 再表示
	DispListArtOrderDetail();
	print "\n";
	if ($result !=="") {
		print "Function:RequestMsgBox('RemoveOder','".$result."',120,70);\n";
		}
	}

/* -------------------------------------------------------------------------------
	PutRemoveElement($xmltag,$no,$rmtag) : XML Tag No Remove
	 $xmltag     : i  : XML Update Target Tag
	 $no         : i  : Remove No 0～指定
	 $rmtag      : i  ; Tag Name
	 @return     : o  : "":Normal End , AbnormalEnd:Error String
	 作成後,OrignalFileを{$XML_ORDERLIST}.orgにする。
	 削除Tagが引数[$rmtag]一致しなければ削除しない
	※unset($xml->LISTART_Order->children()[$no]);で削除できるが一連のCommentTagを削除するための関数化
------------------------------------------------------------------------------ */
function PutRemoveElement($xmltag,$no,$rmtag) {
	global $XML_ORDERLIST;

	$ret="";
	$onTag=0;$index=0;$repkey=-1;
	$tmp = file_get_contents($XML_ORDERLIST);
	$LineAry = explode("\n",$tmp);

	for($key = 0; $key < count($LineAry);$key++) {
		$str=preg_replace( '/\A[\p{C}\p{Z}]++|[\p{C}\p{Z}]++\z/u', '',$LineAry[$key]);			// 前Spaceを詰める
		preg_match("/^\<(.*?)\>/is", $str,$reslut);					// <{Select}>
		$tag="";if(isset($reslut[1])) { $tag=$reslut[1]; }

		if ($tag == "/".$xmltag) { $onTag=0; }					// ArgumentTagの終了
		if ($onTag==1) {										// Tag:<LISTART_Order>の間
			$split =  preg_split('/(?<=>)\s*(?=<)/',$str);			// 同Lineに有効Tagがあるかチェック

			if (isset($split[1])) {
				_PutElementUnfold($LineAry,$key,$split);			// 有効Tagを分割する
				}
			$ary = explode(" ",$tag);
			if (isset($ary[1])) { $ar = explode("=",$ary[1]); }		// Attribute {a}={b}
			if (((preg_match('/^[a-zA-Z0-9]+$/is',$ary[0]))&&(!isset($ary[1])))							// 英数字はTag
				|| ((preg_match('/^[a-zA-Z0-9]+$/is',$ary[0]))&&(isset($ary[1]))&&(isset($ar[1])))) {	// 英数字はTag && Attribute
				if ($no==$index) {								// n番目一致
					$repkey=$key;
					}
//				print "[".$key."]"."[".$index."]".htmlspecialchars($LineAry[$key])."<BR>";
				$index=$index+1;
				}
			}
		if ($tag == $xmltag) {									// ArgumentTagの開始
			$onTag=1;
			}
		}
	if ($repkey < 0) {
		return("PutOder End Remove Noting");
		}
	if (strpos($LineAry[$repkey],$rmtag)===false) {				// $tag引数[$rmtag]にない場合
		return("Remove Oder Error Tag mismatch, state changed");
		}
//	print "DEL [".$repkey."]".$LineAry[$repkey]."<BR>";
	unset($LineAry[$repkey]);									// RepNo削除
	$LineAry=array_values($LineAry);							// 行を詰める
	$LineStr=implode("\n",$LineAry);
	$LineStr=rtrim($LineStr,"\n")."\n";
	$XML_ORDERLISTNew=$XML_ORDERLIST.".new";						// Make New XMLFile
	file_put_contents($XML_ORDERLISTNew,$LineStr);
	chmod($XML_ORDERLISTNew,0666);								// Orignal XMLFile Backup
	chmod($XML_ORDERLIST,0666);
	rename($XML_ORDERLIST,$XML_ORDERLIST.".".org);
	rename($XML_ORDERLISTNew,$XML_ORDERLIST);						// New XMLFile End
	return($ret);
	}

/*******************************************************************************
	PostMoveOder() : PostMoveOder : XML Order Move
	fromno={no}&tono={no}  no:1～
*******************************************************************************/
function PostMoveOder() {
	global $ARG;

	print "PutOder Start Move FromNo[".$ARG["fromno"]."] ToNo[".$ARG["tono"]."]\n";
	$xmltag="LISTART_Order";
	$from=$ARG["fromno"]-1;
	$to=$ARG["tono"]-1;
	PutMoveElement($xmltag,$from,$to);
	print "PutOder End\n";
	}

/* -------------------------------------------------------------------------------
	PutMoveElement($xmltag,$sourceIndex,$targetIndex) : XML Tag No Move
	 $xmltag     : i  : XML Update Target Tag
	 $sourceIndex: i  : Form No 0～指定
	 $targetIndex: i  : To No   0～指定
	 @return     : o  : "":Normal End , AbnormalEnd:Error String
	 作成後,OrignalFileを{$XML_ORDERLIST}.orgにする。
	 移動しFrom No(Tag:$sourceIndex)には<!-- Date:{Data Time -->を付加する。

	※ XML Tag($xmltag) Form番目をTo番目に移動()コメント除く
	   XMLをTextとして扱うので対象Tag($xmltag)に制限がある。
	   ・有効Tagの前は,Space/Tag以外はないこと
	   ・Tag名は英数字で作成する。
	   以外はTagとして扱わない
------------------------------------------------------------------------------ */
function PutMoveElement($xmltag,$sourceIndex,$targetIndex) {
	global $XML_ORDERLIST;

	$ret="";
	if($sourceIndex == $targetIndex) { $ret="From / To Same Index End\n";return($ret); }
	$onTag=0;$index=0;$From=-1;$To=-1;
	$tmp = file_get_contents($XML_ORDERLIST);
	$LineAry = explode("\n",$tmp);

	for($key = 0; $key < count($LineAry);$key++) {
		$str=preg_replace( '/\A[\p{C}\p{Z}]++|[\p{C}\p{Z}]++\z/u', '',$LineAry[$key]);			// 前Spaceを詰める
		preg_match("/^\<(.*?)\>/is", $str,$reslut);					// <{Select}>
		$tag="";if(isset($reslut[1])) { $tag=$reslut[1]; }
		if ($tag == "/".$xmltag) { $onTag=0; }				// ArgumentTagの終了
		if ($onTag==1) {									// Tag:<LISTART_Order>の間
			$split =  preg_split('/(?<=>)\s*(?=<)/',$str);			// 同Lineに有効Tagがあるかチェック
			if (isset($split[1])) {
				_PutElementUnfold($LineAry,$key,$split);			// 有効Tagを分割する
				}
			$ary = explode(" ",$tag);
			if (isset($ary[1])) { $ar = explode("=",$ary[1]); }		// Attribute {a}={b}
			if (((preg_match('/^[a-zA-Z0-9]+$/is',$ary[0]))&&(!isset($ary[1])))							// 英数字はTag
				|| ((preg_match('/^[a-zA-Z0-9]+$/is',$ary[0]))&&(isset($ary[1]))&&(isset($ar[1])))) {	// 英数字はTag && Attribute
				if ($sourceIndex==$index) {							// From ; n番目
					$From=$key;
					}
				if ($targetIndex==$index) {							// To   : n番目
					$To=$key;
					}
//				print "[".$key."]"."[".$index."]".htmlspecialchars($LineAry[$key])."<BR>";
				$index=$index+1;
				}
			}
			if ($tag == $xmltag) {							// ArgumentTagの開始
				$onTag=1;
			}
		}
	if(($From < 0)||($To < 0))  { $ret="No Search Line End\n";return($ret); }

	$From_Line=$LineAry[$From];
	$From_Line=preg_replace( "/\<!-- Date(.*?) --\>/is",'',$From_Line);

	for ($i = sizeof($LineAry);$i >= $To;$i--) {			// Toより下を1行下げる
		$LineAry[$i+1]=$LineAry[$i];
		}

	if($From > $To) {										// Fromより上にToがあると位置行増えるので+1
		 $From=$From+1;
		 }
	else {
		 $To=$To+1;
		 }
	$LineAry[$From]=preg_replace( "/\<!-- Date(.*?) --\>/is",'',$LineAry[$From]);
	$LineAry[$To]=$LineAry[$From].'<!-- Date:'.date('Y-m-d H:i:s').' -->';		// FromのToに挿入
	if ($From_Line == $LineAry[$From]) {
		 unset($LineAry[$From]);									// From削除
		 }
	else {
		 $ret="unMatch Line Array[$From]".htmlspecialchars($LineAry[$From])."]\n";return($ret);
		 }
	$LineAry=array_values($LineAry);								// 行を詰める
//	if($From > $To) { $no=$To; } else { $no=$From; }
//		for ($i = $no;$i < sizeof($LineAry);$i++) {
//		print "[".$i."]".htmlspecialchars($LineAry[$i])."<BR>";
//		}
	$LineStr=implode("\n",$LineAry);
	$LineStr=rtrim($LineStr,"\n")."\n";
	$XML_ORDERLISTNew=$XML_ORDERLIST.".new";
	file_put_contents($XML_ORDERLISTNew,$LineStr);
	chmod($XML_ORDERLISTNew,0666);
	chmod($XML_ORDERLIST,0666);
	rename($XML_ORDERLIST,$XML_ORDERLIST.".".org);
	rename($XML_ORDERLISTNew,$XML_ORDERLIST);
	return($ret);
	}

/* -------------------------------------------------------------------------------
	_PutElementUnfold($LineAry,$key,$split) : 有効Tagの分割
	 $LineAry : io : XML LineArrayy : 有効なTagがあった場合，数行に分割する
	 $key     : i  : $LineAryのKey(現在対象としている位置Index)
	 $split   : i  : 行のTag分割Array
	 分割イメージ
	  Now Line  :<A></A> <B></B><!-- C -->
	  New Line  :<A></A>
	  New Line+1:<B></B><!-- C -->
------------------------------------------------------------------------------ */
function _PutElementUnfold(&$LineAry,$key,$split) {
	$flgHit=0;

	for ($i = 1;$i < count($split);$i++) {					// 位置行分のTagをチェック([0]:は元のTagなのでその後のあるかチェック)
		if (strpos($split[$i],"<!--")===0)  { continue; }
		if (strpos($split[$i],"<")===False) { continue; }
		$flgHit=1;											// 有効となるTag検出
		break;
		}
	if ($flgHit ==0) { return; }

	$ary = explode($split[$i],$LineAry[$key]);				// 検出した有効Tag前を現在のTagにする
	$tmp=str_replace($ary[0],'',$LineAry[$key]);			// 現在のTagLineより後ろを新Lineにする。
	print '$split['.$key.'.0]['.htmlspecialchars($ary[0])."]<BR>";
	print '$split['.$key.'.1]['.htmlspecialchars($tmp)."]<BR>";
	for ($i = sizeof($LineAry);$i > $key;$i--) {			// Toより下を1行下げる
		$LineAry[$i+1]=$LineAry[$i];
		}
	$LineAry[$key]=$ary[0];									// 検出した有効Tag前を現在の位置に戻す
	$i=$key+1;
	$LineAry[$i]="\t".$tmp;										// 検出した有効Ta現在の位置+1に戻す
	}

/*******************************************************************************
	PostMakeMyset() : Post Make MySet Order XML File
*******************************************************************************/
function PostMakeMyset() {
	global $XML_WEBROOTBASE,$XML_ORDERLIST;
	print "MySetOder Make Start\n";

	print "Sumple[".$XML_WEBROOTBASE["OrderSumple"]."] Make[".$XML_ORDERLIST."].\n";

	if (file_exists($XML_WEBROOTBASE["OrderSumple"])) {
		if (file_exists($XML_ORDERLIST)) {
			 print "MySetOder Make File Exists	[".$XML_ORDERLIST."] End\n";
			 print "Function:RequestMsgBox('MySetOder Make Error','File Exists [".$XML_ORDERLIST."]',120,70);\n";
			 }
		else {
			$result=copy($XML_WEBROOTBASE["OrderSumple"],$XML_ORDERLIST);
			if($result) {
				 chmod($XML_ORDERLIST,0666);
				 print "Function:location.reload();\n";
				 print "MySetOder Make End\n";

				 }
			else {
				 print "MySetOder Make Copy False\n";
				 print "MySetOder Make Copy False End\n";
				 }
			 }
		 }
	else {
		 print "Function:RequestMsgBox('MySetOder Make Error','NotFileExists [".$XML_WEBROOTBASE["OrderSumple"]."]',120,70);\n";
		 print "MySetOder Make Not File Exists	[".$XML_WEBROOTBASE["OrderSumple"]."] End\n";
		 }
	}

//----- Post Source End --------------------------------------------------------------
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<?php
/***************************************************************************************
	mpdweb.list.setting.php Main Proc
***************************************************************************************/
ArgAnalyze($_GET,$ARG);

$HTML_CONFIG=array("lang"=>"ja","favicon"=>"");
get_config("Html_config",$HTML_CONFIG);				// php config
echo <<<EOM
<html lang="{$HTML_CONFIG["lang"]}">
<head>
EOM;
if ($HTML_CONFIG["favicon"] !== "") {
	print '<link '.$HTML_CONFIG["favicon"].'>';
	}
if ($HTML_CONFIG["favicon"] !== "") {
	print '<link '.$HTML_CONFIG["favicon"].'>';
	}

$LIB_CONF=array("Codeset"=>"utf-8","TimeZone"=>"Asia/Tokyo");
GetAlterConfig("LibConf",$LIB_CONF);			// Alternative get_config
print '<meta http-equiv="Content-Type" content="text/html; charset='.$LIB_CONF["Codeset"].'" >';

$CACHE_SEC=array("CacheContent"=>"86400");								// キャッシュ有効時間 初期値24時間
GetAlterConfig("Html_config",$CACHE_SEC);			// Alternative get_config
print '<meta http-equiv="Expires" content="'.$CACHE_SEC["CacheContent"].'">';
$HTML_CONFIG=array("Viewport"=>"width=380px,initial-scale=1.2,maximum-scale=1.7","ViewportRate"=>"");	// Viewport初期値
$setsts=GetAlterConfig("Html_config",$HTML_CONFIG);			// Alternative get_config
$ViewportRate=$HTML_CONFIG["ViewportRate"];								// Phoneの時画面高/幅の比率の設定
if (is_numeric($ViewportRate)) { } else {								// 数値以外は0:未設定
	$ViewportRate ="0";
	}
$xml_ua=array("ua_phone"=>"iPhone,iPod,Android");		// 設定のWordがHTTP_USER_AGENTあれば,Phoneと扱う
GetAlterConfig("php_config",$xml_ua);					// Alternative get_config
$arr_ua = explode(',',$xml_ua["ua_phone"]);
$ua=$_SERVER['HTTP_USER_AGENT'];$REQ_UA="PC";				// UAを取得(Venderを求めるのに必要な項目を使用しないので直接決定)
foreach($arr_ua as $key=> $part) {
	if (strpos($ua,$part)!==false) { $REQ_UA='Phone'; break; }
	}
if ($REQ_UA !== "PC") {		// PC時のPlay ProgressTime(Sec) Style
	$HTML_CONFIG=array("ViewportPhone"=>"");							// ViewportPhone初期値
	$tmpsts=GetAlterConfig("Html_config",$HTML_CONFIG);					// Html_config mpdconfig.xmlより設定
	if ($HTML_CONFIG["ViewportPhone"] !=="") {
		$HTML_CONFIG["Viewport"]=$HTML_CONFIG["ViewportPhone"];
		$setsts=$tmpsts;
		}
	}
$SCR_WIDTH=480;															// mpdart HTML : WIDTH

$html_viewport=ArgViewport($XML_CONF,$count);
if (($setsts["No"]==0)&&($count==0)&&($setsts["AltXml"]!=="")) {
	 $html_viewport=GetAlterViewport($setsts["AltXml"]);
	 }
if ($html_viewport=="") { $html_viewport=$HTML_CONFIG["Viewport"]; }

if(stripos($html_viewport,'%scale%') === false) {						// %scale%:initial-scale計算
	 print '<meta name="viewport" content="'.$html_viewport.'" >';
	 }
else {
	 $str=str_replace('%scale%','1.0',$html_viewport);
	 print '<meta id="idMeta" name="viewport" content="'.$str.'" >';
	 echo <<<EOM
<script type="text/javascript">
	var viewportContent="{$html_viewport}";
	var vportrate=window.outerHeight/window.outerWidth;
	if (('{$REQ_UA}' !=="PC")&&({$ViewportRate} > 0)&&({$ViewportRate} > vportrate)) {
		 var scale={$ViewportRate};										// 縦横比を余白分にする
		 if (window.outerWidth < ({$SCR_WIDTH}*scale)) {				// Viewが画面幅を超えるときは適用しない
		 	scale=Math.floor((window.outerWidth/{$SCR_WIDTH})*100)/100;	// 幅比率で表示(小数3位切り捨て)
			}
		 }
	else {
		 var scale=Math.floor((window.outerWidth/{$SCR_WIDTH})*100)/100;	// 小数3位切り捨て
		 }
	var viewportContent=viewportContent.replace('%scale%',scale);
	document.getElementById('idMeta').setAttribute('content',viewportContent);
</script>
EOM;
	 }
$csscommon = rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'."mpdweb.common.css";		// mpdweb Common css
if  (file_exists(rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename(__FILE__,".php").".common.css")) {
	$csscommon = rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename(__FILE__,".php").".common.css";		// mpdweb Common jsp mpd{module}.css
	}
$dateform="";
if (file_exists($csscommon)) {
	$date = new DateTime();
	$date->setTimestamp(filemtime($csscommon));
	$dateform=$date->format('YmdHis');
	$dateform="?a=".$dateform;
	}

echo <<<EOM
<link rel="stylesheet" href="{$csscommon}{$dateform}" type="text/css">
EOM;

?>
<style type="text/css">
/***************************************************************************************
 Style Definition body : Body is created for each device by PHP
****************************************************************************************/
html { overflow-y: scroll; }
body { background-color:#000000;color:#ffffff;margin-left:4px;font-family:Verdana,"Meiryo UI",sans-serif;font-size:80%; } /* 暫定 */
/* IE:スクロールバーの色 */  /* バウンススクロール禁止 : overscroll-behavior IOSはIOS16以降有効 */
html,body { background-color:#000000;color:#ffffff;scrollbar-base-color:#707070;scrollbar-track-color:#A4A4A4;scrollbar-arrow-color:#707070;overscroll-behavior:none; }
/* Edge Chome スクロールバーの色 */
::-webkit-scrollbar { width: 10px; }					/* スクロールバー全体 */
::-webkit-scrollbar-track { background: #1c1c1c; box-shadow: inset 0 0 1px #2e2e2e; }	/* スクロールバー背景 */
::-webkit-scrollbar-thumb { background: #2f4f4f; }		/* スクロールバーつまみ */

/* IOSのStyle 無効 */
button { background-color:#ffffff;color:#000000; }
input,select,textarea { font-size:98%;font-family: inherit; }
input[type="button"] { -webkit-appearance: none; border-radius: 0; }
input[type="submit"] { -webkit-appearance: none; border-radius: 0; }

.detaile { height:20px;line-height:140%;background-color:#000000;color:#d3d3d3;font-size:11px;white-space:nowrap;text-align:left;vertical-align:middle;border:0px solid #333333;overflow:hidden; }
.head  {position:fixed !important;position:absolute;top:0;width:480px;height:24px;font-size:11px;background-color:#000000;z-index:100;}
.botom {position:fixed;bottom:0px;width:476px;background-color:#000000;}
.buttn {border-style:none;width:50px;height:20px;padding:2px 0 2px;font-size:11px;cursor:pointer;-moz-border-radius:4px;-webkit-border-radius:4px;border-radius: 4px;}
.comnd {border-style:none;padding:2px 0 2px;font-size:8p;cursor:pointer;-moz-border-radius:2px;-webkit-border-radius:2px;border-radius:2px;text-align:center;}
.music {background-color:#000000;color:#ffffff;font-size:12p;font-weight:bold;text-decoration:none;white-space:nowrap;display:block;text-align:left;vertical-align:middle;padding:2px 0 2px;border:0px solid #333333;cursor:pointer;}
.hfunc { position:relative;right:0px;top:-4px;width:20px;height:23;transform:rotate(-90deg);white-space:normal;background-color:#585858;color:#ffffff;}

.box {border: 1px solid #888888;position:fixed;top:200px;left:170px;
      width:300px;height:238px;font-size:10p;z-index:120;
      background-color:#2f2f2f;
      display: none;
      }
.boxtitle {background-color:#0000FF;color:#CEECF5;font-size:14px;text-align:left;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;width:280px;height:18px;position:absolute;top:0px;left:0px;padding:8px 10 2px;}
.boxbcan  {position:absolute;bottom: 5;right:6px;}
.boxline  {background-color:#000000;color:#ffffff;font-size:14px;font-weight:bold;text-decoration:none;white-space:nowrap;display:block;text-align:left;vertical-align:middle;cursor:pointer;border: 1px solid #acacac;width:300px;height:25;padding:3px 10 2px;}
.boxblin1 {position:absolute;left:0px;top:32px;}
.boxblin2 {position:absolute;left:0px;top:50px;}
.boxblin2h {position:absolute;left:0px;top:76px;}
.boxblin3 {position:absolute;left:0px;top:88px;}
.boxblin4 {position:absolute;left:0px;top:116px;}
.boxblin4h {position:absolute;left:0px;top:128px;}
.boxblin5 {position:absolute;left:0px;top:144px;}
.boxblin6 {position:absolute;left:0px;top:172px;}
.boxtext  {position:absolute;background-color:#2f2f2;color:#ffffff;font-size:16x;font-weight:bold;text-decoration:none;display:block;text-align:left;vertical-align:middle;border: 0px;width:278px;height:19;padding:3px 10 2px;}
.msgbbtn { font-size:12px;width:60px;height:24px;position:absolute;top:120px;background-color:#c0c0c0;border:1.5px ridge #d3d3d3;}

/* DispListArtOrder */
.tdHead { height:24px;font-weight:normal;font-size:12px;text-align:center;background-color:#191970;padding: 2px; }
.tdLine { overflow:visible;white-space:nowrap;text-overflow:ellipsis;height:24px;font-size:10px;line-height:200%; }
/* ListArt Move Box */
.ListArtMovBx { width:60px;height:200px;position:fixed;}
.ListArtMovNo { text-align:center;width:20px;height:18px;font-size:13px;position:absolute;top:74px;left:10px;padding:8px 10px 2px;}
.ListArtMovCt { order:0px;font-size:13px;position:absolute;width:150px;height:12px;line-height:80%;border-radius:4px;opacity:0.70;background-color:#d3d3d3;color:#191970;}
.ListArtMovRt { position:absolute;top:48px;left:8px;width:45px;height:20;transform:rotate(90deg)scale(0.5,2);border-radius:5px;padding:0px 16 0px;}
/* ListArt Directory Box */
.ListArtDir   { background-color:#343434;display:block;overflow-y:auto; }
.ListArtDirTb { caret-color:#343434;font-size:13px;letter-spacing:0.03em;cursor:pointer; }
.ListArtDirDt { text-overflow:ellipsis;color:#7fffd4;white-space:nowrap; }
.ListArtDirDt:hover { background-color:#b0c4de;color:#000000; }
/* Status Line */
.StatusL { border:1.4px solid #000000;width:480px;height:20;font-size:10px;color:#BDBDBD;line-height:140%;padding:4 6 6 6;background-color:#2E2E2E;resize:none;}
</style>

</head>
<body>
<script type="text/javascript">
/********************************************************************************
	Java Script Event Listener
********************************************************************************/
document.addEventListener("dragstart",function(event) {
	_pldragstart(event);				// store a ref. on the dragstart
},false);

document.addEventListener("dragover", function(event) {
	_pldragover(event);				// store a ref. on the drop over
},false);

document.addEventListener("drop", function(event) {
	_pldrop(event);					// store a ref. on the drop
},false);


/*
	Mouse Event Listener
*/
document.body.addEventListener( "click", function(event) {
	var mouseX = event.pageX ;	// X座標(Wide) (マウス位置を取得する)
	var mouseY = event.pageY ;	// Y座標(Higth)
	EventControle(mouseX,mouseY,event);
} );

/*
	Touch Event Listener
*/
document.body.addEventListener( "touchstart", function(event) {
	var touchObj = event.changedTouches[0] ;	// タッチの情報を含むオブジェクト
	var touchX = touchObj.pageX ;	// X座標	// タッチ位置を取得する
	var touchY = touchObj.pageY ;	// Y座標
	EventControle(touchX,touchY,event);
} );
/* -------------------------------------------------------------------------------------
	Event Controle Edit Function Drag&Drop
------------------------------------------------------------------------------------- */
/*
	_pldragstart(event)  : dragstart
	 even : i  : Event : EventListener:dragstart or HTML:<td id=Play{Pos} ondragstart
	 Drag Start  : ドラッグ操作を始めた時のイベント
*/
function _pldragstart(event) {
	var id  = event.dataTransfer.setData("text", event.target.id);
	}

/*
	_pldragover(event) Event : EventListener:dragover or HTML:<td id=Play{Pos} ondragover
	 Drag Over : ドラッグ状態のマウスのポインタがドロップ可能な要素上に重なってる時のイベント。
*/
function _pldragover(event) {
	event.preventDefault();
	}

/*
	_pldrop(event) Event : EventListener:"drop" or HTML: <td id=Play{Pos} ondrop
	 Drop      : ドロップした時のイベント。
*/
function _pldrop(event) {
	if (!event.target.id) {								// Taget(To)のチェック
		return;
		}
	if (event.target.id.indexOf("idno") == -1) {			// Taget(To)のDrop対象のチェック
		return;
		}
	var dropElm = event.target;
	event.stopPropagation();							// イベントの規定のアクションが発生するのを止める
	var qid_to = dropElm.innerHTML;
		qid_to = parseInt(qid_to);
	var id_drag = event.dataTransfer.getData("text");
	var qid_from = document.getElementById(id_drag).innerHTML;
		qid_from = parseInt(qid_from);
	event.preventDefault();								// 処理される既定のアクションが動作しなくなる
	LISTARTMovExit(1);									// Move Mark Coler Reset
	LISTARTMov(qid_to,qid_from);						// Move Process
	}

/* ------------------------------------------------------------------------------------
	Rect Controle   Mouse/Touch Commn Control
	PostionX : i  : Wide
	PostionY : i  : Higth
	event    : i  : Event Object
------------------------------------------------------------------------------------ */
function EventControle(PostionX,PostionY,event) {
	if (event.target.id.match(/^idno/)) {			// Tagetのidチェック HTML-ID No:pid{n} (MoveBox Touch Event)
		LISTARTMovTouch(event.target.id)
		}
	}

/* ------------------------------------------------------------------------------------
	RequestLoadDisp(waitsec) : 起動待ちの時計マークディスプレイ
		waitsec : i  : Display Timeout(Sec) 0:Limit(Net Timeoutまで),null:defult,{n}:指定時{n}sec
		styleを使用し id=idlodingmsgをOn/Offする
		id=idlodingmsgは<BODY>などに設定しておく
			style:#idlodingmsg:待ちのイメージをこの名前で作成しておく
			<body><div id="idlodingmsg"></div>
------------------------------------------------------------------------------------ */
var GURLCONNECT="";		// 外部モジュールがmpdsetting.phpシリーズとHeaderFunctionでURL共有部を使用する項目
var LoadDispWSec=30;
var GObjSTime;			// 起動待ちの時計マーク Objectid
function RequestLoadDisp(waitsec){
	if (waitsec == 0) {
		 sleep=LoadDispWSec*1000;
		 }
	else if (waitsec == null) {
		 sleep=10000;
		 }
	else {
		 sleep=waitsec*1000;
		 }
	document.getElementById('idlodingmsg').style.display='block';	// idlodingmsgを表示にする display: none;→block

	var element = document.createElement('div'); 					// ロック用のdivを生成 透明，最大画面を最上位に表示
	element.id = "screenLock"; 										// ロック用のスタイル
	element.style.height = '100%'; 
	element.style.left = '0px'; 
	element.style.position = 'fixed';
	element.style.top = '0px';
	element.style.width = '100%';
	element.style.zIndex = '100';									// PlayPanel(id=idFormCtl)よりz-indexを下げている
	element.style.opacity = '0';
	var objBody = document.getElementsByTagName("body").item(0); 
	objBody.appendChild(element);

	if(GObjSTime) { clearTimeout(GObjSTime);GObjSTime=null; }			// Timer Unloak
	GObjSTime=setTimeout( function() { RequestUnLoadDisp(); },sleep);	// ロック画面の削除
	}
/*
	RequestUnLoadDisp() 起動待ちの時計マーク解除
*/
function RequestUnLoadDisp(){
	document.getElementById('idlodingmsg').style.display='none';

	id_name='screenLock';
	if (document.getElementById(id_name) == null) {
		return;
		}
	if(GObjSTime) { clearTimeout(GObjSTime);GObjSTime=null; }			// Timer Unloak
	var dom_obj = document.getElementById(id_name);
	var dom_obj_parent=dom_obj.parentNode;
	dom_obj_parent.removeChild(dom_obj);
	}
</script>

<div id="idlodingmsg"></div>
<?php
/***************************************************************************************
 Jsp Common Library Load
***************************************************************************************/
$jscommon = rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'."mpdweb.common.js";		// mpdweb Common js
if  (file_exists(rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename(__FILE__,".php").".common.js")) {
	$jscommon = rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename(__FILE__,".php").".common.js";		// mpdweb Common jsp mpdcommon.js
	}

$jslibcajax = rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'."mpdweb.libcajax.js";		// mpdweb Common js
if  (file_exists(rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename(__FILE__,".php").".libcajax.js")) {
	$jslibcajax = rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename(__FILE__,".php").".libcajax.js";	// mpdweb Common jsp mpd{module}.js
	}

$dateform="";
if (file_exists($jscommon)) {
	$date = new DateTime();
	$date->setTimestamp(filemtime($jscommon));
	$dateform=$date->format('YmdHis');
	$dateform="?a=".$dateform;
	}

echo <<<EOM
<script type="text/javascript" src="{$jscommon}{$dateform}"></script>
<script type="text/javascript" src="{$jslibcajax}{$dateform}"></script>
EOM;

echo <<<EOM
<script type="text/javascript">
var POSTMOD="{$_SERVER['PHP_SELF']}";		// POST ServerModule

/* ------------------------------------------------------------------------------------
	RequestByGet(module,id,callback) : URL実行 AJAX GET簡易版版
	module   : i  : URL
	id       : i  : HTML-id id指定時受信内容を表示する
	callback : i  : Callback完了時実行 function () { (JS) }
	簡易版としてURLを裏で実行。表示したい場合,受信内容を引数id (<div id{}>),innerHTMLで表示
------------------------------------------------------------------------------------ */
function RequestByGet(module,id,callback) {
	var request=new XMLHttpRequest();
		request.onreadystatechange = function() {
		if (request.readyState == 4){
   			if (request.status == 200){
				htmlstr = request.responseText;
				if ((id !=="")&&(document.getElementById(id) != null)) {					//  HTML-IDがあれば表示する。
					var idobj = document.getElementById(id);
					idobj.outerHTML=htmlstr;
					}
				if (callback != '') {
					callback();
					}
				}
			}
		}
	request.open('GET',module,true);
	request.send(null);
	}
</script>
EOM;

/***************************************************************************************
	mpdweb.list.setting.php
************************************************************************************** */
$PHP_CONFIG=array("php_timeout"=>130,"php_looptime"=>120,"php_locale"=>"ja_JP.UTF-8","memory_limit"=>"160M");
get_config("php_config",$PHP_CONFIG);				// php config
set_time_limit($PHP_CONFIG["php_timeout"]);
setlocale(LC_ALL,$PHP_CONFIG["php_locale"]);
ini_set('memory_limit',$PHP_CONFIG["memory_limit"]);
//----- mpd library init --- ---------------------------------------------------
if (isset($PHP_CONFIG["php_looptime"])) {						// Special Setting : $LIB_CONF["LoopTimeout"]が設定されていたらループを打ち切る設定として使用 
	$LIB_CONF["LoopTimeout"]=$PHP_CONFIG["php_looptime"];		// XMLに設定していないので"php_looptime"を活用。現在:mpd_list_find()で使用。
	}
if ($ARG["p"]=="conf") {
	 if(DispHeader($ARG["p"]) ===false) { exit; }
	 require_once("./mpdxmlconfig.php");
	 if (function_exists(DispXMLEdit)) {	// Function Check
		  DispXMLEdit();
		  }
	 else {
		  DispMsgBox("on","Function undefined [DispXMLEdit]",200,60,"mpdsetting Error Message");
		  }
	 DispState();
	 }
else {
	 DispListArtOrder();
	 }
DispMsgBox("off");				// メッセージボックス初期生成
DispSureBox("off");

/*******************************************************************************
	GetSessionConfig() : mpdweb.php Session Config
	 @return: o  : $SESSION_CONF Session Array
*******************************************************************************/
function GetSessionConfig() {
	global $XML_CONF;

	GetEnvCommon();
	ignore_user_abort(false);							// 切断時終了
	$SESSION_CONF=array("sesion_id"=>"mpdweb","href_waitmsec"=>"50","maxlifetime"=>"1440");
	get_config("php_session",$SESSION_CONF);			// php config php_session
	$SESSION_CONF=ArgSessionConf($SESSION_CONF);		// mpdweb:Session id 作成 : Used mpdcmnses.lib.php
	return($SESSION_CONF);
	}

/* -----------------------------------------------------------------------------
	GetEnvCommon(); Load setting/mpdconfig.xml
	 @return: o  : "":Normal !="":ErrorMessage
----------------------------------------------------------------------------- */
function GetEnvCommon() {
	global $XML_CONF,$XML_CONF_ARY;

	$XML_File = "setting/mpdconfig.xml";
		$ret="";
	try {
		$XML_CONF = get_loadconfig($XML_File);	// XML File Get FileNameはLibrary標準
		} catch( Exception $e ) {
	  $ret=$e->getMessage();
	  }
	$XML_CONF_ARY["setting/mpdconfig.xml"]=$XML_CONF;				// AlterSectionでmpdconfig.xmlの内容を取得
	return($ret);
	}

/* -----------------------------------------------------------------------------
	GetXMLSetting() ; Get XML Setting
----------------------------------------------------------------------------- */
function GetXMLSetting() {
	global $XML_CONF,$XML_CONF_ARY,$XML_LISTART,$XML_ORDERLIST,$XML_DPROG,$XML_FIELD,$XML_WEBROOTBASE,$XML_WEBROOT,$XML_SHMLISTART,$XML_FILENAME,$XML_EXCLUDE;

	$STS_MESSAGE="";
	try {
		get_loadconfig($xml_file="setting/mpdconfig.xml");
		} catch( Exception $e ) {
	  $STS_MESSAGE=$e->getMessage();
	  }
	$XML_DPROG=array("Status"=>"off");					// Status
	get_config("DISP_Config",$XML_DPROG);

	$XML_FIELDTX=array("List_Comb"=>"Artist,AlbumArtist,Date,Genre");
	get_config("DISP_Config",$XML_FIELDTX);				// Filed Combo
	$XML_FIELD=explode(",",",".trim($XML_FIELDTX["List_Comb"],","));

// mpdweb.list.setting 設定 --------------------------------------------------------------------------------------
	$XML_LISTART = "setting/mpdweb_list.xml";			// XML File ListArt Setting
	try {
		$XML_LISTCONF=get_loadxml($XML_LISTART);
		} catch( Exception $e ) {
	  $STS_MESSAGE=$e->getMessage();
	  }
	$XML_WEBROOTBASE=array("WebRoot"=>"%DOCUMENT_ROOT%","OrderSumple"=>"setting/mpdweb_list.xml.sumple");	// WebRoot Notation word
	get_confxml($XML_LISTCONF,"LISTART_Filename",$XML_WEBROOTBASE);
	$XML_WEBROOTSEL=array("WebRoot"=>"%DOCUMENT_ROOT%");	// WebRoot SelectBox
	get_confxml($XML_LISTCONF,"Setting",$XML_WEBROOTSEL);	// WebRoot SelectBoxに%DOCUMENT_ROOT%がなければ追加
	if(strpos($XML_WEBROOTSEL["WebRoot"],$XML_WEBROOTBASE["WebRoot"]) === false){
		$XML_WEBROOTSEL["WebRoot"]=$XML_WEBROOTBASE["WebRoot"].",".trim($XML_WEBROOTSEL["WebRoot"],",");
		}
	$XML_WEBROOT=explode(",",$XML_WEBROOTSEL["WebRoot"]);

// mpdweb.list.setting Info項目 -----------------------------------------------------------------------------------
	$XML_FILENAME=array("ArtDirectoryRepChar"=>"&|/","LinkPathFileName"=>"Folder.jpg,folder.jpg","Directory"=>"\\","ArtDirectoryExtend"=>"jpg,png","WebRoot"=>"%DOCUMENT_ROOT%","XML_LISTART_Order"=>"setting/mpdweb_list_myset.xml");		// ListArt FileName: {before}\t{After}\n{before}\t{After}\n...
	get_confxml($XML_LISTCONF,"LISTART_Filename",$XML_FILENAME);
	$ary=explode('\n',$XML_FILENAME["ArtDirectoryRepChar"]);
	$XML_FILENAME["RepChar"]=array();$XML_FILENAME["FileName"]=array();
	foreach($ary as $key=> $ar) {
		$ary=explode('\t',$ar);
		$XML_FILENAME["RepChar"]["a"][$key]=$ary[0];
		$str="";
		if(isset($ary[1])) {
			$str=$ary[1];
			}
		$XML_FILENAME["RepChar"]["b"][$key]=$str;
		}
	$XML_ORDERLIST=$XML_FILENAME["XML_LISTART_Order"];
// mpdweb.list.php 同様に取得 : XML_SHMLISTART["Used"] を使用している --------------------------------------------
	$XML_CONF_ARY["setting/mpdconfig.xml"]=$XML_CONF;				// AlterSectionでmpdconfig.xmlの内容を取得
	$XML_CONF_ARY["setting/mpdweb_list.xml"]=$XML_LISTCONF;
	$tempary=array("Used"=>"off","Common"=>"0,/tmp,128,43200,,,");
	GetAlterConfig("Shm_Project",$tempary);							// Alternative get_config
	$XML_SHMLISTART=array("Used"=>$tempary["Used"],"Common"=>$tempary["Common"],"ListArt"=>"5");		// mpdweb_list.xml:"Shm_Project"で個別に設定時取得
	get_confxml($XML_LISTCONF,"Shm_Project",$XML_SHMLISTART);
	if($tempary["Used"]=="off") { $XML_SHMLISTART["Used"]="off"; }										// mpdconfig.xml:Shm_ProjectがUsed:off時,onにできないようにする。(LibrayがShared Memory未使用)
// netmask 取得 --------------------------------------------------------------------------------------------------
	// 形式 : <Exclude><netmask>直接背設定</netmask> , <Exclude><netmask>{XMLFile}:/{Section}/{Item}</netmask>を展開する
	$XML_EXCLUDE=array("netmask"=>"{setting/mpdconfig.xml:/Mpd_exclusive/netmask}");		// 実行除外のnetmask設定
	get_confxml($XML_LISTCONF,"Exclude",$XML_EXCLUDE);
	$result = preg_match_all('/{(.*?)}/s',$XML_EXCLUDE["netmask"],$part,PREG_SET_ORDER);	// Result:正規表現:{}を検出:Value
	if (isset($part[0][1])) {
		$XML_EXCLUDE["netmask"]="";
		$tmp=explode(":",$part[0][1]);														// {}内の形式が合わない場合,実行許可となる。
		$xmlfile=$tmp[0];
		if (isset($tmp[1])) {
			$result = preg_match_all('/\/(.*?)\//s',$tmp[1],$par,PREG_SET_ORDER);			// Result:正規表現://を検出 $part[n][0]:{Item} [1]:Value
			if(isset($par[0][1])) {
				$section=$par[0][1];
				$tmp=explode("/".$section."/",$tmp[1]);
				if(isset($tmp[1])) {
					$item=$tmp[1];
					$XML_EXCLUDE[$item]="";
					GetAlterConfig("$section",$XML_EXCLUDE);								// Alternative get_config
					if ($item !=="netmask") {												// 違うItem名を取得時，設定名称"netmask"に設定し直す
						$XML_EXCLUDE["netmask"]=$XML_EXCLUDE[$item];
						}
					}
				}
			}
		}
	return($STS_MESSAGE);
	}

/* -----------------------------------------------------------------------------
	ArgAnalyze($Link,&$ARG) : Argument Analyze
	 $Link   : i  : $_GET or $_POST
	 $ARG    : o  : Analyze Argument
	 @return : o  : Find! "p=" true
----------------------------------------------------------------------------- */
function ArgAnalyze($Link,&$ARG) {
	$ret=false;
	$ARG=array("p"=>"");		// Argument Table Argument Table初期化
	foreach($Link as $key => $val) {		// ArgAnalyze($_GET)と同じ形式にする
		$val=ArgDecode($val);
		$key_part=$key;
		if (substr($key,0,1)=="p") {		// P=が発生していれば有効
			$ret=true;
			}
		$arg= explode(':', $val, 2);
		if (!isset($arg[1])) {
			 $str=ArgDecode($val);
			 $ARG[$key_part]=$str;								// When Form Get : key=data 引数[p=list]
			 msglog("ARG:key_part[".$key_part."] ".$str);		//    $ARG[{key}] => "{val}"に変換  例:$ARG[p] => "list"
			 }
		else {
			 $str=ArgDecode($arg[1]);
			 $ARG[$key_part][$arg[0]]=$str;						// When Form Get key={key2}:data 引数[f=AlbumArtist:ABBA ] ----->$ARG["f"]["AlbumArtist"]=> "ABBA"
			 msglog("ARG:key[".$key_part."][".$arg[0]."] ".$str);
			 if ((!isset($ARG["key"][$key_part]))||($ARG["key"][$key_part]== "")) { 
			 	 $ARG["key"][$key_part]=$arg[0];				// 逆引きキーをセット f(x)の場合複数の場合は無効
				 }												// 例) $key=$ARG["key"]["f"]
			 }													//     $ARG["f"][$key]=$val;
		}

	foreach($ARG as $key => $ary) {
		if (($key=="m")||($key=="f")||($key=="b")||($key=="d")||($key=="url")) {	// PHP7対応:Arrayの初期値をArray()としている
			if ((is_array($ary))&&(count($ary)==0)) {					//   起動引数:m,f,b,dがない時, 初期 0件時はPHP5のとき同様にする
				$ARG[$key]="";											//   起動引数配列$ARG[{Para}]に""をセットする。
				}
			}
		}
	return($ret);					// Debug時のDumpは,GetEnvAppli()のコメントを開放する(PostはLogで確認できる)
	}

/* -----------------------------------------------------------------------------
	ArgURLCount($URL,$base) : URL Add Count,'cnt={}
	$URL   : i  : In URL
	$base  : i  : In URLのBase 省略時:$_SERVER['PHP_SELF'](自モジュールベース)
	@return: o  : New URL
----------------------------------------------------------------------------- */
function ArgURLCount($URL,$base="") {
	if ($base=="") { $base=$_SERVER['PHP_SELF']; }
	if (strpos($URL,'?cnt=') !== false) { $drm="?"; } else { $drm="&"; }
	$result = preg_match_all('/cnt=(.*?)[0-9]{1,2}/si',$URL,$part,PREG_SET_ORDER);	// 正規表現:cnr={}を検出 $part[0][0]:Value
	$no=0;$cntstr="";
	if(isset($part[0][0])) { $no=str_replace("cnt=","",$part[0][0]);$cntstr=$part[0][0]; }	// cnt={数値}を取得
	$tmp_uri=str_replace($drm.$cntstr,"",$URL);
	$new_cnt="cnt=".($no+1);
	if((strpos($tmp_uri,"?") === false)&&(strpos($tmp_uri,"&") === false)) {		// 引数がなく起動時
		 $NewURL=$tmp_uri."?".$new_cnt;
		 }
	else if ($cntstr == "") {														// cnt={}がない状態で起動時
		 $NewURL=$URL."&".$new_cnt;
		 }
	else {																			// cnt=が指定されているときは置換
		 $NewURL=str_replace($drm.$cntstr,$drm.$new_cnt,$URL);
		 }
	return($NewURL);
	}

/*******************************************************************************
	DispListArtOrder() : Edit Order List
*******************************************************************************/
function DispListArtOrder() {
	if (DispHeader() ===false) { return; }
	DispListArtOrderHeader();
	DispState();
	$reslut=DispListArtOrderDetail();
	DispListArtOrderFuncMove();
	DispListArtOrderFuncEdit();
/* - MyOrder XML Fileがない場合操作を抑制 ------------------------------------- */
	if ($reslut == False) {
		echo <<<EOM
<script type="text/javascript">
	document.getElementById("idNewTag").removeAttribute("onclick");
	document.getElementById("idNewTag").style.color = '#a9a9a9';
	document.getElementById("idNewTag").style.cursor="default";
</script>
EOM;
	}
/* - JSP Edit Box Edit -------------------------------------------------------- */
	global $XML_WEBROOTBASE,$XML_WEBROOT;
	$webroot=str_replace("%DOCUMENT_ROOT%",$_SERVER['DOCUMENT_ROOT'],$XML_WEBROOTBASE["WebRoot"]);
	$art_stddir=rtrim($webroot,"/")."/".$StdDir;
	if ((!file_exists($art_stddir))||($FlgStdDir=="on")) {				// 新規時:Standerd "ListArt"はディレクトリがない場合と，定義済みは 入力補助しない
		$art_stddir="";
		}
	if ($FlgAtrTag=="on") {												// 新規:ArtDirectoryは複数必要としない。(在っても良い)
		 $newtag="LinkPath";
		 $art_stddir="";
		 }
	else {																// "ArtDirectory"は全てで使用できるので一個は作成を補助
		 $newtag="ArtDirectory";
		 }
	$topdir='"'.implode ('","',$XML_WEBROOT).'"';						// WebRoot Combo用Array
	echo <<<EOM
<script type="text/javascript">
/* --------------------------------------------------------------------------------
	Tag / WebRootが変更されたとき，Directory/Filesを初期化する。(使用目的が異なるため)
	Update / Cancell でTag/WebRoothはクリアする。(関数ではないがコメント)
--------------------------------------------------------------------------------- */
// Tagが変更されたとき，Directory/Filesを初期化する
var ObserveTag=null;var ObserveTop=null;
idEditTag=document.getElementById('idEditTag');
var mo = new MutationObserver(function() {
		if ((ObserveTag !==null)&&(ObserveTag !== document.getElementById('idEditTag').innerText)) {
//			alert(document.getElementById('idEditTag').innerText);
			ObserveTag=document.getElementById('idEditTag').innerText;
			document.getElementById('idEditArtDir').value=ObserveTop=document.getElementById('idEditTop').innerText;
			document.getElementById('idEditDir').innerText=ObserveTop=document.getElementById('idEditTop').innerText;
			}
		if (ObserveTag ==null) {
			ObserveTag=document.getElementById('idEditTag').innerText;
			}
	ArgChangeCheck();
	});
var config = { childList: true };
mo.observe(idEditTag, config);
// WebRootが変更されたとき，Directory/Filesを初期化する
idEditTop=document.getElementById('idEditTop');
var mo = new MutationObserver(function() {
		if ((ObserveTop !==null)&&(ObserveTop !== document.getElementById('idEditTop').innerText)) {
//			alert(document.getElementById('idEditTop').innerText);
			ObserveTop=document.getElementById('idEditTop').innerText;
			document.getElementById('idEditArtDir').value=ObserveTop=document.getElementById('idEditTop').innerText;
			document.getElementById('idEditDir').innerText=ObserveTop=document.getElementById('idEditTop').innerText;
			}
		if (ObserveTop ==null) {
			ObserveTop=document.getElementById('idEditTop').innerText;
			}
	ArgChangeCheck();
	});
var config = { childList: true };
mo.observe(idEditTop, config);

// Filedが変更されたとき
idEditField=document.getElementById('idEditField');
var mo = new MutationObserver(function() {
	ArgChangeCheck();
	});
var config = { childList: true };
mo.observe(idEditField, config);

/* -----------------------------------------------------------------------------
	ArgChangeCheck() : Input Change Check
	内容が変更されたら Update Buttonの色を変える
----------------------------------------------------------------------------- */
function ArgChangeCheck() {
	var no=document.getElementById('idEditNo').innerText;
	if (no == 0) {
		 var tag   = "{$newtag}";
		 var Field = "";
		 var ArtDir= "{$XML_WEBROOTBASE['WebRoot']}";
		 }
	else {
		 var tag   = idOrderTbl.rows[no].cells[1].innerText;	// Tag
		 var Field = idOrderTbl.rows[no].cells[2].innerText;	// Filed
		 var ArtDir= idOrderTbl.rows[no].cells[3].innerText;	// Dirctory
		 }
	if((document.getElementById('idEditTag').innerText !==tag) ||
	   (document.getElementById('idEditField').innerText !==Field) ||
	   (document.getElementById('idEditArtDir').value  !==ArtDir)) {
		 document.getElementById('idEditSubmit').style.backgroundColor='#009900';	// 内容が変わったらUpdate Buttonに色付ける
		 document.getElementById('idEditSubmit').style.color='#CED8F6';
		 }
	else if((document.getElementById('idEditTag').innerText ==tag) &&
		 (document.getElementById('idEditField').innerText ==Field) &&
		 (document.getElementById('idEditArtDir').value ==ArtDir)) {
		  document.getElementById('idEditSubmit').style.backgroundColor='';			// 内容が同じなのでらUpdate Buttonの色を戻す
		  document.getElementById('idEditSubmit').style.color='';
		  }
	}

/* -----------------------------------------------------------------------------
	DispListOrderFunc(no) : Display Edit Source Line
	 no  : i  : 1～ : Edit Line No 
	            Null: New Line
	※ Table:idOrderTbl.rows[n].cells[n].innerText
	         Line rows[n] n:1～ , (*cf 0:Title Line)
	         No:cells[0] Tag:cells[1] Filed:cells[2] Directory:cells[3]
----------------------------------------------------------------------------- */
var TopDir=[{$topdir}];					// WebRoot候補用 Array
function DispListOrderFunc(no) {
	if (no == null) {
		 document.getElementById('idEditTitle').innerHTML="Edit Source Line [NewTag]";		// TitleNew
		 document.getElementById('idEditTag').innerText="{$newtag}";						// Tag
		 document.getElementById('idEditNo').innerText=0;									// no
		 document.getElementById('idEditField').innerText="";								// Filed
		 document.getElementById('idEditTop').innerText="{$XML_WEBROOTBASE['WebRoot']}";		// WebRoot
		 document.getElementById('idEditArtDir').value="{$XML_WEBROOTBASE['WebRoot']}";		// Dirctory
		 }
	else {
		 document.getElementById('idEditTitle').innerHTML="Edit Source Line [#"+idOrderTbl.rows[no].cells[0].innerText+"]";		// TitleNo
		 document.getElementById('idEditNo').innerText=no;											// no
		 document.getElementById('idEditTag').innerText=idOrderTbl.rows[no].cells[1].innerText;		// Tag
		 document.getElementById('idEditField').innerText=idOrderTbl.rows[no].cells[2].innerText;	// Filed
		 document.getElementById('idEditArtDir').value=idOrderTbl.rows[no].cells[3].innerText;		// Dirctory
		 var str=idOrderTbl.rows[no].cells[3].innerText
		 var top="";
		 for (var i = 0; i < TopDir.length; i++) {					// WebRootとPathを分離する
			var ary=str.split(TopDir[i]);
			if (ary.length > 1) {
				top=TopDir[i];
				break;
				}
			}
		 document.getElementById('idEditTop').innerText=top;		// WebRoot
		 }
	document.getElementById('idEditSubmit').style.backgroundColor='';	// Update Buttonの色を戻す
	document.getElementById('idEditSubmit').style.color='';
	}

</script>
EOM;

	}
?>
<script type="text/javascript">
/* -----------------------------------------------------------------------------
	DispListOrderUpdate() : EditBox : ListOrder Update / New Tag
	EditBox：新規Tag/Replace のPost
	id=idEditNo (display:none)にNoを設定(新規0，No:1～)
----------------------------------------------------------------------------- */
function DispListOrderUpdate() {
	var ArtDir=RequestB64Encode(document.getElementById('idEditArtDir').value);
	var post='p=PutOder&no='+document.getElementById('idEditNo').innerText+'&tag='+document.getElementById('idEditTag').innerText+'&field='+document.getElementById('idEditField').innerText+'&path='+ArtDir;

	RequestSureBox('MPDWEB ListArt Setting','ListArtOrder Update\nDirectory/FileSetting\n\n Are you Sure?',function () { RequestLoadDisp(0);RequestByPost(POSTMOD,post,callback) },100,120);
	}

/* -----------------------------------------------------------------------------
	DispListOrderRemove(no) : EditBox : ListOrder Remove XML削除
	no    : i  : Remove No 1～
----------------------------------------------------------------------------- */
function DispListOrderRemove(no) {
	var rmtag=idOrderTbl.rows[no].cells[1].innerText;
	var post='p=RemoveOder&no='+no+'&tag='+rmtag;

	RequestSureBox('MPDWEB ListArt Setting','ListArtOrder Remove Tag\n\n No ['+no+'] Tag['+rmtag+']\n   Are you Sure?',function () { RequestLoadDisp(0);RequestByPost(POSTMOD,post,RequestUnLoadDisp()) },100,120);
	}

/*****************************************************************************
	ListOrderMove Function :
******************************************************************************/
/*
	DispListOrderMoveInit(no) : Move Box Init BOX Display
	no    : i  : Move No 1～
-----------------------------------------------------------------------------*/
function DispListOrderMoveInit(no) {
	document.getElementById("MvPos").innerHTML=no;
	LISTARTMovColor();
	}
/*
	HSTCNFMovColor() : Move Positon Color
*/
function LISTARTMovColor() {
	var idx=document.getElementById("MvPos").innerHTML;
	var i=parseInt(idx);
	var tbl =document.getElementById("idOrderTbl");
	tbl.rows[i].cells[0].style.backgroundColor='#008000';	// NoのCellを取得
	}

/*
	HSTCNFMovExit() : Host Configuration Move Box Exit
	 mode   : i   : 0: OneSession終了 /  1: Playlist Move Operetion終了
*/
function LISTARTMovExit(mode) {
	var tbl =document.getElementById("idOrderTbl");

	if ((mode==1)&&(document.getElementById("MvPos").innerHTML=="")) { return; }
	var idx=document.getElementById("MvPos").innerHTML;
	var i=parseInt(idx);
	tbl.rows[i].cells[0].style.backgroundColor='';	// NoのCellを取得 backgroundColorを初期に戻す
	if (mode == 1) {		// Playlist Move Operetion終了時クリア
		document.getElementById("MvPos").innerHTML="";
		}
	}

/*
	LISTARTMovTouch(id) : Mouse Move Touch id to No
	 id      : i  : 移動To Disp(画面上Posiston id)
	 MoveBox (From) & Touch(To) Operation
*/
function LISTARTMovTouch(id) {
	if (document.getElementById("MvPos").innerHTML=="") {
		return;
		}
	var pos=document.getElementById(id).innerText;
	LISTARTMov(parseInt(pos-1));
	}

/*
	LISTARTMov(pos) : Host Configuration Move
	 pos     : i  : Move To Positon
	 dropfrom: i  : Move From Positon MoveBox時Null。MoveBoxを使用しない場合設定。現在MouceによるDrop:
*/
function LISTARTMov(pos,dropfrom) {
	var tbl =document.getElementById("idOrderTbl");
	if (dropfrom == null) {
		var idx=document.getElementById("MvPos").innerHTML;
		from = parseInt(idx);
		 if (pos == "-") {					// Reqest to Down(-)
			if(from <= 1) { return; }
			to=from - 1;
			}
		 else if (pos == "+") {				// Reqest to Down(+)
			  if((from+1) >= tbl.rows.length) { return; }
			  to=from + 1;
			  }
		 else {								// Reqest to Positon
			  to = parseInt(pos+1);
			  }
		 }
	else {
		 from = parseInt(dropfrom);
		 to = parseInt(pos);
		 idx=parseInt(from);
		 }

//	alert("From["+from+"]To["+to+"]");
	RequestByPost(POSTMOD,'p=MoveOder&fromno='+from+'&tono='+to,'');		// 裏で更新

	rows_from=tbl.rows[from].outerHTML;		// Fromをセーブ
	rows = tbl.deleteRow(from);				// Fromを削除 (先に消さないとToを空行追加時,カウントが変わる)
	row = tbl.insertRow(to);				// To上段に空行を作成
	tbl.rows[to].outerHTML=rows_from;		// ToにFromセーブを挿入

	var i = from;var lend = to;				// Renumber
	if (from > to) { i = to;var lend = from; }
	for(i=1;i < tbl.rows.length;i++) {
		tbl.rows[i].cells[0].idName="idno"+i;
		var str=tbl.rows[i].cells[0].innerHTML;
		str = str.replace(/>(.*?)</,">"+i+"<");
		tbl.rows[i].cells[0].innerHTML=str;
		}
	var idx=document.getElementById("MvPos").innerHTML;
	var i=parseInt(idx);

	if(tbl.rows[i]) {
		tbl.rows[i].cells[0].style.backgroundColor='';	// NoのCellを取得 backgroundColorを初期に戻す
		}
	if (dropfrom == null) {
		document.getElementById("MvPos").innerHTML=parseInt(to);	// MoveFromをToにする(連続Operation)
		LISTARTMovColor();
		}
	}

</script>
<?php
/* -----------------------------------------------------------------------------
	DispListArtOrderDetail() : Edit Order List Detail
	 $reslut : io : True : MyOrder File Exists / False:MyOrder File Not Exists
----------------------------------------------------------------------------- */
function DispListArtOrderDetail() {
	print '<div id=grplist style="position:absolute;left:2px;top:48px;">';
	print '<table id="idOrderTbl" border="3" cellpadding="0" bgcolor="#000000" frame=void style="table-layout:fixed;display:block;">';
	print '<tr><th class="tdHead">No</th><th class="tdHead">Tag</th><th class="tdHead">Field</th><th class="tdHead">Art&nbspDirectory&nbsp/&nbspFile&nbsp Setting</th><th class="tdHead" style="font-style:oblique;">fn</th></tr>';
	$reslut=True;
	$XML_ArtOrder=DispListArtOrderMake($reslut);
	$StdDir="ListArt";$FlgStdDir="";$FlgAtrTag="";							// $StdDir="ListArt":Install Shellで標準的に作成,$FlgStdDir:"ListArt"検出で"on",$FlgAtrTag:"ArtDirectory"検出で"on"
	$no = 1; // Noの初期値
	foreach ($XML_ArtOrder->LISTART_Order->children() as $index => $child) {
		print '<tr>';
		$idbase="idno";
		$id=$idbase.$no;
		print '<td><div id='.$id.' draggable=true align=center class="tdLine" style="width:28px;font-size:10px;cursor:move;">' . $no . '</div></td>';
		print '<td><div class="tdLine" style="width:70px;font-size:11px;">' . $child->getName() . '</td>';
		print '<td><div class="tdLine" style="width:68px;font-size:11px;">' . ($child['Filed'] ? $child['Filed'] : '') . '</td>';
		print '<td><div class="tdLine" style="width:278px;font-size:11px;">' . $child . '</td>';
		$idfunc=$idbase."func".$no;
		DispListArtOrderFunc($idfunc,$no);
		if($reslut==False) {
			 print '<td><button type=submit class="music bfunc" style="width:18px;font-size:12px;text-align:center;color:#a9a9a9;cursor:default;">...</button></td>';
			 }
		else {
			 print '<td><button type=submit class="music bfunc" onclick="RequestBoxDisp(\''.$idfunc.'\');" style="width:18px;font-size:12px;text-align:center;cursor:pointer;">...</button></td>';
			 }
		print '</tr>';

		if ($child->getName()=="ArtDirectory") {
			$FlgAtrTag="on";
			if (strpos($child,$StdDir)!==false) {
				$FlgStdDir="on";
				}
			}
		$no++; // No increment
		}
	print '</table>';
	print '<div style="position:absolute;left:10px;font-size:12px;line-height:180%;color:#b0c4de;">*cf.No. is search order</div>';
	print '</div>';
	return($reslut);
	}

/* -----------------------------------------------------------------------------
	DispListArtOrderMake($reslut) : DispListArtOrder XML Get
	 $reslut : io : True : MyOrder File Exists / False:MyOrder File Not Exists
	 @return : o  : ListArtOrder simplexml形式
----------------------------------------------------------------------------- */
function DispListArtOrderMake(&$reslut) {
	global $XML_ORDERLIST,$XML_LISTART;
	$reslut=True;
	$XML_ArtOrder = simplexml_load_file($XML_ORDERLIST);
	if (!$XML_ArtOrder) {
		$reslut=False;
		$post='RequestByPost(POSTMOD,\'p=Myset\');RequestBoxtUnLoad(\'idMySet\');';
		DispSureBox("on","idMySet",$post,"","MPDWEB ListArt Setting","Make My Order XMLFile<BR>Are you Sure?",100,170);
		$XML_ArtOrder = simplexml_load_file($XML_LISTART);
		}
	return($XML_ArtOrder);
	}

/* -----------------------------------------------------------------------------
	DispHostCnfFuncMove($top,$left): Disp Current Move
	 $top   : i  : 表示位置 top
	 $left  : i  : 表示位置 left
----------------------------------------------------------------------------- */
function DispListArtOrderFuncMove($top=100,$left=413) {
	$id="movebox";
	print '<div id='.$id.' class="box ListArtMovBx" style="width:60px;top:'.$top.'px;left:'.$left.'px;9">';
	print '<div class=boxtitle style="width:40px;">'.'Move'.'</div>';
	print '<button type=submit onclick="LISTARTMov(\'-\')" class="boxline ListArtMovRt" style="absolute;top:48px;">&lt;</button>';
	print '<div id=MvPos class=ListArtMovNo></div>';
	print '<button type=submit onClick="LISTARTMov(\'+\')" class="boxline ListArtMovRt" style="absolute;top:114px;">&gt;</button>';
	$unload = 'LISTARTMovExit(1);RequestBoxtUnLoad(\''.$id.'\');';
	print '<input type="button" class=buttn value="Close" onclick="'.$unload.'" style="position:absolute;top:170px;right:6px;">';
	print '<div class="boxtext ListArtMovCt" style="absolute;top:'.($top+106).'px;left:'.($left-522).'px;">or Touch \'No\' of To..</div>';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DispListArtOrderFuncEdit($top,$left): Disp Current Move
	 $top   : i  : 表示位置 top
	 $left  : i  : 表示位置 left
----------------------------------------------------------------------------- */
function DispListArtOrderFuncEdit() {
	global $XML_FIELD,$XML_WEBROOTBASE,$XML_WEBROOT;

// EditBoxのUnload : Callback RequestSureBox()のUnload
	$editid="editbox";
	$unload = 'RequestBoxtUnLoad(\''.$editid.'\');ObserveTag=null;ObserveTop=null;';
	echo <<<EOM

<script type="text/javascript">
	callback=function () { {$unload};RequestUnLoadDisp(); }		// DispListOrderUpdateのCallback RequestSureBox()のUnload
</script>

EOM;
	
	print '<div id='.$editid.' class=box style="position:fixed;top:70px;left:3px;width:474px;height:230px;">';
	print '<div class=boxtitle id=idEditTitle style="border:0.4px solid #808080;width:454px;height:18px;">Edit Source Line</div>';
	print '<div id=idEditNo style=position:absolute;top:30px;right:10px;display:none;">1</div>';			// No
	print '<div style=position:absolute;top:52px;left:12px;letter-spacing:0.22em;">Tag</div>';				// Input:Tag
	$Tag_sel["style"]["position"]="position:absolute;";
	$Tag_sel["Text"]=array("LinkText","LinkPath","ArtDirectory");
	$Tag_sty="font-size:13px;";
	$Tag_def="";
	MakeSelectBox("get",$Tag_sel,$Tag_def,"idEditTag",70,8,102,"","idEditTagSel","",$Tag_sty);
	print '<div style=position:absolute;top:52px;left:110px;letter-spacing:0.22em;">Filed</div>';			// Input:Field
	$Field_sel["style"]["position"]="position:absolute;";
	$Field_sel["Text"]=$XML_FIELD;
	$Field_sty="font-size:13px;";
	$Field_def="";
	MakeSelectBox("get",$Field_sel,$Field_def,"idEditField",70,112,100,"","idEditFieldSel","",$Field_sty);

	print '<div style=position:absolute;top:52px;left:224px;letter-spacing:0.22em;">WebRoot</div>';			// Input:WebRoot
	$Top_sel["style"]["position"]="position:absolute;";
	$Top_sel["Text"]=$XML_WEBROOT;
	$Top_sty="font-size:13px;";
	$Top_def=$XML_WEBROOTBASE["WebRoot"];
	MakeSelectBox("get",$Top_sel,$Top_def,"idEditTop",70,220,180,"","idEditTopSel","",$Top_sty);
	$post='var top=document.getElementById(\'idEditTop\').value;var tag=document.getElementById(\'idEditTag\').innerText;var art=document.getElementById(\'idEditArtDir\').value;';
	$post=$post.'var ary=art.split(\'/\');var select=ary[ary.length - 1];art=art.replace(\'/\'+select,\'\');';
	$post=$post.'var dir=document.getElementById(\'idEditDir\').innerText=art.replace(top,\'\');var dir=document.getElementById(\'idEditDir\').innerText;';
	$post=$post.'dir=RequestB64Encode(dir);top=RequestB64Encode(top);select=RequestB64Encode(select);';				// B64Encoder
	$post=$post.'RequestByPost(POSTMOD,\'p=getdir&dir=\'+dir+\'&top=\'+top+\'&select=\'+select+\'&tag=\'+tag);';	// Post String
	print '<div style=position:absolute;top:100px;left:12px;letter-spacing:0.22em;">Directory/Files</div>';			// input:Directory/Files
	print '<input type="text" id="idEditArtDir" onchange="ArgChangeCheck();" size="53" value="" style="position:absolute;left:8px;top:116px;cursor:pointer;">';
	print '<button type=submit onclick="RequestBoxDisp(\'idEditDirBox\');'.$post.'" style=position:absolute;top:116px;left:406px;height:22px;width:60px;cursor:pointer;">Search</button>';
	// Directory Select Box Base
	print '<div class=box id=idEditDirBox style="position:fixed;top:'.(70+40).'px;left:8px;width:462px;height:306px;background-color:#272727;border:1px solid #808080;">';// Combo:Directory
	print '<div style=position:absolute;top:6px;left:24px;">Directory&nbsp;Select</div>';
	$selunload='RequestBoxtUnLoad(\'idEditDirBox\');';
	// Directory Select Box
	print '<div id="idEditDir" style="position:absolute;top:26px;left:10px;width:440px;height:22px;padding: 0 0 0 4px;font-size:13px;letter-spacing:0.03em;background-color:#343434;border:0.4px solid #808080;line-height:180%;"></div>';
	print '<div class=box id=idEditDirSel style="position:absolute;top:51px;left:10px;width:440px;height:118px;background-color:##343434;display:block;">';			// Combo:WebRoot
	print '</div>';
	// Directory Submit

	$js='document.getElementById(\'idEditArtDir\').value=document.getElementById(\'idEditTop\').value+document.getElementById(\'idEditDir\').innerText;ArgChangeCheck();';
	print '<button type=submit onclick="'.$js.$selunload.'" style=position:absolute;bottom:8px;left:10px;height:22px;width:60px;">Select</button>';
	print '<input type="button" value="Cancell" onclick="'.$selunload.'" class="buttn boxbcan" style="position:absolute;bottom:10px;right:12px;" />';
	print '</div>';

	print '<div style="position:absolute;bottom:50px;left:20px;font-size:12px;color:#f5f5dc;">*cf1.Tag:"LinkText" is a text file(.txt), Others are directories</div>';

	$js='DispListOrderUpdate();';
	print '<input type="button" value="Update" id="idEditSubmit" onclick="'.$js.'" class="buttn boxbcan" style=position:absolute;bottom:8px;left:20px;" />';
	print '<input type="button" value="Cancell" onclick="'.$unload.'" class="buttn boxbcan" />';
	print '</div>';
	}
/* -----------------------------------------------------------------------------
	DispListArtOrderFunc() : DispListArtOrder Func
----------------------------------------------------------------------------- */
function DispListArtOrderFunc($id,$no) {
	$top=60;$left=177;
	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	print '<div id='.$id.' class=box  style="position:fixed;top:'.$top.'px;left:'.$left.'px;height:220px;">';
	print '<div class=boxtitle>MySet Source Line [#'.$no.']</div>';
	$editid="editbox";
	print '<button type=submit onclick="DispListOrderFunc('.$no.');RequestBoxDisp(\''.$editid.'\');'.$unload.'" class="boxline boxblin1" style="background-color:rgb(8, 8, 77);">Edit Source</button>';
	$moveid="movebox";
//	$posid="ID".$n;
	print '<button type=submit onclick="LISTARTMovExit(1);RequestBoxDisp(\''.$moveid.'\');DispListOrderMoveInit('.$no.');'.$unload.'" class="boxline boxblin2h">Move Source</button>';
	print '<button type=submit onclick="DispListOrderRemove('.$no.');'.$unload.'" class="boxline boxblin4">Remove Source</button>';

	print '<input type="button" value="Cancell" onclick="'.$unload.'" class="buttn boxbcan" />';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DispTaskSetHeader() : Make DispListArtOrder Header
----------------------------------------------------------------------------- */
function DispListArtOrderHeader() {
	$myUrl=ArgURLCount($_SERVER["REQUEST_URI"]);
	print '<div class=head style="top:24;height:25px;">';
	$color_self='background-color:#008000;color:#CED8F6;';			// 自身を示す色
	print '<button type=submit class=buttn onclick="RequestLoadDisp();location.href=\''.$myUrl.'\';" style="width:60;'.$color_self.'">Renew</button>';
	print '<div style="position:fixed;top:26px;left:68px;height:20px;line-height:150%;width:106px;background-color:#333333;color:#ffffff;font-size:12px;text-align:center;">ListArt Setting</div>';
	print '<div style="position:fixed;top:26px;left:179px;height:20px;line-height:150%;width:220px;background-color:#333333;color:#ffffff;font-size:12px;">&nbsp;&nbsp;My Setting,Order Directoris/Files</div>';
	$editid="editbox";
	print '<button id="idNewTag" type=submit class=buttn onclick="DispListOrderFunc();RequestBoxDisp(\''.$editid.'\');" style="position:fixed;top:26px;left:403px;width:50;background-color:#642EFE;color:#CED8F6;">NewTag</button>';
	$funcid="idhfunc";
	print '<button type=submit class="comnd hfunc" onclick="RequestBoxDisp(\''.$funcid.'\');this.blur();" style="position:fixed;top:22px;left:458px;background-color:#008000;margin:2px 0px 0px 0px;18px;">...</button>';
	DispListArtOrderHeaderFunc($funcid);
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DispListArtOrderHeaderFunc() : Make DispListArtOrder Header Function
----------------------------------------------------------------------------- */
function DispListArtOrderHeaderFunc($id,$top=54,$left=175) {
	global $ARG,$XML_SHMLISTART,$MPDWEBLISTART,$XML_FILENAME;

	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	print '<div id='.$id.' class=box style="position:fixed;top:'.$top.'px;left:'.$left.';height:210px;">';
	print '<div class=boxtitle>Order Directoris/Files Function</div>';
	if ($XML_SHMLISTART["Used"] =="on") {													// Shared Memory:on Function
		 $clearurl=$unload.'RequestLoadDisp();RequestByGet(\''.$MPDWEBLISTART.'?p=extend|list&clear\',\'\',function () { RequestUnLoadDisp();RequestMsgBox(\'ListArtOder\',\'Clear&Remake End\',80,70) });';
		 $style="";
		 $memo="Shared Memory : used";
		 }
	else {
		 $clearurl="";
		 $style='style="color:#808080;"';
		 $memo="Shared Memory : Not used";
		 }
// Information Display
	print '<button id="idClear" type=submit onClick="'.$clearurl.'" class="boxline boxblin2"'.$style.'>Cash Clear&Remake:Shared Mem:ListArt</button>';
	print '<div style="position:absolute;top:90px;left:10px;font-size:12px;color:#f5f5dc;">'.$memo.'</div>';
	print '<div style="position:absolute;top:110px;left:10px;font-size:12px;color:#f5f5dc;">File Replace Character</div>';
	$str="";$i=0;
	foreach ($XML_FILENAME["RepChar"]["a"] as $key => $val) {
		if (($val=="")&&($XML_FILENAME["RepChar"]["b"][$key]=="")) { } else {
			if ($XML_FILENAME["RepChar"]["b"][$key]=="") { $char="<span style=\"color:#98fb98;\">null</span>"; } else { $char="'<span style=\"color:#98fb98;\">".$XML_FILENAME["RepChar"]["b"][$key]."</span>'"; } 
			$str=$str."['<span style=\"color:#98fb98;\">".$val."</span>'=>".$char."] ";
			$i=$i+1;
			if ($i >= 4) { $str=$str."<BR>";$i=0; }
			}
		}
	print '<div style="position:absolute;top:125px;left:10px;font-size:12px;color:color:#98fb98;;">'.$str.'</div>';

	print '<input type="button" name="Submit" value="Cancell" onclick="'.$unload.'" class="buttn boxbcan" style="top:180px;" />';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DispHeader() : Edit Header
----------------------------------------------------------------------------- */
function DispHeader($prog="") {
	global $MPDWEB,$MPDWEBLISTART,$XML_LISTART,$XML_EXCLUDE;

	if ($prog =="conf") {
		 $conf_color='background-color:#008000;color:#dbebc4;';
		 $self_color='background-color:#642EFE;color:#CED8F6;';
		 }
	else {
		 $conf_color='background-color:#642EFE;color:#CED8F6;';
		 $self_color='background-color:#008000;color:#dbebc4;';
		 }
	$HTTPListArt=ArgHTMLEncode($XML_LISTART);			// XML設定FileをHTMLエンティティ
// mpdweb 復帰Program
	print '<div class=head style="width:480px;height:24px;z-index:410;">';
	print '<div style="float:left;font-size:11px;width:360px;">';
	print '<button type=submit name=Current value=Current class=buttn onclick="RequestLoadDisp();location.href=\'./'.$MPDWEB.'?p=curren\'" style="position:fixed;top:0px;left:4px;background-color:#642EFE;color:#CED8F6;width:60px;" >NowPlay</button>';
	print '<button type=submit name=ListArt value=List class=buttn onclick="RequestLoadDisp();location.href=\'./'.$MPDWEBLISTART.'?p=extend|list\'" style="position:fixed;top:0px;left:70px;background-color:#642EFE;color:#CED8F6;width:50px;" >ListArt</button>';
// mpdweb.list.php 設定Program
	$js='RequestLoadDisp();location.href=\''.$_SERVER["PHP_SELF"].'\'';
	print '<button type=submit class=buttn  onclick="'.$js.'" style="position:fixed;top:0px;left:124px;'.$self_color.'width:50px;" >Order</button>';
// XML設定共通Program
	$js='RequestLoadDisp();location.href=\''.$_SERVER["PHP_SELF"].'?p=conf&XMLFILE='.$HTTPListArt.'\'';
	print '<button type=submit onclick="'.$js.'" class=buttn style="position:fixed;top:0px;left:178px;'.$conf_color.'width:50px;" >Conf</button>';
	print '<Div value=Playlist class=buttn  style="position:fixed;top:0px;left:234px;width:216px;line-height:150%;height:16px;font-size:12px;border: 1px solid rgb(136, 136, 136);background-color:#333333;color:#DDDDDD;" >&nbsp;&nbsp;&nbsp;&nbsp;MPDWEB List Art Setting</div>';
// Function
	$HFunc="idHedFunc";
	print '<button type=submit onclick="document.getElementById(\'MYJSVER\').innerText=MYJS_VERSION;document.getElementById(\'MYAJAXVER\').innerText=MYJSVER_AJAX;RequestBoxDisp(\''.$HFunc.'\');this.blur();" class="comnd  hfunc" style="left:454px;margin:3px 0px 0px 0px;">...</button>';
	DispFunc($HFunc);
	print '</div></div>';

	if (!Commn_Subnet($XML_EXCLUDE["netmask"],$_SERVER['REMOTE_ADDR'])) {
		_DispHeaderIgnore();
		return(false);
		}
	return(true);
	}

/*
	_DispHeaderIgnore() : NetMask Ignore
*/
function _DispHeaderIgnore() {

echo <<<EOM
<div style="border: 1px solid #888888;position:fixed;top:100px;left:20px;width:440px;height:180px;background-color:#2f2f2f;">
<div style="position:absolute;top:30;left:30;font-size:14px;color:#ff1493;">
Attention !!
</div>
<div style="position:absolute;top:60;left:30;font-size:14px;">
- Settings are not allowed on other networks<BR>
- Run from the same network as the mpd daemon<BR>
- Allowable by changing the netmask in other settings<BR>
</div>
</div>
EOM;
	}

/*******************************************************************************
	DispMountFunc($id) : Mount List Function Box
	 $id    : i  : HTML-id
*******************************************************************************/
function DispFunc($id) {
	global $MY_LISTARTVERSION,$XML_WEBROOTBASE;

	$top=20;$left=174;$def=4;
	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	print '<div id='.$id.' class=box style="position:fixed;top:'.$top.'px;left:'.$left.';height:300px;">';
	print '<div class=boxtitle>mpdweb:Settings Function</div>';

	print '<div class="boxtext" style="top:'.($top+$def+12).'px;left:0px;font-size:9px;">PHP Ver: '.phpversion().'</div>';
	$tmp=$_SERVER['REMOTE_ADDR'];
	if(strlen($tmp) >28) { $tmp=substr($tmp,0,28).".."; } else { $tmp=$tmp.'&nbsp;&nbsp;'; }
	print '<div class="boxtext" style="top:'.($top+$def+26).'px;left:0px;font-size:9px;">REMOTE_ADDR:&nbsp;'.$tmp.'</div>';
	if (isset($_SERVER['HTTP_USER_AGENT'])) {
		$str=$_SERVER['HTTP_USER_AGENT'];
		}
	print '<div class="boxtext" style="height:50;top:'.($top+$def+40).'px;width:278px;font-size:9px;color:#b0c4de;">Information:&nbsp;'.$str.'</div>';
	$mem = sprintf('%.2f',((memory_get_usage()) / 100000));
	$mem = number_format($mem,2);
	print '<div class="boxtext" style="top:'.($top+$def+98).'px;font-size:9px;">PHP Used Memory : '.$mem.' MB</div>';
	print '<div class="boxtext" style="top:'.($top+$def+110).'px;font-size:9px;color:#98fb98;">'.$MY_LISTARTVERSION.'</div>';
	print '<div class="boxtext" style="top:'.($top+$def+122).'px;font-size:9px;">'.(apl_version()).'</div>';
	print '<div class="boxtext" style="top:'.($top+$def+136).'px;font-size:9px;">'.(lib_version()).'</div>';
	print '<div id=MYJSVER class="boxtext" style="top:'.($top+$def+148).'px;font-size:9px;"></div>';
	print '<div id=MYAJAXVER class="boxtext" style="top:'.($top+$def+160).'px;font-size:9px;"></div>';
	print '<div class="boxtext MYCSS_VERSION" style="top:'.($top+$def+172).'px;font-size:9px;"></div>';
	print '<div class="boxtext" style="top:'.($top+$def+186).'px;font-size:9px;">'.(cmnses_version()).'</div>';

	print '<div class="boxtext" style="top:'.($top+$def+212).'px;font-size:9px;">WebRoot</div>';
	if ($XML_WEBROOTBASE["WebRoot"]=="%DOCUMENT_ROOT%") {
		 $str="%DOCUMENT_ROOT% [".$_SERVER['DOCUMENT_ROOT']."]";
		 }
	else {
		 $str=$XML_WEBROOTBASE["WebRoot"];
		 }
	print '<div class="boxtext" style="top:'.($top+$def+224).'px;font-size:9px;color:#98fb98;">'.$str.'</div>';
	print '<div class="boxtext" style="bottom:-2px;font-size:9px;">'."(C)2023 by Mikio Shiratori".'</div>';
	print '<input type="button" value="Cancell" onclick="'.$unload.'" class="buttn boxbcan" />';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DispState() : Disp Status Area
----------------------------------------------------------------------------- */
function DispState() {
	global $XML_DPROG,$STS_MESSAGE;

	if (!isset($STS_MESSAGE)) { $STS_MESSAGE=""; }

	if ($XML_DPROG["Status"] =="on") {						// Statusを表示するかの設定
		 $style = 'style="display:block;"';
		 }
	else {
		 $style = 'style="display:none;"';
		 }
	if ($XML_DISP["Status_Scrollbar"] =="on") { } else { $style=(rtrim($style,'"')).'overflow:hidden;"'; }
	print '<div id="IdState" class=botom style="left:2px;bottom:-1px;width:480px;font-size:11px;z-index:100">';	// RequestLoadDispよりz-indexを上げている
	print '<textarea cols="56" rows="1" readonly id="status" class=StatusL '.$style.'>'.$STS_MESSAGE.'</textarea>';				// Using Debug
	print '</div>';
	}
//----- Source End --------------------------------------------------------------
?>
</body
</html>
