<?php
/*******************************************************************************
	URL GET CONTENS (Used Frame)
	mpdgethtml.php?shell={shell}&emsg={emsg}&url={url} | mpdgethtml.php?b64={word}
	  shell  : XML<Shell_{shell}>の設定を使用する 省略時:curl
	  service: HTML Srting 編集のパターンを指定 XML<http_develop><{service}> 省略時:なし
	  emsg   : エラー編集のパターンを指定 XML<EMsg__{emsg}>の設定を使用する 省略時:HTTP
	  url    : Display URL 
	 ※パラメータ"url"は最後にすること

   	mpdgethtml.php?var : Version表示

   	mpdgethtml.php?b64={word} : B64変換

 ※参考
  設定でcurlを使用できる。
  MusicPlay PC/RaspberryPiに負荷を掛けたくない場合、TaskServer経由で他の機器でcurlを使用できる
  {ThisPath}setting/mpdweblink.xml : <GetHTML><Use_curl>on</Use_curl :Command curlを使用する
  使用する場合は下記をcurlをインストール後下記を行う。

 Cache Clear
	sudo sh -c "sync; echo {Cache} > /proc/sys/vm/drop_caches"
	 Cache: 1:Page Cache
	        2:Slab Cache
            3:Page/Slab
 Cache show
    free -m

 curlでCacheするっていう機能:放置するとmemoryを使用 NSS_SDB_USE_CACHEをYESかNOにするとsdb_measureAccessを呼ばなくなる
 cURL dentry
	 export NSS_SDB_USE_CACHE=YES
	 php関数: putenv("NSS_SDB_USE_CACHE=YES");
*******************************************************************************/
$MY_VERSION="mpdgethtml 1.2 (01.03.2025)";
if (isset($_GET["b64"])) { $ARG['url']="";print $MY_VERSION;print "<BR><BR>";print "Input[".$_GET["b64"]."] -> b64[".(base64_encode($_GET["b64"]))."]<BR><BR>";exit; }
if (isset($_GET["var"])) { $ARG['url']="";print $MY_VERSION;print "<BR><BR>";exit; }
ob_start();												// StanderdOutをセット
DispStatus('Loading...');
ob_flush();
$dary= explode('/',trim(dirname($_SERVER['PHP_SELF']),"/"));
if (count($dary) > 1) { $dir="/".$dary[count($dary)-1]; } else { $dir=""; }		// 自身のモジュールより, count =< 2 : 同じ階層に配置と見なす count > 2 : mpdwebより一階層下に配置と見なす
$_FILE_=str_replace($dir,"",dirname(__FILE__));									// $_FILE_   : mpd Library Directory
$PWA=dirname(__FILE__);									// TaskServerの設定/Libraryは,require:mpdtask.if.lib.phpを使用する。

$require_ses =$_FILE_.'/mpdcmnses.lib.php';				// Mpd Session id Library ※ mpdtask.if.lib.phpより先にrequireすること
$require_mod =$_FILE_.'/mpdtask.if.lib.php';			// mpd:mpdtask.if.lib.php Application Libraryに移動 (XML定義を取得するため)
chdir($_FILE_);											// 実行Directoryを変更
$REQUIRE="on";
require_once($require_ses);								// require mpdcmnses.lib.php
require_once($require_mod);								// require mpdtask.if.lib.php

$SESSION_CONF=@GetSessionConfig();						// php Session Config (GetEnvCommon経由)
@ArgSessionStart($SESSION_CONF);						// Start Session : Used mpdcmnses.lib.php
if (GetEnvTaskCommon() ===false) {						// mpdtask.if.lib.php mpdtask.xml Get&Edit
	 if ((isset($REQUIRE))&&($REQUIRE=="on")) { $REQUIRE="failed"; } else { exit(); }		// require_onceの時はexitしない
	 }
chdir($PWA);											// 実行Directoryを変更
ob_end_clean();
if ($REQUIRE=="failed") {
	$ret="Require failed : mpdtask.if.lib.php";
	$ermsg[0]="Error,XML Setting: mpdtask.xml";
	$ermsg[1]="E06";$ermsg[2]="Init Error (require)";$ermsg[3]="Require Get failed:".$require_mod;
	Put_ErrBox($_SERVER['SERVER_ADDR'],"XML GetLoadconfig(GetEnvGetHTML)",$ermsg[3],$ret,$ermsg);
	DispStatus("Prosess End(Error)");
	exit;
	}
$ARG=GetArgument();
if ((!isset($ARG["url"]))||($ARG["url"]=="")) { 		// URLが未設定
	DispStatus("Prosess End(Error)");
	exit;
	}
if (GetEnvGetHTML() !=="") {							// GateAppが設定時,Jump
	DispStatus($ARG["url"]);
	exit;
	}
if (GetGateApp() =="1") {								// GateAppが設定時,Jump
	DispStatus($ARG["url"]);
	exit;
	}

Put_LodingMsg();

$buf=url_get_contents($ARG['url']);
print $buf;
print "<BR><BR>";
DispStatus($ARG['url']);
ob_flush();
exit;

/* -----------------------------------------------------------------------------
	DispStatus($str) : Display Status
	 $str  : i  : Display string
----------------------------------------------------------------------------- */
function DispStatus($str) {
	print '<footer class=boxon>';
	print '<div id="idGetHtmlSts" >'.$str.'</div>';
	print '</footer>';
	}

/* -----------------------------------------------------------------------------
	GetArgument();
	 @return: o  : 起動引数 $_POST|$_GET $_POST優先
----------------------------------------------------------------------------- */
function GetArgument() {
	$ARG=array();									// &URLは必須パラメータ
	if (isset($_POST["url"])) { $ARG=$_POST; }			// $_POSTにURLが設定されているので採用
	else if (isset($_GET["url"])) { $ARG=$_GET; }		// $_GETにURLが設定されているので採用
	else {
		 $ermsg[0]="Calling Parameter Error";
		 $ermsg[1]="E02";$ermsg[2]="kick failed";$ermsg[3]="Cannot start";
		 $errstr="mpdgethtml : Calling Parameter Error,kick failed,Cannot start";
		 Put_ErrBox("Request[".$_SERVER['SERVER_ADDR']."]","Request [ ".$_SERVER['REQUEST_URI']." ]","Calling Parameter Error,kick failed,",$errstr,$ermsg);
		 $ARG['url']="";
		 }
	$ARG['url']=str_replace(' ','+',$ARG['url']);					// " "->"+" : URL 変換
	if (!isset($ARG['shell'])) { $ARG['shell']='curl'; }			// Shell未設定時 "curl"をDefault
	if (!isset($ARG['emsg'])) { $ARG['emsg']='HTTP'; }				// Used Error Message Array 未設定時 "HTTP"をDefault
	if (!isset($ARG['service'])) { $ARG['service']=''; }			// Used Service,使用する編集設定 未設定時 "Last.fm"をDefault
//print_r($ARG);
	return($ARG);
	}

/* -----------------------------------------------------------------------------
	GetEnvGetHTML() : Environment Common Set
	 $XML_File = "/setting/mpdweblink.xml";←変更可能
----------------------------------------------------------------------------- */
function GetEnvGetHTML() {
	global $ARG,$XML_CONF,$XML_GETHTML,$XML_HOST,$XML_SHELL,$XML_GETSHELL,$XML_EMSGDEF,$XML_ENVPASS,$XML_EMSG,$_FILE_;		// $ARG:Argument , $XML_CONF:XMLArray , $XML_GETHTML:$XML_HOST:TaskServeerConnetSetting , $XML_EMSGDEF:ErrorEdit/Default , $XML_EMSG:ErrorMessageArray, $_FILE_:mpdweb HomePat;

	$ret="";
	$XML_CONF=NULL;
	try {
		$XML_File=dirname(__FILE__)."/setting/mpdweblink.xml";
		$XML_CONF = get_loadconfig($XML_File);										// XML File Get FileNameはLibrary標準
		} catch( Exception $e ) {
	  $ret=$e->getMessage();
	  $ermsg = array_fill(0, 4,"");													// Edit , Error Message
	  $path=pathinfo($XML_File);
	  $ermsg[0]="Error,XML Setting : ".$path['filename'].".".$path['extension'];
	  $ermsg[1]="E01";$ermsg[2]=$XML_File;$ermsg[3]=$ret;
	  $ary=explode("Error",$ret);
	  $ermsg[2]=$ary[0];
	  if (isset($ary[1])) { $ermsg[2].="Error";$ermsg[3]=trim(trim($ary[1]," "),":"); }
	  Put_ErrBox($_SERVER['SERVER_ADDR'],"XML GetLoadconfig(GetEnvGetHTML)","//".$_SERVER['SERVER_ADDR']."/".$_SERVER['PHP_SELF'],$ret,$ermsg);
	  return($ret);
	  }
	$XML_GETHTML=array("GateApp"=>"","Limit"=>"off","Use_curl"=>"off");				// GetHTML設定 Limit[on]:制限モードレスポンスを考慮
	get_config("GetHTML",$XML_GETHTML);

// TaskServerを任意に設定できるので設定を取得
	if($XML_GETHTML["Use_curl"]=="on") {
		$tmp_host=array("Host"=>"{%home%/setting/mpdtask.xml:/TaskServer/Host}","Port"=>"9050","Timeout"=>"5","Accunt"=>"login=mpdweb:mpdweb\n","TermStr"=>"\x1b\n");	// Task Server I/F設定
		$tmp_host["Host"]=str_replace('%home%',rtrim($_FILE_,"/"),$tmp_host["Host"]);					// mpdweblink.php固有
		$sv_host=$tmp_host["Host"];														// XMLの設定を取得 設定時:mpdtask.xmlと同じ形式)
		get_config("TaskServer",$tmp_host);
		$tmp_host["Host"]=str_replace('%home%',rtrim($_FILE_,"/"),$tmp_host["Host"]);					// mpdweblink.php固有
		if (($sv_host == $tmp_host["Host"])||($tmp_host["Host"]=="")) { } else {			// 未設定か,mpdtask.xmlを使用の場合は,require_once[mpdtask.if.lib.php.php]を使用
			if ($mpd_net["Host"]=="localhost") {
				$mpd_net["Host"] = str_replace("localhost",$_SERVER["SERVER_ADDR"],$mpd_net["Host"]);	// localhostに設定時,shell実行のAddressを設定
				}
			$tmp_host["TermStr"] = str_replace("%1b","\x1b",$tmp_host["TermStr"]);			// TaskSaver TaskEnd Send Character
			$result = preg_match_all('/{(.*?)}/s',$tmp_host["Host"],$part,PREG_SET_ORDER);	// Result:正規表現:<{}>を検出 $part[n][0]:{Item} [1]:Value
			if (isset($part[0][1])) {
				$tmp_host["Host"]=GetEnvHost($part[0][1],"/TaskServer/Host");				// Hostが他のXMLにLinkされているときGet
				if ($tmp_host["Host"] ===false) {
					 $ret="ServerName Get failed : GetEnvHost";
					 $ermsg[0]="Error,XML Setting:Host Name";
					 $ermsg[1]="E04";$ermsg[2]="GetEnvHost(Host)";$ermsg[3]="ServerName Get failed:".$part[0][1];
					 Put_ErrBox($_SERVER['SERVER_ADDR'],"XML GetLoadconfig(GetEnvGetHTML)",$part[0][1],$ret,$ermsg);
					 return($ret);
					 }
				}
			$XML_HOST=$tmp_host;
			}
		$tmp_Force=array("Force"=>"");														// TaskServer[Force]が設定されている場合は使用する
		$tmp_Force["SetNo"]=get_config("TaskServer",$tmp_Force);
		if ($tmp_Force["Force"] !=="") {
			$XML_HOST["Force"]=$tmp_Force["Force"];
			}
		$tmp_shell=array("sudo-s"=>"{%home%/setting/mpdtask.xml:/ShellExec/sudo-s}");		// sudoの設定 mpdgethtml.php固有取得方法
		$tmp_shell["sudo-s"]=str_replace('%home%',rtrim($_FILE_,"/"),$tmp_shell["sudo-s"]);
		$sv_shell=$tmp_shell["sudo-s"];														// XMLの設定を取得 設定時:mpdtask.xmlと同じ形式)
		get_config("ShellExec",$tmp_shell);
		$tmp_shell["sudo-s"]=str_replace('%home%',rtrim($_FILE_,"/"),$tmp_shell["sudo-s"]);
		if ($sv_shell == $tmp_shell["sudo-s"]) {											// mpdtask.xmlを使用の場合は,require_once[mpdtask.if.lib.php.php]を使用
			  $XML_ENVPASS["GetShell"]["valid"]=0;					// 自由に設定できるため直接Passwordを指定時はMulti Host Serach Passを使用しない
			  }
		 else {										
			  if ($tmp_shell["sudo-s"]=="localhost") {
					$tmp_shell["sudo-s"] = str_replace("localhost",$_SERVER["SERVER_ADDR"],$tmp_shell["sudo-s"]);	// localhostに設定時,shell実行のAddressを設定
					}
			  $result = preg_match_all('/{(.*?)}/s',$tmp_shell["sudo-s"],$part,PREG_SET_ORDER);	// Result:正規表現:<{}>を検出 $part[n][0]:{Item} [1]:Value
			  if (isset($part[0][1])) {
					$tmp_shell["sudo-s"]=GetEnvHost($part[0][1],"/ShellExec/sudo-s","");							// Hostが他のXMLにLinkされているときGet
					if ($tmp_shell["sudo-s"] ===false) {
						 $ret="ServerName Get failed : GetEnvHost";
					 	$ermsg[0]="Error,XML Setting:Sudo";
						 $ermsg[1]="E05";$ermsg[2]="GetEnvHost(Sudo)";$ermsg[3]="ServerName Get failed:".$part[0][1];
						 Put_ErrBox($_SERVER['SERVER_ADDR'],"XML GetLoadconfig(GetEnvGetHTML)",$part[0][1],$ret,$ermsg);
						 return($ret);
						 }
					}
				$XML_SHELL["sudo-pw"]=base64_decode($tmp_shell["sudo-s"]);
				}
		$ARG["sudo-pw"]=$XML_SHELL["sudo-pw"];
		$XML_GETSHELL=array("Shell"=>"curl -fsSL \"%url%\" 2>&1","ShellError"=>"curl:","ErrorValidStr"=>"");		// Shell設定 URL Shell別
		get_config("Shell_".$ARG["shell"],$XML_GETSHELL);
		}
	$XML_EMSGDEF=array("ENoStr"=>"/[0-9]{3}/","Ermsg1Def"=>"Requested Returned Failed","Ermsg2Def"=>"Requested Failed");		// Shell設定 URL Shell別
	get_config("EMsg_".$ARG['emsg'],$XML_EMSGDEF);

	$XML = get_object_vars($XML_CONF);
	$XML_EMSG=array();
	$ary=get_xml_attri_array($XML["EMsg_".$ARG['emsg']]);
	foreach ($ary["Val"] as $no =>$val) {
		if (isset($ary["Att"][$no]["Code"])) {
			$eno=(String)$ary["Att"][$no]["Code"];
			$XML_EMSG[$eno]=$val;
			}
		}
	if (count($XML_EMSG) ==0) { $XML_EMSG["E99"]="Requested Returned Failed"; }
//print_r($XML_HOST);print "[".$_FILE_."]<BR>";
//print_r($ARG);
//print_r($XML_GETHTML);
//print_r($XML_GETSHELL);
//print_r($XML_EMSG);
	return($ret);
	}

/* -----------------------------------------------------------------------------
	GetGateApp() : Cheack GateApplication , Gate
	 @return : 0:GateApplicationを使用しない 1:GateApplication完了
	※GateGateApplication : 設定で指定したGateAppにリンクする。
----------------------------------------------------------------------------- */
function GetGateApp() {
	global $XML_GETHTML;

	$url= explode('?',$_SERVER['REQUEST_URI']);
	$GATEAP=$XML_GETHTML["GateApp"];
	if (($GATEAP=="")||(!isset($url[1]))) { return("0"); }
	$alturl=$GATEAP."?".$url[1];
	$alturl=str_replace('+&+','+%26+',$alturl);
	$buf = file_get_contents($alturl);
	print $buf;
	if ($buf=="") {
		$ermsg[0]="GateAp, Request failed";
		$ermsg[1]="E04";$ermsg[2]="GateApp failed";$ermsg[3]="GateAp Cannot Connect";
		$errstr="GateAp, Request failed : ".$XML_GETHTML["GateApp"];
		Put_ErrBox("Request[".$_SERVER['SERVER_ADDR']."]","Gate[".$XML_GETHTML["GateApp"]."]","GateAp, Request failed",$errstr,$ermsg);
		$ARG['url']="";
		}
	return("1");
	}

/*******************************************************************************
	url_get_contents($url) : URLからContensを取得する
	 $url   : i  : URL
	 @return: o  : HTML
*******************************************************************************/
function url_get_contents($url) {
	global $ARG,$XML_GETHTML;						// $XML_GETHTML:$XML GetHTML設定

//	print (empty($_SERVER['HTTPS']) ? 'http://' : 'https://').$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']."<BR>";		// Used Test
	$ary=parse_url($url);
	if ((isset($ary["scheme"]))&&(isset($ary["host"]))) {
		$REQ_URLHOST=$ary["scheme"]."://".trim($ary["host"],"/");
		$REQ_URLHOST=rtrim($REQ_URLHOST,"/")."/";
		}
// Jump時付加するURL Parameter 呼ばれた形式を継承
	$reqpat=explode("?",$_SERVER["REQUEST_URI"]);		// URL Parameter Base
	$REQ_URLSTR=$reqpat[0];
	$str="";
	if (isset($reqpat[1])) {
		parse_str($reqpat[1],$urlarg);
		foreach ($urlarg as $key => $val) {
			if ($key !=="url") {
				$str=$str.$key."=".$val."&";
				}
			}
		 }
	$REQ_URLSTR=$reqpat[0]."?".$str;
// Service別 PHP設定Get(All)
	$phpstr=_url_get_contents_php($ARG["service"]);
	$phpstr=str_replace('%HTML_BUFFER%','$buf',$phpstr);
	$phpstr=str_replace('%REQ_URLSTR%','$REQ_URLSTR',$phpstr);
	$phpstr=str_replace('%REQ_URLHOST%','$REQ_URLHOST',$phpstr);
// Service別 PHP設定Get(Limit=off)
	$limit_phpstr=_url_get_contents_php("Limit_".$ARG["service"]);
	$limit_phpstr=str_replace('%HTML_BUFFER%','$buf',$limit_phpstr);
	$limit_phpstr=str_replace('%REQ_URLSTR%','$REQ_URLSTR',$limit_phpstr);
	$limit_phpstr=str_replace('%REQ_URLHOST%','$REQ_URLHOST',$limit_phpstr);
// Jump時付加するURL Hostname
	$hary= explode(':',$REQ_URLHOST);
	if (isset($hary[1])) { $host=$hary[1]; } else { $host=""; }
	$mode=1;							// mode 0:ArrayOut 1:StringOut ロジックはいずれでも可だが mode:0時 Stringに展開するのでレスポンスに不利
	$buf=url_get_taskserv($url,$mode);
//print $phpstr."<BR>";print '$REQ_URLHOST['.$REQ_URLHOST.'<BR>';	// 例)$REQ_URLHOST[https://www.last.fm/
// Get HTML Buffer成形
	if (is_array($buf)) {						// TaskServerの結果をArrayで受信
		$str="";
		foreach ($buf as $val) {
			$val=str_replace("\n","",$val);		// href="/ -> href="https://{server}/ : オリジナルサイトに変更
			$val=trim($val);
			if ($val =="") { continue; }
			$str=$str.trim($val)."\n";
			}
		$buf=$str;
		}
// HTMLにSelfURLを付加する。
	$buf=str_replace('href="/','href="'.$REQ_URLHOST,$buf);		// href="/ -> href="https://{server}/ : オリジナルサイトに変更
	$buf=str_replace('src="/','src="'.$REQ_URLHOST,$buf);		// src="/  -> src="https://{server}/  : オリジナルサイトに変更
// HTML固有の編集 XML設定から実行
	if ($phpstr !=="") {
		eval($phpstr);										// PHP実行
		}
// HTMLにmpdweb/mpdgethtml.php?url=を付加する
	if ($XML_GETHTML["Limit"]=="off") {		// 制限モード	// Last.fmで調査:Frame表示をさせたいため本プログラムを経由するように書き換え (onclickを使用すると対応できない)
		if ($limit_phpstr !=="") {
			eval($limit_phpstr);							// PHP実行
			}
		}
//$buf="";							// Used Debug
	return($buf);
	}

/*
	_url_get_contents_php($tag) : Get php xml:http_develop
	 $tag   : i  : Get XML Section
*/
function _url_get_contents_php($tag) {
	global $XML_CONF;						// $XML_GETHTML:$XML GetHTML設定

	$ary="";$phpstr="";$attri=array();
	if ($ARG["service"] !=="") {
		$out="2";$rep=array("\t"=>"","\n"=>"");
		$ary=get_xml_String($XML_CONF,"http_develop",$tag,$out,$rep,1,$attri);				// <http_develop><{$ARG["service"}]>
		}
	if (is_array($ary)) {
		foreach($ary as $key => $val) {
			$result = preg_match_all('/<\?php(.*?)\?>/si',$val,$part,PREG_SET_ORDER);		// 正規表現:<{Item}>を検出 $part[n][0]:{Item} [1]:Value
			foreach($part as $key => $par) {		// PHP String $part[n][1]
				$str=str_replace($par[0],"",$str);
				$str=$str.(trim($par[1]));
				}
			$phpstr=$phpstr.$str;
			}
		}
//print "PHP(".$tag.") : ".$phpstr."<BR>";
	return($phpstr);
	}

/*<http_develop>の定義方法 :eval
   Last.fm固有な置換
	$buf=str_replace('data-station-url="/','data-station-url="'.$REQ_URLHOST,$buf);
	$buf=str_replace('data-track-url="/','data-track-url="'.$REQ_URLHOST,$buf);
	$buf=str_replace('data-lazy-buylink-url="/','data-lazy-buylink-url="'.$REQ_URLHOST,$buf);

	$buf=str_replace('data-lazy-filter-endpoint="/','data-lazy-filter-endpoint="'.$REQ_URLHOST,$buf);
	$buf=str_replace('data-artist-url="/','data-artist-url="'.$REQ_URLHOST,$buf);
	$buf=str_replace('data-track-url="/','data-track-url="'.$REQ_URLHOST,$buf);

	$buf=str_replace('data-spotify-initial-device-modal="/','data-spotify-initial-device-modal="'.$REQ_URLHOST,$buf);
	$buf=str_replace('data-spotify-premium-modal="/','data-spotify-premium-modal="'.$REQ_URLHOST,$buf);
*/


/* -----------------------------------------------------------------------------
	url_get_taskserv($url) : ContensをTaskServer(mpdtaskserver)から取得する
	 $url   : i  : URL
	 $mode  : i  : 0:@return is array, 1:@return is string
	 @return: o  : HTML
	 ※ mpdtaskserver / cURLがインストールされていること
	    # apt-get install curl : Volumio2にはインストール済
----------------------------------------------------------------------------- */
function url_get_taskserv($url,$mode) {
	global $XML_HOST,$XML_GETHTML,$XML_GETSHELL,$XML_ENVPASS,$ARG;					// $XML_HOST:require module '/mpdtask.if.lib.php.php'の設定を共有 , $XML_GETSHELL:Shell設定

	if($XML_GETHTML["Use_curl"]!=="on") {
		$options = [
			"http" => [
			"method"  => "GET",
			"header"  => "User-Agent: PHP\r\n"
			]
		];
		$response="";
		$context = stream_context_create($options);
		$response = file_get_contents($url, false, $context);
		return($response);
		}

	$ARG_KEY = array_keys($ARG);foreach ($ARG_KEY as $key=> $val) { $ARG_KEY[$key]="%".$val."%"; }
	$sendstr=str_replace($ARG_KEY,$ARG,$XML_GETSHELL["Shell"])."\n";
	$host="";$rhost="";
	if (isset($_SERVER["REMOTE_ADDR"])) {
		$rhost=$_SERVER["REMOTE_ADDR"];
		}
	if (isset($_SERVER["HTTP_HOST"])) {
		$urlary = parse_url($_SERVER["HTTP_HOST"]);		// {host}:{88}
		if (isset($urlary["host"])) { $host=$urlary["host"]; }
		}
// Task Serverが HTTP Serverと同じ場合,Shellで求める
	$shell=0;
	$sendstr=ArgMakeSvrCmd($sendstr);					// sudoがあるとき，直接Password指定しないときは，Multi HostPasswordを使用する(現在URLをGetのためにはsudoは未使用)
	$sendstr=ArgURLJpEncode($sendstr);
//	$fp = fopen("debuglog.txt", "a");fwrite($fp,$sendstr);fclose($fp);
	if ($XML_HOST["Force"] == "off") {					// $XML_HOST["Force"]:on時常にTaskServer使用
		if (($XML_HOST["Host"]=="localhost")||($XML_HOST["Host"]=="127.0.0.1")||(($host !=="")&&($host==$XML_HOST["Host"]))||(($rhost !=="")&&($rhost==$XML_HOST["Host"]))) {
			$shell=1;
			}
		}
	if ($shell==1) {
		if ($mode==1) {
			  $ret = shell_exec($sendstr);
			  }
		 else {
			  exec($sendstr,$ret);
			  }
		 }
	else {
		 $ret=SockCmdsend($XML_HOST["Accunt"],$sendstr,$XML_HOST["Host"],$XML_HOST["Port"],$XML_HOST["Timeout"],$XML_HOST["TermStr"],$mode,$errno,$errstr);
		 if (!$ret) {
			$ermsg[0]="Sock_Common Error";
			$ermsg[1]=$errno;$ermsg[2]="Socket Connect Failed";$ermsg[3]=$errstr;
			$errstr='Sock_Common : Connect Error Connecting: ErrNo:'.$errno.' : '.$errstr;
			Put_ErrBox("Request[".$_SERVER['SERVER_ADDR']."]","Connect[".$XML_HOST["Host"]."]","TaskServer Request Sock_Common Error",$errstr,$ermsg);
			$ret="";
			}
		 if ((!is_array($ret))&&(strpos($ret,"Reject\n") !== false)) {	// Last.FMの応答に"unhandledPromiseRejection:1"が含まれたため"Reject「\n」"をErrorにした
			$ermsg[0]="Sock_Common Error";
			$ermsg[1]="E03";$ermsg[2]="Login failed";$ermsg[3]="Check Accunt/Password";
			$errstr="Sock_Common : Connect Error Connecting : Login failed";
			Put_ErrBox("Request[".$_SERVER['SERVER_ADDR']."]","Connect[".$XML_HOST["Host"]."]","TaskServer Request Sock_Common Error",$errstr,$ermsg);
			$ret="";
			}
		 }

	if(strpos($ret,$XML_GETSHELL["ShellError"]) !== false){		// 設定のError判定文字列が含まれるかチェック : cURLのError形式 curl:({no})
		Put_Error($url,$ret);
		$ret="";
		}

//print "ret[".$ret."]<BR>";
	return($ret);
	}

/* -----------------------------------------------------------------------------
	ArgURLJpEncode($str) : String ,URL Encode 文字列からURLを抽出しEncode
	 $str   : i  ; String URLを含む https:～"
	 @return: o  : New String
	https:から"までのStringからURL漢字を分離しEncode。Last.Fmをターゲットとしている
     例)  "https://www.last.fm/ja/music/宇多田ヒカル/+tracks"
	   → "https://www.last.fm/ja/music/%89F%91%BD%93c%83q%83J%83%8B/+tracks"
----------------------------------------------------------------------------- */
function ArgURLJpEncode($str) {
	if(preg_match_all('/https:.*?\"/', $str, $result) !== false){
	foreach ($result[0] as $ary){
			$after=_ArgURLJpEncodePearge($ary);
			$str=str_replace($ary,$after,$str);
		    }
		}
	return($str);
	}

/*
	_ArgURLJpEncodePearge($str): 
	 $str   : i  ; String(漢字を含む)
	 @return: o  : Encode String
*/
function _ArgURLJpEncodePearge($str) {
 	return preg_replace_callback(
		'/[^\x21-\x7e]+/',
		function( $matches ) {
			return urlencode( $matches[0] );
		},
		$str );
	}

/* *****************************************************************************
	frame内に固有のFunctionを追加
	 php : Put_Error()         : Error Message HTML Put
	       Put_LodingMsg()     : Loading Message HTML Put (Difference: dezgin : diggin)
	 js  : RequestLoadDisp     : Display Loading Message (Same: mpdweb.common.js )
	       RequestUnLoadDisp() : Display Message Unload  (Same: mpdweb.common.js)
***************************************************************************** */
/* -----------------------------------------------------------------------------
	Put_Error($title,$str) : Put Error Message (Curl)
	 $title : i  ; URL形式
	 $str   : i  : Message String
----------------------------------------------------------------------------- */
function Put_Error($title="",$str="") {
	global $XML_GETSHELL,$XML_EMSGDEF,$XML_EMSG;

	$part=parse_url($title);
	$host=$title;$query="";
	if (isset($part["host"])) {
		$host=$part["host"];
		if (isset($part["path"])) { $query=$part["path"]; }
		if (isset($part["query"])) { $query=$query.$part["query"]; }
		}
	$ermsg = array_fill(0, 4,"");
	if ($XML_GETSHELL["ErrorValidStr"] !=="") {
		 $erary = preg_split($XML_GETSHELL["ErrorValidStr"],$str,PREG_SET_ORDER);		// Format :(Ex."/curl:(.*?)\)(.*?)/si"でcurl: (22) を捨てる)
		 }
	else {
		 $erary[1]=$str;															// Formatが指定されない場合は指定文言をそのまま使用
		 }
	if (isset($erary[1])) {										// $erary[1]に有効となるStringを格納となる正規表現
		$ermsgar=$erary[1];
		preg_match($XML_EMSGDEF["ENoStr"],$str,$match);			// ErrorNo取得(default"/[0-9]{3}/":数字3桁)がErrorNo MessageArrayに対応
		if (!isset($match[0])) { $match[0]=""; }
		$ermsg[1]=$match[0];									// $ermsg[1]:Error No
		$msg=explode($ermsg[1],$ermsgar);
		$ermsg[0]=$msg[0];										// $ermsg[0]:メッセージ ErrorNo前の文言
		if ($ermsg[0]=="") { $ermsg[0]=$XML_EMSGDEF["Ermsg1Def"]; }
		if (isset($msg[1])) { $ermsg[2]=$msg[1]; }				// $ermsg[2] ErrorNo後のString
		else { $ermsg[2]=$XML_EMSGDEF["Ermsg2Def"]; }
		}														// $ermsg[3]:ErrorNoの文言
	if (($ermsg[1] !=="")&&(isset($XML_EMSG[$ermsg[1]]))) { $ermsg[3]=$XML_EMSG[$ermsg[1]];} else {
		if ($ermsg[1] =="") { $ermsg[1]="E99"; }
		$ermsg[3]=$XML_EMSG["E99"];
		}
	Put_ErrBox($host,$query,$title,$str,$ermsg);
	}

/* -----------------------------------------------------------------------------
	Put_ErrBox($host,$query,$ermsg) : Put Error Box
	 $host  : i  ; Display Host
	 $query : i  : Display Query
	 $title : i  ; Message Title
	 $str   : i  : Message Full
	 $ermsg : i  : Message Array [0]:Error Title [1]:ErrorNo [2]:Message1 [3]:Message2
	 ※$host,$strを>Native Messageに表示する
----------------------------------------------------------------------------- */
function Put_ErrBox($host,$query,$title,$str,$ermsg) {

print <<<EOM
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" >

</head>
<style type="text/css">
body {background-color:#f5f5f5;;color:#ffffff;margin-left:4px;font-family:Verdana,"Meiryo UI",sans-serif;font-size:80%;}
.boxtitle {position:absolute;top:0px;left:0px;width:100%;height:50px;background-color:#ff7f50;color:#CEECF5;font-size:14px;text-align:left;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;padding:8px 10 2px;}
.boxtext {position:absolute;top:60px;left:20px;width:360px;height:200px;line-height:20px;font-size:15px;color:#000000;text-align:left;overflow:hidden;word-wrap: break-word;text-overflow:ellipsis;"}
.boxfooter {position:absolute;bottom:0px;left:0px;width:100%;height:70px;background-color:#ff7f50;color:#CEECF5;font-size:14px;text-align:left;overflow:word-break:break-all;padding:8px 10 2px;}
</style>
<body>
<div class=boxtitle>
<p style="position:absolute;top:-14px;left:10px;font-size:20px;">{$host}</p>
<p style="position:absolute;top:20px;left:14px;font-size:14px;color:#000000;">Query:{$query}</p>
</div>
<div class=boxtext>
<p style="position:absolute;top:10px;left:10px;font-size:14px">{$ermsg[0]}</p>
<p style="position:absolute;top:30px;left:10px;font-size:30px;color:#dc143c;">{$ermsg[1]}</p>
<p style="position:absolute;top:50px;left:80px;font-size:16px">{$ermsg[2]}</p>
<p style="position:absolute;top:90px;left:10px;word-break:break-all;font-size:12px">{$ermsg[3]}</p>
</div>
<div id=boxbottom class=boxtitle style="top:500px">
<p style="position:absolute;top:0px;left:10px;font-size:10px;color:#dc143c;">Native Message</p>
<p style="position:absolute;top:14px;left:10px;font-size:10px;color:#000000;">{$title}<BR>{$str}</p>
</div>
</body>
</html>
EOM;

	}

/* -----------------------------------------------------------------------------
	Put_LodingMsg() : Display Loading Message
----------------------------------------------------------------------------- */
function Put_LodingMsg() {
ob_start();
print <<<EOM
<script type="text/javascript">

var GObjSTime;				// 起動待ちの時計マーク Objectid
/* ------------------------------------------------------------------------------------
	RequestLoadDisp(waitsec) : 起動待ちの時計マークディスプレイ
		waitsec : i  : Display Timeout(Sec) 0:Limit(Net Timeoutまで),null:defult,{n}:指定時{n}sec
		styleを使用し id=idlodingmsgをOn/Offする
		id=idlodingmsgは<BODY>などに設定しておく
			style:#idlodingmsg:待ちのイメージをこの名前で作成しておく
			<body><div id="idlodingmsg"></div>
------------------------------------------------------------------------------------ */
function RequestLoadDisp(waitsec){
	if (waitsec == 0) {
		 sleep=LoadDispWSec*1000;
		 }
	else if (waitsec == null) {
		 sleep=10000;
		 }
	else {
		 sleep=waitsec*1000;
		 }
	document.getElementById('idlodingmsg').style.display='block';	// idlodingmsgを表示にする display: none;→block

	if (window.parent.document.getElementById('idFrmVieWap') !== null) {
		document.getElementById('idlodingmsg').style.left=(parseInt(window.parent.document.getElementById('idFrmVieWap').style.width)/2-30)+"px";
		}
	var element = document.createElement('div'); 					// ロック用のdivを生成 透明，最大画面を最上位に表示
	element.id = "screenLock"; 										// ロック用のスタイル
	element.style.height = '100%'; 
	element.style.left = '0px'; 
	element.style.position = 'fixed';
	element.style.top = '0px';
	element.style.width = '100%';
	element.style.zIndex = '100';									// PlayPanel(id=idFormCtl)よりz-indexを下げている
	element.style.opacity = '0';
	var objBody = document.getElementById("idlodingmsg"); 
	objBody.appendChild(element);

	if(GObjSTime) { clearTimeout(GObjSTime);GObjSTime=null; }			// Timer Unloak
	GObjSTime=setTimeout( function() { RequestUnLoadDisp(); },sleep);	// ロック画面の削除
	}

/*
	RequestUnLoadDisp() 起動待ちの時計マーク解除
*/
function RequestUnLoadDisp(){
	document.getElementById('idlodingmsg').style.display='none';

	id_name='screenLock';
	if (document.getElementById(id_name) == null) {
		return;
		}
	if(GObjSTime) { clearTimeout(GObjSTime);GObjSTime=null; }			// Timer Unloak
	var dom_obj = document.getElementById(id_name);
	var dom_obj_parent=dom_obj.parentNode;
	dom_obj_parent.removeChild(dom_obj);
	}
</script>

<style type="text/css">
.idlodingmsg {
    position: fixed;top:210px;left:210px;z-index:4;
    width: 50px; /*ローディングアイコンの横サイズ*/
    height: 50px; /*ローディングアイコンの縦サイズ*/
    border-radius: 50%;  /*CSS3で円を書く*/
/*    border: 8px solid #ffffff;*/  /*円に○の白枠をつける*/
    border: 8px solid #000000;  /*円に○の白枠をつける*/
    border-right-color: transparent; /*円の右にC状の空きをつける*/
    animation: spin 1s linear infinite; /*1秒毎にくるくる回転するアニメーション*/
    display: none;
	}
@keyframes spin {
    0% { transform: rotate(0deg);   opacity: 0.2; } /*0%の時は20％の透明度*/
    50%  { transform: rotate(180deg); opacity: 1.0; } /*50%の時は透明度なし*/
    100%   { transform: rotate(360deg); opacity: 0.2; } /*100%の時に20％の透明度に戻る*/
}

.boxon {
	position:fixed;bottom:2px;left:2px;width:450px;height:20px;font-size:13px;z-index:99999;background-color:rgba(211,211,211,0.8);
	border-radius:6px 6px 6px 6px;border: 0.3px solid #696969;color:#000000;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;padding:0 12px 0 12px;
 	}

</style>
<div id="idlodingmsg" name="idlodingmsg" class="idlodingmsg"></div>
EOM;
ob_end_flush();
	}
// -------End of Source ----------------------------------------------------------
?>
