<?php
$require_lib=dirname(__FILE__).'/mpdweb.lib.php';		// Mpd XML Library Default
if  (file_exists(dirname(__FILE__)."/".basename(__FILE__,".php").".lib.php")) {		// Mpd XML Library mpd{module}.lib.phpの存在確認
	$require_lib=dirname(__FILE__)."/".basename(__FILE__,".php").".lib.php";
	}
require_once($require_lib);					// Mpd XML Library mpd{module}.lib.php
$require_ses=dirname(__FILE__).'/mpdcmnses.lib.php';				// Mpd Session id Library
if  (file_exists($require_ses)) { require_once($require_ses); }		// Mpd mpdcmnses.lib.phpの存在確認&require
$SESSION_CONF=GetSessionConfig();									// php Session Config
ArgSessionStart($SESSION_CONF);										// Start Session : Used mpdcmnses.lib.php

echo <<<EOM
<style type="text/css">
body {background-color: #ffffff; color: #000000;}
body, td, th, h1, h2 {font-family: sans-serif;}
pre {margin: 0px; font-family: monospace;}
a:link {color: #000099; text-decoration: none; background-color: #ffffff;}
a:hover {text-decoration: underline;}
table {border-collapse: collapse;}
.center {text-align: center;}
.center table { margin-left: auto; margin-right: auto; text-align: left;}
.center th { text-align: center !important; }
td, th { border: 1px solid #000000; font-size: 75%; vertical-align: baseline;}
h1 {font-size: 150%;}
h2 {font-size: 125%;}
.p {text-align: left;}
.e {background-color: #ccccff; font-weight: bold; color: #000000;}
.h {background-color: #9999cc; font-weight: bold; color: #000000;}
.v {background-color: #cccccc; color: #000000;}
.vr {background-color: #cccccc; text-align: right; color: #000000;}
img {float: right; border: 0px;}
hr {width: 600px; background-color: #cccccc; border: 0px; height: 1px; color: #000000;}
</style>
EOM;

print '<div class="center">';
print '<table  width="600">';
print '<tr class="h"><td>$_SESSION</td><td>Value</td></tr>';

foreach($_SESSION as $key => $val) {
	print '<tr><td class="e">';
	print  $key.'</td>';
	print  '<td class="v">';
	if (is_array($val)) {
		 foreach($val as $ckey => $cval) {
			$sp="";
			print "Array";
			print "[$ckey]";
			if (is_array($cval)) {
				 print " Array";
				 $s="";
				 foreach($cval as $k => $v) {
					print $s."[$k]$v";
				 	$s=" , ";
					}
				 }
			else {
				 print $sp.$cval;
				 $sp=" , ";
				 }
			}
		 }
	else {
		 print  $val;
		 }
	print '</td></tr>';
	}
print '<tr><td class="e">';
print  'sesion_id</td>';
print  '<td class="v">';
print  $SESSION_CONF["sesion_id"];
print '</td></tr>';

print '</table>';
print '</div>';

/* -----------------------------------------------------------------------------
	GetSessionConfig() : php Session Config
	 @return: o  : "":$SESSION_CONF Session Array
----------------------------------------------------------------------------- */
function GetSessionConfig() {
	global $XML_CONF;

	GetEnvCommon();
	ignore_user_abort(false);							// 切断時終了
	$SESSION_CONF=array("sesion_id"=>"mpdweb","href_waitmsec"=>"50","maxlifetime"=>"1440");
	get_config("php_session",$SESSION_CONF);			// php config php_session
	$SESSION_CONF=ArgSessionConf($SESSION_CONF);		// mpdweb:Session id 作成 : Used mpdcmnses.lib.php
	return($SESSION_CONF);
	}

/* -----------------------------------------------------------------------------
	GetEnvCommon(); Load setting/mpdconfig.xml
	 @return: o  : "":Normal !="":ErrorMessage
----------------------------------------------------------------------------- */
function GetEnvCommon() {
	global $XML_CONF;

	$XML_File = "setting/mpdconfig.xml";
		$ret="";
	try {
		$XML_CONF = get_loadconfig($XML_File);	// XML File Get FileNameはLibrary標準
		} catch( Exception $e ) {
	  $ret=$e->getMessage();
	  }
	return($ret);
	}

?>
