﻿<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<?php
/***************************************************************************************
	mpdclock.php : Plubin Applet Display Clock

	 	Sumple: https://www.jqueryscript.net/time-clock/Animated-Digital-Clock-Plugin-with-jQuery-CSS3.html

****************************************************************************************/
/*
	Width          : container-width={width}
	HeightDate     : date-height={height}px
	Width Clock    : clock-width={width}px
	HeightClock    : clock-height={height}px
	Date Font Size : date-font-size={size}
	Time Font Size : time-font-size={size}
	Clock Left Rigth Margin : margin={size}
	Upper Margin   : upper-margin={size}
	Date  Margin   : date-margin={size}
	background     : background-color #xxxxxx or xxxxxx
	clear          : background-color clear 0.x
	clock-style    : clock-style  *CF: Coler is designated as "background=xxxxx" / Clearis designated as "clear"
	closeid        : Close Button id ,       "":no action   : Frame時呼び元のCloseBottan id ClickEventで閉じるを行う , close=""時,Clock全体がCloseButton
	close          : Make Close Button Color "":no Make     : Close Buttonを作成する。値はCloseButton Color
	ex : mpdclock.php?container-width=200px&date-height=10px&clock-width=150px&clock-height=25px&date-font-size=11px&time-font-size=2em&margin=4px&upper-margin=-10px&date-margin=5px&background=000000&clear=0.5
	     mpdclock.php?container-width=350px&date-height=10px&clock-width=250px&clock-height=40px&date-font-size=16px&time-font-size=3em&margin=4px&upper-margin=-10px&date-margin=5px
-------------------------------------------------------------------------------------- */
$JQUERY_JS="jquery-ui-1.12.1/jquery-3.4.0.min.js";
$dateformjs="";
if (file_exists($JQUERY_JS)) {				// Local Serverにjqueryを用意しているかチェック
	 $date = new DateTime();
	 $date->setTimestamp(filemtime($JQUERY_JS));
	 $dateformjs=$date->format('YmdHis');	// 変更時反映
	 $dateformjs="?a=".$dateformjs;
	 }
else {
	 $JQUERY_JS="https://code.jquery.com/jquery-3.4.1.min.js";
	 }
echo <<<EOM
<script type="text/javascript" src="{$JQUERY_JS}{$dateformjs}"></script>
EOM;
?>
<!-- Sumple https://www.jqueryscript.net/time-clock/Animated-Digital-Clock-Plugin-with-jQuery-CSS3.html -->
<script type="text/javascript">
$(document).ready(function() {
// Create two variable with the names of the months and days in an array
var monthNames = [ "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" ]; 
var dayNames= ["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"]
setInterval( function() {
	// Create a newDate() object
	var newDate = new Date();
	// Extract the current date from Date object
	newDate.setDate(newDate.getDate());

	// Create a newDate() object and extract the seconds of the current time on the visitor's
	var seconds = new Date().getSeconds();
	// Add a leading zero to seconds value
	$("#sec").html(( seconds < 10 ? "0" : "" ) + seconds);
	var minutes = new Date().getMinutes();
	// Add a leading zero to the minutes value
	$("#min").html(( minutes < 10 ? "0" : "" ) + minutes);
	var hours = new Date().getHours();
	// Add a leading zero to the hours value
	$("#hours").html(( hours < 10 ? "0" : "" ) + hours);
	// Output the day, date, month and year   
	$('#Date').html(dayNames[newDate.getDay()] + " " + newDate.getDate() + ' ' + monthNames[newDate.getMonth()] + ' ' + newDate.getFullYear());
	},1000);
});
</script>

<?php

$CLOCK_VERSION="Ver:1.0 : 30.04.2021";

$ARG=ArgAnalyze();

echo <<<EOM
<script type="text/javascript">
var CLOSEID="{$ARG["closeid"]}";		// Self Freme: Width
function EventClose() {
	if (CLOSEID !=="") {
		window.parent.document.getElementById(CLOSEID).onclick();
		}
	}
</script>

<style type="text/css">
body { margin:0;padding:0;overflow:hidden;border:none }

/* If you want you can use font-face */
@font-face {
    font-family: 'BebasNeueRegular';
    src: url('BebasNeue-webfont.eot');
    src: url('BebasNeue-webfont.eot?#iefix') format('embedded-opentype'),
         url('BebasNeue-webfont.woff') format('woff'),
         url('BebasNeue-webfont.ttf') format('truetype'),
         url('BebasNeue-webfont.svg#BebasNeueRegular') format('svg');
    font-weight: normal;
    font-style: normal;
}

.container {width: {$ARG["container-width"]}; margin: 0 auto; overflow: hidden; }						/* Orignal size : width: 960px; */
.clock {width:{$ARG["clock-width"]}; margin:0 auto; padding:20px;background-color:#000000; border:1px solid #333; color:#fff;  }	/* Orignal size : width:800px; */

#Date { font-family:'BebasNeueRegular', Arial, Helvetica, sans-serif; font-size:{$ARG["date-font-size"]}; text-align:center; text-shadow:0 0 5px #00c6ff; }	/* Orignal size : font-size:36px; */
ul { width:{$ARG["clock-width"]}; margin:0 auto; padding:0px; list-style:none; text-align:center; }		/* Orignal size : width:800px; */
ul li { display:inline; font-size:{$ARG["time-font-size"]}; text-align:center; font-family:'BebasNeueRegular', Arial, Helvetica, sans-serif; text-shadow:0 0 5px #00c6ff; }	/* Orignal size : font-size:10em */
/*#point { position:relative; -moz-animation:mymove 1s ease infinite; -webkit-animation:mymove 1s ease infinite; padding-left:{$ARG["margin"]}; padding-right:{$ARG["margin"]};*/ } /* Orignal size : padding-left:10px; */
#point { position:relative; -moz-animation:mymove 1s ease infinite; padding-left:{$ARG["margin"]}; padding-right:{$ARG["margin"]}; } /* Orignal size : padding-left:10px; */

/* Simple <a href="https://www.jqueryscript.net/animation/">Animation</a> */
@-webkit-keyframes mymove 
{
0% {opacity:1.0; text-shadow:0 0 20px #00c6ff;}
50% {opacity:0; text-shadow:none; }
100% {opacity:1.0; text-shadow:0 0 20px #00c6ff; }	
}

@-moz-keyframes mymove 
{
0% {opacity:1.0; text-shadow:0 0 20px #00c6ff;}
50% {opacity:0; text-shadow:none; }
100% {opacity:1.0; text-shadow:0 0 20px #00c6ff; }	
}
EOM;

if (($ARG["closeid"] !=="")&&($ARG["close"] !=="")) {		// close:
	$rgba=Color2rgb($ARG["close"]);
	$bbg = "border-color:rgba(".$rgba.",%clear%)";
	if ($ARG["clear"] =="") {
		$bbg = str_replace(",%clear%","",$bbg);
		$bbg = str_replace("rgba","rgb",$bbg);
		}
	if ($ARG["clear"] !=="") {
		if ($bbg =="") {
			$bbg = "border-color:rgba(0,0,0,%clear%)";
			}
		$bbg= str_replace("%clear%",$ARG["clear"],$bbg);
		}
	}
echo <<<EOM

.clockdm {width:{$ARG["clock-width"]}; margin:0 auto; padding:20px; }
.triangle {
	width:0;height:0px;
	border-right:16px solid;{$bbg};
	border-top:16px solid transparent;
	border-bottom:0px solid transparent;
	}
EOM;

echo <<<EOM

</style>
EOM;
//print 'rgba['.$bbg."]<BR><BR><BR><BR><BR><BR>";


$mtop=$ARG["clock-height"]+4;
$mleft=$ARG["clock-width"]-16;

$event="";$cursor="";
if (($ARG["closeid"] !=="")&&($ARG["close"] =="")) {
	$event='onclick="EventClose();" ';
	$cursor='cursor:pointer;';
	}

?>
</head>
<body>
<?php
echo <<<EOM
<div class="clock" {$event}style="height:{$ARG["clock-height"]};{$cursor}{$ARG["clock-style"]}">
   <div id="Date" style="height:{$ARG["date-height"]};margin:{$ARG["upper-margin"]} 0px {$ARG["date-margin"]} 0px;"></div>
      <ul>
          <li id="hours"></li>
          <li id="point">:</li>
          <li id="min"></li>
          <li id="point">:</li>
          <li id="sec"></li>
      </ul>


<div style="position:absolute;top:0px;left:0px">
	<div onmousedown="document.getElementById('varsion').style.display='block';" onmouseup="document.getElementById('varsion').style.display='none';" style="height:10px;width:10px;cursor:pointer;"></div>
	<div id="varsion" style="position:absolute;top:-1px;left:30px;overflow:visible;white-space: nowrap;font-size:9px;color:#87ceeb;display:none;">{$CLOCK_VERSION}</div>
</div>


EOM;
if (($ARG["closeid"] !=="")&&($ARG["close"] !=="")) {
echo <<<EOM
<div class="clockdm" style="position:absolute;top:0px;">
	<div onclick="EventClose();" class="triangle" style="margin:{$mtop}px 0 0 {$mleft}px;cursor:pointer;"></div>
</div>
EOM;
	}

echo <<<EOM
</div>
EOM;

?>

<?php
/* -----------------------------------------------------------------------------
	ArgAnalyze() : Argument Analyze
	$XML_File = "setting/mpdconfig.xml";←変更可能
----------------------------------------------------------------------------- */
function ArgAnalyze() {
	$ARG=array("date-font-size"=>"11px","time-font-size"=>"2em","container-width"=>"200px","date-height"=>"10px","clock-width"=>"156px","clock-height"=>"25px","margin"=>"4px","upper-margin"=>"-10px","date-margin"=>"5px","background"=>"","clear"=>"","clock-style"=>"","closeid"=>"","close"=>"");
	foreach($_GET as $key => $get) {		// ArgAnalyze($_GET)と同じ形式にする
		$ARG[$key]=$get;
		}

	$bg = "";
	if ($ARG["background"] !=="") {
		$rgba=Color2rgb($ARG["background"]);
		$bg = "background-color:rgba(".$rgba.",%clear%)";
		if ($ARG["clear"] =="") {
			$bg = str_replace(",%clear%","",$bg);
			$bg = str_replace("rgba","rgb",$bg);
			}
		}
	if ($ARG["clear"] !=="") {
		if ($bg =="") {
			$bg = "background-color:rgba(0,0,0,%clear%)";
			}
		$bg= str_replace("%clear%",$ARG["clear"],$bg);
		}
	$ARG["clock-style"]=rtrim($ARG["clock-style"], ';').";".$bg;
//print "<BR><BR><BR><BR><BR><BR><BR><BR><BR><BR>-------------------------------------------------<BR>";
//print_r($ARG);
	return($ARG);
	}

/* -----------------------------------------------------------------------------
	Color2rgb($colorcode) :カラーコード RGB数値 変換
	$colorcode : i   :  カラーコード
----------------------------------------------------------------------------- */
function Color2rgb($colorcode) {
	$colorcode = preg_replace("/#/", "", $colorcode);		//「#******」のような形でカラーコードがわたってきた場合「#」を削除する
	$array_colorcode["red"] = hexdec(substr($colorcode, 0, 2));		// 2つずつ「**」に区切りhexdec関数で変換
	$array_colorcode["green"] = hexdec(substr($colorcode, 2, 2));
	$array_colorcode["blue"] = hexdec(substr($colorcode, 4, 2));
	$str=$array_colorcode["red"].",".$array_colorcode["green"].",".$array_colorcode["blue"];
	return($str);
	}
?>
</body>
</html>
