<?php
/***************************************************************************************
	mpdsesclear.php : mpdweb Session Clear

	$_SESSIONに操作歴など一部設定を保持するのでクリアする機能を実行
	Alternate Mpd Host(MPD Host代替)機能を使用時に設定ホストが参照できないときに強制クリアできる。
	(設定ホストが参照できないときは，アクセスタスクがタイムアウトまで待たされるので待つしかない)
	実行に際して，他にmpdwebシリーズを使用していないこと。(実行前に停止しておく)

	実行はブラウザから: http://{Host}/mpdweb/mpdsesclear.php
	   Volumio上で実行: http://{Host}:88/mpdweb/mpdsesclear.php

****************************************************************************************/
if (isset($_POST["p"])) {
	$stsstr="result:SESSION Clear Functcton Start<BR>";
	$require_lib=dirname(__FILE__).'/mpdweb.lib.php';				// Mpd XML Library Default
	if  (file_exists(dirname(__FILE__)."/".basename(__FILE__,".php").".lib.php")) {		// Mpd mpdcmnses.lib.phpの存在確認
		$require_lib=dirname(__FILE__)."/".basename(__FILE__,".php").".lib.php";
		}
	require_once($require_lib);										// Mpd XML Library mpd{module}.lib.php
	$require_ses=dirname(__FILE__).'/mpdcmnses.lib.php';			// Mpd Session id Library
	if  (file_exists($require_ses)) { require_once($require_ses); }	// Mpd mpdcmnses.lib.phpの存在確認&require
	$stsstr=$stsstr.'UsingLibrary ['.$require_lib.']<BR>';print $stsstr."\n";
	$ests="";
	$SESSION_CONF=GetSessionConfig($ests);							// php Session Config
	$ests=str_replace(array("\n",":"),array("<BR>","="),$ests);
	if($ests !="") { $ests=$ests."<BR>"; }
	$stsstr=$stsstr.$ests;print $stsstr."\n";
	ArgSessionStart($SESSION_CONF);									// Start Session : Used mpdcmnses.lib.php

	$stsstr=$stsstr."Session Start<BR>";print $stsstr."\n";
	$ret=PutSessionClear();
	if($ret !="") { $ret=$ret."<BR>"; }
	$stsstr=$stsstr.$ret;print $stsstr."\n";

	$stsstr=$stsstr."SESSION Clear Functcton Terminate\n";
	print $stsstr;
	exit;
	}
?>

<!DOCTYPE html>
<html>
<head>
<script type="text/javascript">
function RequestByPost(prg){
<?php print "\t".'var post_mod="'.basename(__FILE__).'";'."\n"; ?>
    var xhr = new XMLHttpRequest();
    xhr.open('POST',post_mod);
    xhr.onload = function() {
		var res_ans = xhr.response.split("\n");
		for(var i=0; i < res_ans.length ; i++ ) {
		if (res_ans[i] == "") {  continue; }
			var htm_id = res_ans[i].split(":",2);
			if (document.getElementById(htm_id[0])) {					//  HTML-IDがあれば表示する。
				var idobj = document.getElementById(htm_id[0]);
				var str="";
				if (htm_id.length  > 1){ str=htm_id[1]; }
				idobj.innerHTML=str;
				continue;
				}
			}
 	   };
	var data = new FormData();
	data.append("p",prg);
	xhr.send(data);
	}
</script>
<style type="text/css">
#button { overflow: hidden; }
#result { overflow: hidden; }
.boxon {border: 1px solid #888888;font-size:12p;border:ridge 3px #c0c0c0;background-color:#2f2f2f;color:#ffffff; }
</style>
	<title>SESSION Clear</title>
</head>
<body>
<div class=boxon style="position:fixed;top:30px;left:40px;height:50;width:400px;height:160px;">'
	<div style="position:absolute;top:0px;left:0px;border:solid 2px #c0c0c0;padding:0px 30px 0px;width:336px;font-size:14px;color:#000000;background:#87cefa;">MPDWEB : Forced clearing of SESSION Data</div>
	<div style="position:absolute;top:40px;left:60px;color:#fff8dc;">Clear Session data.</div>
	<div style="position:absolute;top:60px;left:60px;color:#fff8dc;">This initializes the behavior.</div>
	<div style="position:absolute;top:122px;left:50px;font-size:12px;">Forced clear:Click</div>
	<button id="button" onclick="document.getElementById('button').style.color = '#ffffff';RequestByPost('HostFavorAdd');setTimeout(function() { document.getElementById('button').style.color = ''; },200);" style="position:absolute;top:120px;left:170px;width:60px;border-style:none;width:50px;height:20px;padding:2px 0 2px;font-size:11px;cursor:pointer;-moz-border-radius:4px;-webkit-border-radius:4px;border-radius: 4px;color:#000000;">Clear</button>
	<div style="position:absolute;top:146px;left:306px;font-size:9px;">2023/04/20 0.9</div>
</div>
<div id="result" style="position:absolute;top:200px;left:60px;color:#000080;"></div>
</body>
</html>

<?php
/* -----------------------------------------------------------------------------
	GetSessionConfig(&$ests) ; Load setting/mpdconfig.xml
	 $ests  : io  : "":Normal !="":ErrorMessage
	 @return: o  : $SESSION_CONF Session Array
----------------------------------------------------------------------------- */
function GetSessionConfig(&$ests) {
	global $XML_CONF;

	$XML_File = "setting/mpdconfig.xml";
		$ests="";
	try {
		$XML_CONF = get_loadxml($XML_File);	// XML File Get FileNameはLibrary標準
		} catch( Exception $e ) {
	  $ests=$e->getMessage();
	  }
	ignore_user_abort(false);							// 切断時終了
	$SESSION_CONF=array("sesion_id"=>"mpdweb","href_waitmsec"=>"50","maxlifetime"=>"1440");
	get_config("php_session",$SESSION_CONF);			// php config php_session
	$SESSION_CONF=ArgSessionConf($SESSION_CONF);		// mpdweb:Session id 作成 : Used mpdcmnses.lib.php
//	$ests="sesion_id:".$SESSION_CONF["sesion_id"];
	return($SESSION_CONF);
	}
/* -----------------------------------------------------------------------------
	PutSessionClear ; Session Clear
	 @return: o  : Message
----------------------------------------------------------------------------- */
function PutSessionClear() {
	$ret="";
	if ((isset($_SESSION))&&(is_array($_SESSION))) {
		 $ret="Session Clear!!";
		 if(isset($_SESSION["XMLAlter"])) {
			$ret="Used Alternate Mpd Host,return to default!";
			}
		 $_SESSION = array();
		 }
	else {
		 $ret="Session does not exist !";
		 }
	return($ret);
	}
?>
