<?php
/********************************************************************************

	mpdxmlconfig.php : XMLFile Edit (2階層までの編集 例:<Mpd_net><host>)

	Calling mpdxmlconfig.php?xmlfile={XMLFilePath} | ?XMLFILE={XMLFilePath}  ※xmlfileは小文字
	単独実行 mpdxmlconfig.php?xmlfile={XMLFilePath}
			 http://{Host}/mpdweb/mpdxmlconfig.php?xmlfile=setting%2fmpdxmlconfig.xml

	ライブラリモード時
		 require時に内部で初期,GetXMLEdit()を実行。
	関数 require_once(mpdxmlconfig.php);
	     DispXMLEdit();		//URL : XMLFILE={XMLFilePath}を付加する ※XMLFILEは大文字
	  ライブラリの引用を行っておく
	     mpdweb.lib.php mpdweb.lib_appli.php
	     mpdweb.common.js mpdweb.libcajax.js mpdweb.common.css
********************************************************************************/
/*******************************************************************************
	Post実行
	単独でも使用できるようにPostをここで受信
	require()で連結される場合に exit() で終了しないこと
*******************************************************************************/
if (isset($_POST['p'])) {
	global $XMLEDIT_ARG;
	$require_lib=dirname(__FILE__).'/mpdweb.lib.php';		// Mpd XML Library Default
	if  (file_exists(dirname(__FILE__)."/".basename(__FILE__,".php").".lib.php")) {		// Mpd XML Library mpd{module}.lib.phpの存在確認
		$require_lib=dirname(__FILE__)."/".basename(__FILE__,".php").".lib.php";
		}
	require_once($require_lib);								// Mpd XML Library mpd{module}.lib.php
	$require_appli_lib=dirname(__FILE__).'/mpdweb.lib_appli.php';								// mpd Application Library アプリケーション層
	if  (file_exists(dirname(__FILE__)."/".basename(__FILE__,".php").".lib_appli.php")) {		// Mpd XML Library mpd{module}.lib_appli.phpの存在確認
		$require_appli_lib=dirname(__FILE__)."/".basename(__FILE__,".php").".lib_appli.php";
		}
	require_once($require_appli_lib);						// Mpd XML Library mpd{module}.lib.php
	if  (file_exists(dirname(__FILE__)."/mpdxmlupdate.lib.php")) {	// Mpd XML Library mpd{module}.lib.phpの存在確認
		$require_xml=dirname(__FILE__)."/mpdxmlupdate.lib.php";
		require_once($require_xml);
		}

	GetURLArg();
	if ($_POST['p']=="xmlsave") {						// MountList Update
		PostXMLEditSave();
		}												// exitしないこと
	return;
	}

/* -----------------------------------------------------------------------------
	PostXMLEditSave() ; XML Edit Save
	 $_POST["save"]   : XML編集の設定XML File
	 $_POST["xmlfile"]: 保存用XML File名 (名前を付けて保存に対応)
----------------------------------------------------------------------------- */
function PostXMLEditSave() {
	global $XMLEDIT_ARG;

	print "PostXMLEditSave Start\n";
	if (!isset($_POST["xmlfile"])) {
		print "PostXMLEditSave End (none XMLFile)\n";
		return;
		}
	if (!isset($_POST["save"])) {
		print "PostXMLEditSave End (none SaveFile)\n";
		return;
		}
	$save=$_POST["save"];
	$xmlary=array();
	$ary=explode('@',$_POST["xmlary"]);			// XMLAry配列
	foreach($ary as $key=> $val) {
		if ($val=="") { continue; }
		$tmp=explode(':',$val,3);
		if (!isset($tmp[1])) {  continue;  }
		if (isset($tmp[2])) { $str=$tmp[2]; } else { $str=""; }
		$xmlary[$tmp[0]][$tmp[1]]=$str;
		}
	$ret=XMLEditUpdate($save,"",$xmlary);
	$ser="";if($ret < 0) { $ser="Update Error"; }

	GetXMLEdit();								// 画面最新編集
	print "grpXMLEdit:";
	DispXMLEditDetail();
	print "\n";
	print "PostXMLEditSave End\n";
	}

/*******************************************************************************
	 単独実行 Web Function Library
*******************************************************************************/
if (isset($_GET['xmlfile'])) {	// 単独実行 &xmlfile={XMLFilePath}
	$require_lib=dirname(__FILE__).'/mpdweb.lib.php';		// Mpd XML Library Default
	if  (file_exists(dirname(__FILE__)."/".basename(__FILE__,".php").".lib.php")) {		// Mpd XML Library mpd{module}.lib.phpの存在確認
		$require_lib=dirname(__FILE__)."/".basename(__FILE__,".php").".lib.php";
		}
	require_once($require_lib);					// Mpd XML Library mpd{module}.lib.php
	$require_appli_lib=dirname(__FILE__).'/mpdweb.lib_appli.php';								// mpd Application Library アプリケーション層
	if  (file_exists(dirname(__FILE__)."/".basename(__FILE__,".php").".lib_appli.php")) {		// Mpd XML Library mpd{module}.lib_appli.phpの存在確認
		$require_appli_lib=dirname(__FILE__)."/".basename(__FILE__,".php").".lib_appli.php";
		}
	require_once($require_appli_lib);				// Mpd XML Library mpd{module}.lib.php

	$jscommon = rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'."mpdweb.common.js";		// mpdweb Common js
	if  (file_exists(rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename(__FILE__,".php").".common.js")) {
		$jscommon = rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename(__FILE__,".php").".common.js";		// mpdweb Common jsp mpdcommon.js
		}
	$jslibcajax = rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'."mpdweb.libcajax.js";		// mpdweb Common js
	if  (file_exists(rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename(__FILE__,".php").".libcajax.js")) {
		$jslibcajax = rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename(__FILE__,".php").".libcajax.js";	// mpdweb Common jsp mpd{module}.js
		}
	$dateform="";
	if (file_exists($jscommon)) {
		$date = new DateTime();
		$date->setTimestamp(filemtime($jscommon));
		$dateform=$date->format('YmdHis');
		$dateform="?a=".$dateform;
		}
	echo <<<EOM
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html lang="ja">
<head><body>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" >
<script type="text/javascript" src="{$jscommon}{$dateform}"></script>
<script type="text/javascript" src="{$jslibcajax}{$dateform}"></script>
EOM;
	$csscommon = rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'."mpdweb.common.css";		// mpdweb Common css
	if  (file_exists(rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename(__FILE__,".php").".common.css")) {
		$csscommon = rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename(__FILE__,".php").".common.css";		// mpdweb Common jsp mpd{module}.css
		}
	$dateform="";
	if (file_exists($csscommon)) {
		$date = new DateTime();
		$date->setTimestamp(filemtime($csscommon));
		$dateform=$date->format('YmdHis');
		$dateform="?a=".$dateform;
		}
	echo <<<EOM
<link rel="stylesheet" href="{$csscommon}{$dateform}" type="text/css">

<style type="text/css">
html { overflow-y: scroll; }
html,body { background-color:#000000;color:#ffffff;scrollbar-base-color:#707070;scrollbar-track-color:#A4A4A4;scrollbar-arrow-color:#707070; }
body {background-color:#000000;color:#ffffff;margin-left:4px;font-family:Verdana,"Meiryo UI",sans-serif;font-size:80%;} /* 暫定 */
.box {border: 1px solid #888888;position:fixed;top:200px;left:170px;
      width:300px;height:238px;font-size:10p;z-index:120;
      background-color:#2f2f2f;
      display: none;
      }
.boxtitle {background-color:#0000FF;color:#CEECF5;font-size:14px;text-align:left;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;width:280px;height:18px;position:absolute;top:0px;left:0px;padding:8px 10 2px;}
.boxbcan  {position:absolute;bottom: 5;right:6px;}
.boxline  {background-color:#000000;color:#ffffff;font-size:14px;font-weight:bold;text-decoration:none;white-space:nowrap;display:block;text-align:left;vertical-align:middle;cursor:pointer;border: 1px solid #acacac;width:300px;height:25;padding:3px 10 2px;}
.boxblin1 {position:absolute;left:0px;top:32px;}
.boxblin2 {position:absolute;left:0px;top:50px;}
.boxtext  {position:absolute;background-color:#2f2f2;color:#ffffff;font-size:16x;font-weight:bold;text-decoration:none;display:block;text-align:left;vertical-align:middle;border: 0px;width:278px;height:19;padding:3px 10 2px;}
.comnd {border-style:none;padding:2px 0 2px;font-size:8p;cursor:pointer;-moz-border-radius:2px;-webkit-border-radius:2px;border-radius:2px;text-align:center;}
.buttn {border-style:none;width:50px;height:20px;padding:2px 0 2px;font-size:11px;cursor:pointer;-moz-border-radius:4px;-webkit-border-radius:4px;border-radius: 4px;}
.msgbbtn { font-size:12px;width:60px;height:24px;position:absolute;top:120px;background-color:#c0c0c0;border:1.5px ridge #d3d3d3;}
.hedtext { position:fixed;top:0px;left:0px;font-size:12px;width:471px;height:20px;background-color:#c0c0c0;color:#000000;margin:0px 0px 0px 5px;}
.hedbord { border: 1px ridge #888888;background:rgb(192,192,192);color:#4d4d4d;border-radius:4px;line-height:150%;font-weight:bold; }
.botom {position:fixed;bottom:0px;width:476px;background-color:#000000;}
.StatusL { border:1.4px solid #000000;width:480px;height:20;font-size:10px;color:#BDBDBD;line-height:140%;padding:4 6 6 6;background-color:#2E2E2E;resize:none;}
</style>
EOM;
	}

/* ------------------------------------------------------------------------------------
	 mpdxmlconfig.php 共通CSS
------------------------------------------------------------------------------------- */
echo <<<EOM
<style type="text/css">
.chgfnt { background-color:#000000;color:#ffffff;font-family:Verdana,"Meiryo UI",sans-serif;font-size:80%; }
.cfgtbl { width:476px;border-collapse: collapse; }
.cfgtd  { height:22px;border: 1px solid #000000;font-size:11px;vertical-align:middle;border:1px solid #808080; }
.cfgtr  { background-color:#00008b;font-weight;color:#ffffff;border:1px solid #808080;text-align: center }
.cfgtdtil {background-color:#d3d3d3;font-weight;color:#000000;border:1px solid #808080;text-align: center }
.cfgtdval {background-color:#e5e5e5;color:#000000;border:1px solid #808080;overflow:hidden; }
.xmledtfnc { position:relative;right:0px;top:-4px;width:20px;height:23;transform:rotate(-90deg);white-space:normal;background-color:#585858;color:#ffffff;}
</style>
EOM;
if (isset($_GET['xmlfile'])) {		// 単独実行 &xmlfile={XMLFilePath}
	print '<div class="hedtext hedbord">&emsp;&emsp;XMLFile:Edit</div>';
	print '<div id="idlodingmsg"></div>';
	DispMsgBox("off");				// メッセージボックス初期生成
	DispSureBox("off");
	DispXMLEditState();
	}
/*******************************************************************************
	mpdxmlconfig.php : XMLFile Edit
********************************************************************************/
global $XMLEDIT_ARG,$XMLEDIT_ITEM,$XMLEDIT_VERSION;

$XMLEDIT_VERSION=basename(__FILE__,"")." 0.6 (01.03.2025)";
if(!isset($_POST["p"])) {
	GetURLArg();
	if ($XMLEDIT_ARG["FILE"] !=="") {		// ARGV XMLFILE={FilePath}が指定されていないときは,ライブラリモード
		 GetXMLEdit();
		 DispXMLEdit();
		 }
	else {
		 GetXMLEdit();						// ライブラリモード時,require時に初期,GetXMLEdit()を実行
	 	 }									//  画面表示:DispXMLEdit()をCallする
	}

$postmod=rtrim(dirname($_SERVER['PHP_SELF']),'/').'/'.basename(__FILE__);
echo <<<EOM
<script type="text/javascript">
var MyPOSTMOD="{$postmod}";		// POST ServerModule 
</script>
EOM;

?>

<script type="text/javascript">
/*******************************************************************************
	GetXMLEditEvent(xmlfile) : XMLEdit , Function Execution
	 xmlfile : i  : XMLFile Path
********************************************************************************/
function GetXMLEditEvent(xmlfile,save) {
	var idTbl=document.getElementById("idTblXMLEdit");
	var pststr="";var secstr="";var cntsec=0;
	for(var i=0;i < idTbl.rows.length;i++) {					// Table row要素
		for(var j=0;j < idTbl.rows[i].cells.length;j++){		// Table cell要素
			var cell = idTbl.rows[i].cells[j];
			if (j==0) {
				var id=_ArgHTMLIdPurge(cell);
				if (id) { } else {
					secstr = document.getElementById('sec'+cntsec).innerText;	// Section(Orignal目名)を取得 
					cntsec++;
					}
				}
			if (j==1) {
				var id=_ArgHTMLIdPurge(cell);					// cellのidを取得
				if (id) {
					var no=_ArgIdSeparate(id);					// idの文字,数値を分離
					if ((no)&&(no.length > 0)) {
						if (document.getElementById('val'+no[1])) {
							var tag = document.getElementById('tag'+no[1]).innerText;	// Item名を取得
							var val = document.getElementById('val'+no[1]).innerText;	// Item値を取得
							if (val !==document.getElementById('in'+no[1]).innerText) {
								pststr=pststr+secstr+":"+tag+":"+val+'@';
								}
							}
						}
					}
				}
			}
		}
	if(pststr=="") {
		RequestMsgBox("XMLEdit - Function","There is no update target\nCancel processing",120,70);
		return;
		}
	pststr="&xmlfile="+RequestURLEncode(xmlfile)+"&save="+RequestURLEncode(save)+"&xmlary="+RequestURLEncode(pststr);
//alert("Para["+pststr+"]");
	if(typeof RequestByPost == 'function') { } else {
  	 	alert("NotFound Function[RequestByPost]");
		}
	callback=function () { RequestUnLoadDisp();location.reload(); };	// jsで変更したthis.styleが戻らないのでcallbakでreload
//	callback=function () { RequestUnLoadDisp(); };						// jsで変更したthis.styleが戻らないのでcallbakでreload
	RequestSureBox('XMLEdit - Function','XML File , Save as\n\n Are you Sure?',function () { RequestLoadDisp(5);RequestByPost(MyPOSTMOD,'p=xmlsave&'+pststr,callback); },60,200);
	}

/*
	_ArgHTMLIdPurge(obj) : HTML-Object id Purge
	obj     : i  : HTML Object
	@return : o  : Found:id , notFound : null
*/
function _ArgHTMLIdPurge(obj) {
	var result=null;
	var id=obj.innerHTML.match(/id="(.*?)(")/i);
	if ((id)&&(id.length > 0)) {
		result=id[1];
		}
	return(result);
	}

/*
	_ArgIdSeparate(id) : id Separate 
	id      : i  : String {id:String}{Numeric}
	@return : o  : [0]:id:String [1]:Numeric
*/
function _ArgIdSeparate(id) {
	var result = [ null,null ];
	if (id) {
		var str = id.replace(/[^0-9]/g,'');
		result[1]=str;
		var str = id.replace(str,'');
		result[0]=str;
		}
	return(result);
	}

</script>

<?php
/*************************************************************************************
	mpdxmlconfig 単独実行 JS Common Function
**************************************************************************************/
if (isset($_GET['xmlfile'])) {		// 単独実行 &xmlfile={XMLFilePath}
	echo <<<EOM
<script type="text/javascript">
/* ------------------------------------------------------------------------------------
	RequestLoadDisp(waitsec) : 起動待ちの時計マークディスプレイ
		waitsec : i  : Display Timeout(Sec) 0:Limit(Net Timeoutまで),null:defult,{n}:指定時{n}sec
		styleを使用し id=idlodingmsgをOn/Offする
		id=idlodingmsgは<BODY>などに設定しておく
			style:#idlodingmsg:待ちのイメージをこの名前で作成しておく
			<body><div id="idlodingmsg"></div>
------------------------------------------------------------------------------------ */
var GURLCONNECT="";		// 外部モジュールがmpdsetting.phpシリーズとHeaderFunctionでURL共有部を使用する項目
var LoadDispWSec=30;
var GObjSTime;			// 起動待ちの時計マーク Objectid
function RequestLoadDisp(waitsec){
	if (waitsec == 0) {
		 sleep=LoadDispWSec*1000;
		 }
	else if (waitsec == null) {
		 sleep=10000;
		 }
	else {
		 sleep=waitsec*1000;
		 }
	document.getElementById('idlodingmsg').style.display='block';	// idlodingmsgを表示にする display: none;→block

	var element = document.createElement('div'); 					// ロック用のdivを生成 透明，最大画面を最上位に表示
	element.id = "screenLock"; 										// ロック用のスタイル
	element.style.height = '100%'; 
	element.style.left = '0px'; 
	element.style.position = 'fixed';
	element.style.top = '0px';
	element.style.width = '100%';
	element.style.zIndex = '100';									// PlayPanel(id=idFormCtl)よりz-indexを下げている
	element.style.opacity = '0';
	var objBody = document.getElementsByTagName("body").item(0); 
	objBody.appendChild(element);

	if(GObjSTime) { clearTimeout(GObjSTime);GObjSTime=null; }			// Timer Unloak
	GObjSTime=setTimeout( function() { RequestUnLoadDisp(); },sleep);	// ロック画面の削除
	}

/*
	RequestUnLoadDisp() 起動待ちの時計マーク解除
*/
function RequestUnLoadDisp(){
	document.getElementById('idlodingmsg').style.display='none';

	id_name='screenLock';
	if (document.getElementById(id_name) == null) {
		return;
		}
	if(GObjSTime) { clearTimeout(GObjSTime);GObjSTime=null; }			// Timer Unloak
	var dom_obj = document.getElementById(id_name);
	var dom_obj_parent=dom_obj.parentNode;
	dom_obj_parent.removeChild(dom_obj);
	}
</script>

</body></head>
EOM;
	}

/*******************************************************************************
	mpdxmlconfig.php : PHP Common Function
********************************************************************************/
/* -----------------------------------------------------------------------------
	GetURLArg() ; Get URL Arument
	 XMLFILE=setting%2FXMLTEST.xml(ライブラリモード) | xmlfile=setting%2FXMLTEST.xml(単独実行)
----------------------------------------------------------------------------- */
function GetURLArg() {
	global $XMLEDIT_ARG;

	$XMLEDIT_ARG["FILE"] = "";
	if (isset($_POST['xmlfile'])) {
		 $XMLEDIT_ARG["FILE"]=$_POST['xmlfile'];
		 }
	else if (isset($_GET['XMLFILE'])) {
		 $XMLEDIT_ARG["FILE"]=$_GET['XMLFILE'];
		 }
	else if (isset($_GET['xmlfile'])) {
		 $XMLEDIT_ARG["FILE"]=$_GET['xmlfile'];
		 }
	$XMLEDIT_ARG["FILE"]=urldecode($XMLEDIT_ARG["FILE"]);
	}

/* -----------------------------------------------------------------------------
	GetXMLEdit() ; Get XML Edit Setting
----------------------------------------------------------------------------- */
function GetXMLEdit() {
	global $XMLEDIT_ARG,$XMLEDIT_ENV,$XMLEDIT_ITEM,$XMLEDIT_ATTR;	// $XMLEDIT_ARG:URL Argument ,$XMLEDIT_ENV:XML環境設定,$XMLEDIT_ITEM:XML環境設定(Item),$XMLEDIT_ATTR;XML環境設定(Section Attrinute)

	$ret="";$xmlcnf=array();
	try {
		$xmlcnf = get_loadxml($XMLEDIT_ARG["FILE"]);				// URL引数XMLFILEからXML編集環境設定FilePathGet( XML File Get FileNameはLibrary標準)
		} catch( Exception $e ) {
	  $ret=$e->getMessage();
	  }
	$XMLEDIT_ENV=array("xmlfile"=>"","Forbidden"=>'\r?\n',"xmlitem"=>"mpdconfig");			// XML編集環境設定をGet "xmlfile":編集XMLファイル,"Forbidden":禁止文字NULLに変換,複数は?で指定JS形式
	$ret=get_confxml($xmlcnf,"editenv",$XMLEDIT_ENV);

	$xmlary=get_xml_Array($xmlcnf);									// XML編集項目配列をGet
	$ary=array();
	if(isset($xmlary[$XMLEDIT_ENV["xmlitem"]])) {
		$ary=$xmlary[$XMLEDIT_ENV["xmlitem"]];
		}
	$XMLEDIT_ITEM=array();
	$XMLEDIT_ATTR=array();
	foreach((array)$ary as $key=> $subary) {			// XML <Link> String
		if ($key=="comment") {continue;}
		foreach($subary as $subkey=> $val) {
			if (($subkey=="@attributes")&&(is_array($val))) {		// Mpd_net : Attributes "lock"はTag指定と同等にする(3階層は見ないので判定する)
				foreach($val as $attr=> $v) {
				 	$XMLEDIT_ATTR[$key][$attr]=$v;
					}
				}
			else if (is_array($val)) {
				 $XMLEDIT_ITEM[$key][$subkey]=array();					// PHP7 配列宣言
				 foreach($val as $attr=> $v) {
					if (is_array($v)) {
						}
					if ($attr=="@attributes") {
					 	 $XMLEDIT_ATTR[$key][$subkey][$attr]=$v;
						 }
					else {
						 $XMLEDIT_ITEM[$key][$subkey][$attr]=$v;
						 }
					}
				 }
			else {
				 $XMLEDIT_ITEM[$key][$subkey]=$val;
				 }
		 	}
		}
//print "<BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR>";
//print '$XMLEDIT_ARG["FILE"]['.$XMLEDIT_ARG["FILE"]."]<BR>";
//print '$XMLEDIT_ENV :';print_r($XMLEDIT_ENV);print "<BR>";
//print '$XMLEDIT_ITEM :';print_r($XMLEDIT_ITEM);print "<BR>";
//print '$XMLEDIT_ATTR :';print_r($XMLEDIT_ATTR);print "<BR>";
	}

/* -----------------------------------------------------------------------------
	DispXMLSetting() ; Display XML Edit
----------------------------------------------------------------------------- */
function DispXMLEdit() {
	print '<title>XMLConf ('.$_SERVER["HTTP_HOST"].')</title>';		// Display XML Edit Table
	DispXMLEditHeader();									// Display Header Title
	DispXMLEditDetail();
	}

/* -----------------------------------------------------------------------------
	DispXMLEditDetail() ; Display XML Edit Detail
----------------------------------------------------------------------------- */
function DispXMLEditDetail() {
	global $XMLEDIT_ENV,$XMLEDIT_ITEM,$XMLEDIT_ATTR;	// $XMLEDIT_ENV:XML環境設定,$XMLEDIT_ITEM:XML環境設定(Item),$XMLEDIT_ATTR;XML環境設定(Section Attrinute)

	$xml_file = $XMLEDIT_ENV["xmlfile"];				// XML編集環境設定から編集XMLFilePath名をGet
	$ret="";$XMLARY =NULL;
	try {
		$XMLARY = get_loadxml($xml_file);				// XML File Get FileNameはLibrary標準
		} catch( Exception $e ) {
	  $ret=$e->getMessage();
	  }
	$xmlary=get_xml_Array($XMLARY);						// XML編集Array化 $XMLARY→$xmlary
// -------------------- Debug Howto ---------------------------------------------
// print_r($xmlary);
// print_r($xmlary["Mpd_net"]);
// $ary=$xmlary["Mpd_net"];								// テスト:確認方法1
// print '$xmlary["Mpd_net"]'.$ary["pass"]."<BR>";
// $aryitem=array("host"=>"");							// テスト:確認方法2
// $ret=get_confxml($XMLARY,"Mpd_net",$aryitem);
// print '$ret('.$ret.') [host]'.$aryitem["host"]."<BR>";
// -------------------- Detail Display -------------------------------------------
	print '<div id=grpXMLEdit class="center .chgfnt" style="position:absolute;top:48px;left:4px;width:448px;">';
	print '<table id="idTblXMLEdit" class="cfgtbl">';
	$i=0;$valary=array();				// id Counter , $valary:Table入力Area初期値配列
	foreach($XMLEDIT_ITEM as $section=> $itemary) {					// XML <Link> String
		$str=$section;
		if (isset($XMLEDIT_ATTR[$section]["name"])) { $str=$XMLEDIT_ATTR[$section]["name"]; }	// XML Sectionの変名 <{section} name={change}>
		$comment='&emsp;&emsp;&emsp;&emsp;&emsp;Input&nbsp;Value';
		if (isset($XMLEDIT_ATTR[$section]["comment"])) { $comment='&emsp;&emsp;'.$XMLEDIT_ATTR[$section]["comment"]; }	// XML Sectionの変名 <{section} name={change}>
		print '<tr class="cfgtr"><td class="cfgtd" style="width:114px;">'.$str.'</td><td class="cfgtd" style="text-align:left;">'.$comment.'</td></tr>';
		if(is_array($itemary)) {
			foreach($itemary as $item=> $itemset) {			// XML <Link> String
				$str="";$color='';
				if (!isset($xmlary[$section][$item])) {				// 設定$itemary[$XMLEDIT_ITEM]に対応する値($xmlary:編集XML)がない場合
				 	 $color='style="color:#0000ff;font-weight:500;"';
					 if(!is_array($itemset)) { $str=$itemset; }						// 初期値が設定されている(1) <{section}><{item}>{value}</{item}>
					 else if((isset($itemset["value"]))&&(!is_array($itemset["value"]))) { $str=$itemset["value"]; }	// 初期値が設定されている(2) <{section}><{item}><value>{value}</value></{item}>
					 }
				else if (is_array($xmlary[$section][$item])) {		//  設定$itemary[$XMLEDIT_ITEM]に対応する値($xmlary:編集XML)がない場合(Tagのみの場合Arrayとなる)
					 $str="";
					 }
				else {
					 $str=$xmlary[$section][$item];
					 }
				$attri='rows="1"';									// XML編集項目配列にAttributeが設定されている(Defult:1行)
				if (isset($itemset["attri"])) {
					 if(strpos($itemset["attri"],"rows") !== false)	// 形式(1):<{section}><{item}><attri>rows="{n}"{value}</attri></{item}>
						  $attri=$itemset["attri"];
					 else {
						  $attri=$attri." ".$itemset["attri"];		// 形式(1):<{section}><{item}><attri>{value}</attri></{item}>
						  }
					 }
				$i=$i+1;
				print '<tr><td class="cfgtd cfgtdtil" '.$color.'><div id="tag'.$i.'">'.$item.'</div></td>';
				print  '<td class="cfgtd cfgtdval">';
				$style="";
				if (isset($itemset["style"])) {						// XML編集項目配列にstyleが設定されている 形式(1):<{section}><{item}><style>{value}</style></{item}>
					 $style=$itemset["style"];
					 }
				$js="";
				if ($XMLEDIT_ENV["Forbidden"]!=="") {				// 禁止文字変換
					$js='var tmp=this.value;tmp=tmp.replace(/'.$XMLEDIT_ENV["Forbidden"].'/g,\'\');this.value=tmp;';		// $XMLEDIT_ENV["Forbidden"]:\r?\n:複数は?で指定JS正規表現形式
					}
				$js=$js.'document.getElementById(\'val'.$i.'\').innerText=this.value;if(this.value !==document.getElementById(\'in'.$i.'\').innerText) { this.style.backgroundColor = \'#7fffd4\'; } else { this.style.backgroundColor=\'\'; };';
				if ((isset($itemset["type"]))&&($itemset["type"]=="password")) {		// Password入力
					 print '<input type="password" '.$attri.' id="inp'.$i.'" cols="50" onChange="'.$js.'" style="border:0.4px groove #a9a9a9;width:100%;height:100%;resize:vertical;'.$style.'" />';	// resize:vertical/horizontal/none/both
					 }
				else if ((isset($itemset["type"]))&&($itemset["type"]=="combo")) {		// ComboBox入力
					 $optstr="";if(isset($itemset["option"])) { $optstr=$itemset["option"]; }
					 $opt=explode('|',$optstr);						// Select形式 : <{section}><{item}><option>{val}|{val}|{val}
					 print '<select '.$attri.' id="sel'.$i.'" onChange="'.$js.'" style="width:100%;height:108%;'.$style.'">';
					 foreach($opt as $op) {
						 if($op==$str) { $sel="selected"; } else { $sel=""; }
					 	 print '<option value="'.$op.'" '.$sel.'>'.$op.'</option>';
						 }
					 if (!in_array($str,$opt)) {										// 値がSelect設定に含まれないときは追加しておく
					 	 print '<option value="'.$str.'" selected>'.$str.'</option>';
						 }
					 print '</select>';
					 }
				else {
					 print '<textarea '.$attri.' id="txt'.$i.'" onChange="'.$js.'" cols="50" style="border:0.4px groove #a9a9a9;width:100%;height:100%;resize:vertical;'.$style.'">'.$str.'</textarea>';	// resize:vertical/horizontal/none/both
					 }
				$valary[$i]=$str;				// 初期値を配列に挿入
				if ((isset($itemset["comment"]))&&(!is_array($itemset["comment"]))) {	// Commentを表示
					if ((isset($itemset["type"]))&&(($itemset["type"]=="combo"))||((isset($itemset["type"]))&&($itemset["type"]=="password"))) { $css="font-size:10px;"; } else { $css="vertical-align:top;font-size:10px;line-height:17px;"; }
					 print '<span style="'.$css.'">';
					 print "&nbsp;".$itemset["comment"];
					 print '</span>';
					 }
				print '</td>';
				print '</tr>';
				}
			}
		}
	print '</table>';
	print '<div style="Position:relative;top:3px;left:0px;height:'.(40).'px;line-height:180%;">';
	print '<div style="Position:relative;top:3px;left:8px;width:470px;height:40px;line-height:180%;"><span style="color:#87cefa;">cf1.Item</span><span style="color:#1e90ff;">(B)</span><span style="color:#87cefa;">:Display unset initial value </span></div>';
	print '</div>';
	if($i > 0) {								// Tableの<text/input/select>取得できなかったので,onChangeでストックしておく
		$cnt=$i;
		print '<div style="position:fixed;bottom:0px;left:0px;width:0px;height:0;font-size:0px">';
		for($i=1;$i <= $cnt;$i++) {
			print '<div id="val'.$i.'" style="width:10px;display:none;">'.$valary[$i].'</div>';		// 入力ストック:入力ごとに入れ替え
			print '<div id="in'.$i.'" style="width:10px;display:none;">'.$valary[$i].'</div>';		// 初期ストック
			}
		$i=0;									// Sectionは変名しているのでOrignalを作成
		foreach($XMLEDIT_ITEM as $section => $itemary) {		// XML <Link> String
			print '<div id="sec'.$i.'" style="width:10px;display:none;">'.$section.'</div>';		// Section名
			$i=$i+1;
			}
		print '</div>';
		}
	print '</div>';
//print "<BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR><BR>".$XMLEDIT_ENV["xmlfile"];
	}

/* -----------------------------------------------------------------------------
	DispXMLEdit()Header() : Make Display XMLEdit Header Header
	 $xmlfile : i  : Edit XML File
----------------------------------------------------------------------------- */
function DispXMLEditHeader() {
	global $XMLEDIT_ENV;

	$xmlfile=$XMLEDIT_ENV["xmlfile"];
	if (function_exists("_ArgURLCount")) {
		 $myUrl=_ArgURLCount($_SERVER["REQUEST_URI"]);
		 }
	else {
		 $myUrl=$_SERVER["REQUEST_URI"];
		 }
	$edtsrv=$_SERVER["HTTP_HOST"];
	$tmp=trim(rtrim($_SERVER["HTTP_HOST"],"]"),"[");
	if (Commn_isIPv6($tmp)) {
		$ary=Commn_IPv6inf($tmp);
		$edtsrv=$ary["ifid"];
		}

	$ary=explode('/',$xmlfile);			// Mount Select Default
	$xml=$ary[((count($ary)-1))];
	$idFunc="idXMLEditHead";
	print '<div class=head style="position:fixed !important;position:absolute;top:24;width:480px;height:24px;font-size:11px;background-color:#000000;z-index:100;">';
	$color_self='background-color:#008000;color:#CED8F6;';			// 自身を示す色
	print '<button type=submit class=buttn onclick="if(typeof RequestLoadDisp == \'function\') { RequestLoadDisp(); }; location.href=\''.$myUrl.'\';" style="width:60;'.$color_self.'">Renew</button>';
	print '<div style="position:relative;top:-18px;left:65px;height:18px;line-height:150%;width:146px;background-color:#333333;color:#ffffff;font-size:12px;">&nbsp;&nbsp;'.$xml.'</div>';
	print '<div style="position:relative;top:-36px;left:215px;height:18px;line-height:150%;width:234px;background-color:#333333;color:#ffffff;font-size:12px;">&nbsp;&nbsp;Host:'.$edtsrv.'</div>';
	print '<button type=submit onclick="RequestBoxDisp(\''.$idFunc.'\');" class="comnd xmledtfnc" style="position:relative;top:-60px;left:454px;background-color:#008000;margin:2px 0px 0px 0px;">...</button>';
	print '</div>';
	DispXMLEditHeaderFunc($idFunc);
	}

/* -----------------------------------------------------------------------------
	DispXMLEditHeaderFunc($id)($id) : XMLEdit Header Function
	 $id    : i  : HTML-id
----------------------------------------------------------------------------- */
function DispXMLEditHeaderFunc($id) {
	global $XMLEDIT_ARG,$XMLEDIT_VERSION,$XMLEDIT_ENV;

	$top=20;$left=170;
	$func="on";
	$unload = 'RequestBoxtUnLoad(\''.$id.'\');';
	print '<div id='.$id.' class=box style="position:fixed;top:'.$top.'px;left:'.$left.';height:200px;">';
	print '<div class=boxtitle>XMLEdit Function</div>';
	print '<button type=submit onclick="GetXMLEditEvent(\''.$XMLEDIT_ARG["FILE"].'\',\''.$XMLEDIT_ENV["xmlfile"].'\');'.$unload.'" class="boxline boxblin1">XMLFile Save as...</button>';		// When , Make button
	print '<div class="boxtext" style="bottom:52px;font-size:9px;color:#98fb98;">'.$XMLEDIT_VERSION.'</div>';
	print '<div class="boxtext" style="bottom:38px;font-size:9px;">'.(apl_version()).'</div>';
	print '<div class="boxtext" style="bottom:24px;font-size:9px;">'.(lib_version()).'</div>';
	print '<div class="boxtext" style="bottom:-2px;font-size:9px;color:#ffffff;">'."(C)2020 by Mikio Shiratori".'</div>';
	print '<input type="button" value="Cancell" onclick="'.$unload.'" class="buttn boxbcan" />';
	print '</div>';
	}

/* -----------------------------------------------------------------------------
	DispState() : Disp Status Area
----------------------------------------------------------------------------- */
function DispXMLEditState() {
	print '<div id="IdState" class=botom style="left:2px;bottom:-1px;width:479px;font-size:11px;z-index:100">';	// RequestLoadDispよりz-indexを上げている
	print '<textarea cols="56" rows="1" readonly id="status" class=StatusL style="display:block;overflow:hidden;"></textarea>';				// Using Debug
	print '</div>';
	}

//----- Source End --------------------------------------------------------------
?>
