<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" >
<style type="text/css">
body {background-color: #ffffff; color: #000000;}
body, td, th, h1, h2 {font-family: sans-serif;}
pre {margin: 0px; font-family: monospace;}
a:link {color: #000099; text-decoration: none; background-color: #ffffff;}
a:hover {text-decoration: underline;}
table {border-collapse: collapse;}
.center {text-align: center;}
.center table { margin-left: auto; margin-right: auto; text-align: left;}
.center th { text-align: center !important; }
td, th { border: 1px solid #000000; font-size: 75%; vertical-align: baseline;}
h1 {font-size: 150%;}
h2 {font-size: 125%;}
.p {text-align: left;}
.e {background-color: #ccccff; font-weight: bold; color: #000000;}
.h {background-color: #9999cc; font-weight: bold; color: #000000;}
.v {background-color: #cccccc; color: #000000;}
.vr {background-color: #cccccc; text-align: right; color: #000000;}
img {float: right; border: 0px;}
hr {width: 600px; background-color: #cccccc; border: 0px; height: 1px; color: #000000;}
</style>
<?php
require_once("./mpdweb.lib.php");		// Mpd XML Library mpd{module}.lib.php
require_once("./mpdweb.lib_mpd.php");		// Mpd XML Library mpd{module}.lib.php
require_once("./mpdweb.lib_appli.php");		// Mpd XML Library mpd{module}.lib.php

$DEBUG= flase;	// flase 1:msg 2:logout
//$DEBUG= 1;  	// flase 1:msg 2:logout
ini_set('display_errors',1);						// エラー表示設定
$XML_CONF=get_loadconfig("setting/mpdconfig.xml");
//----- PHP Config Get ---------------------------------------------------------
get_libinit();
if (isset($PHP_CONFIG["php_looptime"])) {						// Special Setting : $LIB_CONF["LoopTimeout"]が設定されていたらループを打ち切る設定として使用 
	$LIB_CONF["LoopTimeout"]=$PHP_CONFIG["php_looptime"];		// XMLに設定していないので"php_looptime"を活用。現在:mpd_list_find()で使用。
	}
//----- mpd network  -----------------------------------------------------------
$Net = new Net_Common;
$tout=array("DispTimeout"=>0);						// Timeoutは局面で変える可能性かあるので共通化としていない
$no=get_config("Net_Timeout",$tout);
if ($no != 0) {
	$Net->timeout=$tout["DispTimeout"];						// Usind Disp Timeout
	}
get_config("Mpd_net",$Net->p_connect);				// Net_Common Property mpdconfig.xmlから設定
if (!$Net->connect()) {
	DispErrorBox($Net->p_error);
	exit;
	}
$MPD_VERSION=$Net->ver;
// commands
$arg=array();
$command="decoders";
$output=$Net->runCommand($command,$arg,1,1);
print '<div class="center">';
print '<table width="600">';
print '<tr class="h"><td>MPD Decoders</td><td>Suffix</td><td>Mime Type</td></tr>';
foreach($output["plugin"] as $key => $val) {
	print '<tr><td class="e">';
	print $val.'</td>';
	print '<td class="v">';
	if (isset($output["suffix"][$key])) {
		print $output["suffix"][$key];
		}
	print '</td><td class="v">';
	if (isset($output["mime_type"][$key])) {
		print $output["mime_type"][$key];
		}
	print '</td></tr>';
	}
print '</table>';
print '</div>';
print '<br>';

$arg=array();
$command="stats";
$output=$Net->runCommand($command,$arg,1,1);

print '<div class="center">';
print '<table width="600">';
print '<tr class="h"><td>Stats</td><td>Value</td></tr>';
$arraykey=array_keys($output);
foreach($arraykey as $val) {
	print '<tr><td class="e" width="200">'.$val.'</td>';
	print '<td class="v">'.$output[$val][0].'</td></tr>';
	}
print '</table>';
print '</div>';
print '<br>';

$arg=array();
$command="commands";
$output=$Net->runCommand($command,$arg,1,1);

print '<div class="center">';
print '<table width="600">';
print '<tr class="h"><td>No.</td><td>MPD Command</td></tr>';
foreach($output["command"] as $key => $val) {
	print '<tr><td class="e">';
	print $key.'</td>';
	print '<td class="v">'.$val.'</td></tr>';
	}
print '</table>';
print '</div>';
print '<br>';

//tblout($output);
//TblDump('',$output);
exit(); 
//----- Source End --------------------------------------------------------------
?>
